<?php
namespace Modules\ReportsModule\Http\Controllers;

use stdClass;
use App\User;
use App\Category;
use App\Product;
use Exception;
use Illuminate\Database\Query\JoinClause;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Resources\Json\PaginatedResourceResponse;
use Illuminate\Pagination\LengthAwarePaginator;
use Illuminate\Pagination\Paginator;
use Illuminate\Support\Arr;
use Illuminate\Support\Collection;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Modules\Connector\Http\Controllers\Api\ApiController;
use Modules\ReportsModule\Transformers\CollectionResource;
use Illuminate\Support\Str;


class BanquetReportApiController extends ApiController
{
    /**
     * Display a listing of the resource.
     * @return JsonResponse
     * @throws Exception
     */

    public function index()
    {
        /** @var User $user */
        $user = Auth::user();
        $business_id = $user->business_id;
        $permitted_locations = $user->permitted_locations($business_id);
        $filters = request()->only([
            'location_id', 'location_type', 'ratio_filter', 'fb', 'combo_details',
            'not_for_selling', 'is_inactive', 'search', 'managed_stock', 'per_page','page', 'category_id' , 'sub_category_id'
        ]);
        // Defines
        $products_data = [];
        // $security_products = [];
        // $digital_products = [];
        // $wedding_products = [];
        // $laser_products = [];
        // $dj_products = [];
        // $smoking_products = [];
        // $screens_products = [];
        // $sounds_products = [];
        // $lights_products = [];
        // $kosha_products = [];
        // $centerpiece_products = [];
        // $tables_products = [];
        // $stairs_cover_products = [];
        // $guest_book_products = [];
        // $chairs_cover_products = [];
        // $stage_products = [];
        // $dance_floor_products = [];
        // $kate_walk_products= [];
        // $high_table_products = [];
        // $chocolate_fountain_products = [];
        // $b_Light_products = [];
        // $celling_products = [];
        // $lounge_products = [];
        // $acrylic_chairs_products = [];
        // $acrylic_tables_products = [];
        // $totmat_products = [];
        // $tart_kosha_products = [];
        // $candlestick_products = [];
        // $spark_show_products = [];
        // $fire_show_products = [];
        // $bubbles_products = [];
        // $garden_package_products = [];
        // $led_screen_products = [];
        // $garden_coloring_products = [];
        // $chairs_products= [];
        // $accessories_products = [];
        // $trass_products = [];
        // $gold_chairs_products = [];
        // $entrance_products = [];
        
        $combo_categories_ids = 0;
        $combo_categories_ids_array = [];
        $combo_details = [];
        $buffet_food_and_beverage_array = [];
        $service_15_tax_id = 0;
        $service_25_tax_id = 0;
        $banquet_location_id = 0;
        $banquet_location_tax_value = 0;
        $banquet_location_type = 0;
        $food_categories_ids = 0;
        $food_categories_ids_array = [];
        $beverage_categories_ids = 0;
        $beverage_categories_ids_array = [];
        $parties_security_ids = 0;
        $parties_security_ids_array = [];
        $combo_variations = 0;
        $combo_variations_details = 0;
        $variation_product_details = 0;
        $parties_video_and_photos_ids = 0;
        $parties_video_and_photos_ids_array = [];
        $parties_wedding_ids = 0;
        $parties_wedding_ids_array = [];
        $parties_laser_ids = 0;
        $parties_laser_ids_array = [];
        $parties_dj_ids = 0;
        $parties_dj_ids_array = [];
        $parties_smoking_ids = 0;
        $parties_smoking_ids_array = [];
        $parties_screens_ids = 0;
        $parties_screens_ids_array = [];
        $parties_sounds_ids = 0;
        $parties_sounds_ids_array = [];
        $parties_lights_ids = 0;
        $parties_lights_ids_array = [];
        $parties_kosha_ids = 0;
        $parties_kosha_ids_array = [];
        $parties_centerpiece_ids = 0;
        $parties_centerpiece_ids_array = [];
        $parties_tables_ids = 0;
        $parties_tables_ids_array = [];
        $parties_stairs_cover_ids = 0;
        $parties_stairs_cover_ids_array = [];
        $parties_guest_book_ids = 0;
        $parties_guest_book_ids_array = [];
        $parties_chairs_cover_ids = 0;
        $parties_chairs_cover_ids_array = [];
        $parties_stage_ids = 0;
        $parties_stage_ids_array = [];
        $parties_dance_floor_ids = 0;
        $parties_dance_floor_ids_array = [];
        $parties_kate_walk_ids = 0;
        $parties_kate_walk_ids_array = [];
        $parties_high_table_ids = 0;
        $parties_high_table_ids_array = [];
        $parties_chocolate_fountain_ids = 0;
        $parties_chocolate_fountain_ids_array = [];
        $parties_b_Light_ids = 0;
        $parties_b_Light_ids_array = [];
        $parties_celling_ids = 0;
        $parties_celling_ids_array = [];
        $parties_lounge_ids = 0;
        $parties_lounge_ids_array = [];
        $parties_acrylic_chairs_ids = 0;
        $parties_acrylic_chairs_ids_array = [];
        $parties_acrylic_tables_ids = 0;
        $parties_acrylic_tables_ids_array = [];
        $parties_totmat_ids = 0;
        $parties_totmat_ids_array = [];
        $parties_tart_kosha_ids = 0;
        $parties_tart_kosha_ids_array = [];
        $parties_candlestick_ids = 0;
        $parties_candlestick_ids_array = [];
        $parties_spark_show_ids = 0;
        $parties_spark_show_ids_array = [];
        $parties_fire_show_ids = 0;
        $parties_fire_show_ids_array = [];
        $parties_bubbles_ids = 0;
        $parties_bubbles_ids_array = [];
        $parties_garden_package_ids = 0;
        $parties_garden_package_ids_array = [];
        $parties_led_screen_ids = 0;
        $parties_led_screen_ids_array = [];
        $parties_garden_coloring_ids = 0;
        $parties_garden_coloring_ids_array = [];
        $parties_chairs_ids = 0;
        $parties_chairs_ids_array = [];
        $parties_accessories_ids = 0;
        $parties_accessories_ids_array = [];
        $parties_trass_ids = 0;
        $parties_trass_ids_array = [];
        $parties_gold_chairs_ids = 0;
        $parties_gold_chairs_ids_array = [];
        $parties_entrance_ids = 0;
        $parties_entrance_ids_array = [];
        // $parties_lights_ids = 0;
        // $parties_lights_ids_array = [];
        // $parties_lights_ids = 0;
        // $parties_lights_ids_array = [];
        // $parties_lights_ids = 0;
        // $parties_lights_ids_array = [];
        // $parties_lights_ids = 0;
        // $parties_lights_ids_array = [];
        // $parties_lights_ids = 0;
        // $parties_lights_ids_array = [];
        // End Defines
        
        
        $banquet_halls = DB::table('banquet_halls')
                    ->get();
        
        $reports_module_setting = DB::table('reports_module')
                    ->get();
        // return($reports_module_setting->where('item' , '=' , 'food_categories_id'));
// return($reports_module_setting);


        foreach ($reports_module_setting as $report_module_setting)
        {
            if($report_module_setting->item == "banquet_location_tax_value")
                $banquet_location_tax_value = $report_module_setting->value;
                
            if($report_module_setting->item == "banquet_location_id")
                $banquet_location_id = $report_module_setting->value;
            
            if($report_module_setting->item == "banquet_location_type")
                $banquet_location_type = $report_module_setting->value;
                
            if($report_module_setting->item == "combo_categories_id")
                $combo_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "food_categories_id")
                $food_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "beverage_categories_id")
                $beverage_categories_ids = json_decode($report_module_setting->value);
            
            if($report_module_setting->item == "service_15_tax_id")
                $service_15_tax_id = $report_module_setting->value;
                
            if($report_module_setting->item == "service_25_tax_id")
                $service_25_tax_id = $report_module_setting->value;
                
            if($report_module_setting->item == "parties_security")
                $parties_security_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_video_and_photos")
                $parties_video_and_photos_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_wedding")
                $parties_wedding_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_laser")
                $parties_laser_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_dj")
                $parties_dj_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_smoking")
                $parties_smoking_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_screens")
                $parties_screens_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_sounds")
                $parties_sounds_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_lights")
                $parties_lights_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_kosha")
                $parties_kosha_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_centerpiece")
                $parties_centerpiece_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_tables")
                $parties_tables_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_stairs_cover")
                $parties_stairs_cover_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_guest_book")
                $parties_guest_book_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_chairs_cover")
                $parties_chairs_cover_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_stage")
                $parties_stage_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_dance_floor")
                $parties_dance_floor_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_kate_walk")
                $parties_kate_walk_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_high_table")
                $parties_high_table_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_chocolate_fountain")
                $parties_chocolate_fountain_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_b_Light")
                $parties_b_Light_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_celling")
                $parties_celling_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_lounge")
                $parties_lounge_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_acrylic_chairs")
                $parties_acrylic_chairs_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_acrylic_tables")
                $parties_acrylic_tables_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_totmat")
                $parties_totmat_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_tart_kosha")
                $parties_tart_kosha_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_candlestick")
                $parties_candlestick_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_spark_show")
                $parties_spark_show_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_fire_show")
                $parties_fire_show_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_bubbles")
                $parties_bubbles_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_garden_package")
                $parties_garden_package_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_led_screen")
                $parties_led_screen_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_garden_coloring")
                $parties_garden_coloring_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_chairs")
                $parties_chairs_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_accessories")
                $parties_accessories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_trass")
                $parties_trass_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "parties_gold_chairs")
                $parties_gold_chairs_ids = json_decode($report_module_setting->value);
                
                
            if($report_module_setting->item == "parties_entrance")
                $parties_entrance_ids = json_decode($report_module_setting->value);
                
        }
        
        
        foreach($combo_categories_ids as $combo_categories_id)
        {
            array_push($combo_categories_ids_array , $combo_categories_id->id);
        }

        foreach($food_categories_ids as $food_categories_id)
        {
            array_push($food_categories_ids_array , $food_categories_id->id);
            array_push($buffet_food_and_beverage_array , $food_categories_id->id);
        }
        
        foreach($beverage_categories_ids as $beverage_categories_id)
        {
            array_push($beverage_categories_ids_array , $beverage_categories_id->id);
            array_push($buffet_food_and_beverage_array , $beverage_categories_id->id);
        }
        
        foreach($parties_video_and_photos_ids as $parties_video_and_photos_id)
        {
            array_push($parties_video_and_photos_ids_array, $parties_video_and_photos_id->category_id);
        }
        
        foreach($parties_wedding_ids as $parties_wedding_id)
        {
            array_push($parties_wedding_ids_array, $parties_wedding_id->category_id);
        }
        
        foreach($parties_laser_ids as $parties_laser_id)
        {
            array_push($parties_laser_ids_array, $parties_laser_id->category_id);
        }

        foreach($parties_dj_ids as $parties_dj_id)
        {
            array_push($parties_dj_ids_array, $parties_dj_id->category_id);
        }
        
        foreach($parties_smoking_ids as $parties_smoking_id)
        {
            array_push($parties_smoking_ids_array, $parties_smoking_id->category_id);
        }
        
        foreach($parties_screens_ids as $parties_screens_id)
        {
            array_push($parties_screens_ids_array, $parties_screens_id->category_id);
        }
        
        foreach($parties_sounds_ids as $parties_sounds_id)
        {
            array_push($parties_sounds_ids_array, $parties_sounds_id->category_id);
        }
        
        foreach($parties_lights_ids as $parties_lights_id)
        {
            array_push($parties_lights_ids_array, $parties_lights_id->category_id);
        }
        
        foreach($parties_security_ids as $parties_security_id)
        {
            array_push($parties_security_ids_array, $parties_security_id->category_id);
        }
        
        foreach($parties_kosha_ids as $parties_kosha_id)
        {
            array_push($parties_kosha_ids_array, $parties_kosha_id->category_id);
        }
        
        foreach($parties_centerpiece_ids as $parties_centerpiece_id)
        {
            array_push($parties_centerpiece_ids_array, $parties_centerpiece_id->category_id);
        }
        
        foreach($parties_tables_ids as $parties_tables_id)
        {
            array_push($parties_tables_ids_array, $parties_tables_id->category_id);
        }
        
        foreach($parties_stairs_cover_ids as $parties_stairs_cover_id)
        {
            array_push($parties_stairs_cover_ids_array, $parties_stairs_cover_id->category_id);
        }
        
        foreach($parties_guest_book_ids as $parties_guest_book_id)
        {
            array_push($parties_guest_book_ids_array, $parties_guest_book_id->category_id);
        }
        
        foreach($parties_chairs_cover_ids as $parties_chairs_cover_id)
        {
            array_push($parties_chairs_cover_ids_array, $parties_chairs_cover_id->category_id);
        }
        
        foreach($parties_stage_ids as $parties_stage_id)
        {
            array_push($parties_stage_ids_array, $parties_stage_id->category_id);
        }
        
        foreach($parties_dance_floor_ids as $parties_dance_floor_id)
        {
            array_push($parties_dance_floor_ids_array, $parties_dance_floor_id->category_id);
        }
        
        foreach($parties_kate_walk_ids as $parties_kate_walk_id)
        {
            array_push($parties_kate_walk_ids_array, $parties_kate_walk_id->category_id);
        }
        
        foreach($parties_high_table_ids as $parties_high_table_id)
        {
            array_push($parties_high_table_ids_array, $parties_high_table_id->category_id);
        }
        
        foreach($parties_chocolate_fountain_ids as $parties_chocolate_fountain_id)
        {
            array_push($parties_chocolate_fountain_ids_array, $parties_chocolate_fountain_id->category_id);
        }
        
        foreach($parties_b_Light_ids as $parties_b_Light_id)
        {
            array_push($parties_b_Light_ids_array, $parties_b_Light_id->category_id);
        }
        
        foreach($parties_celling_ids as $parties_celling_id)
        {
            array_push($parties_celling_ids_array, $parties_celling_id->category_id);
        }
        
        foreach($parties_lounge_ids as $parties_lounge_id)
        {
            array_push($parties_lounge_ids_array, $parties_lounge_id->category_id);
        }
        
        foreach($parties_acrylic_chairs_ids as $parties_acrylic_chairs_id)
        {
            array_push($parties_acrylic_chairs_ids_array, $parties_acrylic_chairs_id->category_id);
        }
        
        foreach($parties_acrylic_tables_ids as $parties_acrylic_tables_id)
        {
            array_push($parties_acrylic_tables_ids_array, $parties_acrylic_tables_id->category_id);
        }
        
        foreach($parties_totmat_ids as $parties_totmat_id)
        {
            array_push($parties_totmat_ids_array, $parties_totmat_id->category_id);
        }
        
        foreach($parties_tart_kosha_ids as $parties_tart_kosha_id)
        {
            array_push($parties_tart_kosha_ids_array, $parties_tart_kosha_id->category_id);
        }
        
        foreach($parties_candlestick_ids as $parties_candlestick_id)
        {
            array_push($parties_candlestick_ids_array, $parties_candlestick_id->category_id);
        }
        
        foreach($parties_spark_show_ids as $parties_spark_show_id)
        {
            array_push($parties_spark_show_ids_array, $parties_spark_show_id->category_id);
        }
        
        foreach($parties_fire_show_ids as $parties_fire_show_id)
        {
            array_push($parties_fire_show_ids_array, $parties_fire_show_id->category_id);
        }
        
        foreach($parties_bubbles_ids as $parties_bubbles_id)
        {
            array_push($parties_bubbles_ids_array, $parties_bubbles_id->category_id);
        }
        
        foreach($parties_garden_package_ids as $parties_garden_package_id)
        {
            array_push($parties_garden_package_ids_array, $parties_garden_package_id->category_id);
        }
        
        foreach($parties_led_screen_ids as $parties_led_screen_id)
        {
            array_push($parties_led_screen_ids_array, $parties_led_screen_id->category_id);
        }
        
        foreach($parties_garden_coloring_ids as $parties_garden_coloring_id)
        {
            array_push($parties_garden_coloring_ids_array, $parties_garden_coloring_id->category_id);
        }
        
        foreach($parties_chairs_ids as $parties_chairs_id)
        {
            array_push($parties_chairs_ids_array, $parties_chairs_id->category_id);
        }
        
        foreach($parties_accessories_ids as $parties_accessories_id)
        {
            array_push($parties_accessories_ids_array, $parties_accessories_id->category_id);
        }
        
        foreach($parties_trass_ids as $parties_trass_id)
        {
            array_push($parties_trass_ids_array, $parties_trass_id->category_id);
        }
        
        foreach($parties_gold_chairs_ids as $parties_gold_chairs_id)
        {
            array_push($parties_gold_chairs_ids_array, $parties_gold_chairs_id->category_id);
        }
        
        foreach($parties_entrance_ids as $parties_entrance_id)
        {
            array_push($parties_entrance_ids_array, $parties_entrance_id->category_id);
        }
        
        // return($buffet_food_and_beverage_array);
        // $buffet_food_and_beverage = $food_categories_id.','.$beverage_categories_id;
        // $buffet_food_and_beverage_array = array_map('intval', explode(',', $buffet_food_and_beverage));

        // return($buffet_food_and_beverage);
        $filters['location_type'] = $banquet_location_type;
        $filters['not_for_selling'] = 0;
        $filters['is_inactive'] = 0 ;
        
        
        $products = DB::table('products as p')
                ->select(
                    DB::raw('p.id AS product_id'),
                    DB::raw('p.name AS product_name_ar'),
                    DB::raw('p.type AS product_type'),
                    DB::raw('p.category_id AS product_category_id'),
                    DB::raw('p.sub_category_id AS product_subCategory_id'),
                    DB::raw('IF(p.product_custom_field1 IS NULL or p.product_custom_field1 = "", p.name , p.product_custom_field1) as product_name_en'),
                    DB::raw('p.product_description AS product_description_ar'),
                    DB::raw('p.product_custom_field2 AS product_description_eng'),
                    DB::raw('p.image AS product_image'),
                    DB::raw('p.product_custom_field4 AS default_product'),
                    DB::raw('v.id AS variation_id'),
                    DB::raw('v.name AS variation_name'),
                    DB::raw('v.sub_sku AS sku'),
                    DB::raw('v.combo_variations AS combo_variations'),
                    // DB::raw('c1.name AS category_name'),
                    // DB::raw('c2.name AS sub_category_name'),
                    // DB::raw('v.default_purchase_price AS v_dpp'),
                    // DB::raw('v.dpp_inc_tax AS v_dpp_inc_tax'),
                    // DB::raw('v.default_sell_price as v_dsp'),
                    DB::raw('v.sell_price_inc_tax AS v_dsp_inc_tax')
                    // DB::raw('p.enable_stock AS product_enable_stock')
                )
                ->leftjoin('variations as v','v.product_id', '=', 'p.id')
                // ->leftjoin('categories as c1','p.category_id', '=', 'c1.id')
                // ->leftjoin('categories as c2','p.sub_category_id', '=', 'c2.id')
                ->leftjoin('product_locations as l','l.product_id', '=', 'p.id')
                ->leftjoin('business_locations as bl','bl.id', '=', 'l.location_id')
                ->where('p.business_id', $business_id)
                ->groupBy('v.id')
                ->orderBy('p.id', 'asc');



                // Filters
                if (!empty($filters['location_id']))
                    $products->whereIn('l.location_id', explode(',', $filters['location_id']));
                else if ($permitted_locations != 'all')
                    $products->whereIn('l.location_id', $permitted_locations);

                 if (!empty($filters['location_type']))
                 {
                     if($filters['location_type'] == 'null') {
                         $products->whereNull('bl.custom_field1');
                     } else {
                         $products->whereIn('bl.custom_field1', explode(',', $filters['location_type']));
                     }
                 }

                if (isset($filters['not_for_selling']) && in_array($filters['not_for_selling'], [0, 1]))
                    $products->where('p.not_for_selling', $filters['not_for_selling']);
                if (isset($filters['is_inactive']) && in_array($filters['is_inactive'], [0, 1]))
                    $products->where('p.is_inactive', $filters['is_inactive']);
                if (isset($filters['managed_stock']) && in_array($filters['managed_stock'], [0, 1]))
                    $products->where('p.enable_stock', $filters['managed_stock']);

                if (!empty($filters['category_id'])) {
                    $products->where('p.category_id', $filters['category_id']);
                }

                if (!empty($filters['sub_category_id'])) {
                    $products->where('p.sub_category_id', $filters['sub_category_id']);
                }
                
                if (isset($filters['fb']) && in_array($filters['is_inactive'], [0, 1])) {
                    if( $filters['fb'] == 1){
                        $products->whereIn('p.category_id', $buffet_food_and_beverage_array);
                        $products->orWhereIn('p.category_id', $combo_categories_ids_array);
                        // $products->whereIn('p.sub_category_id', $buffet_food_and_beverage_array);
                        $products_data['banquet_halls'] = $banquet_halls;
                        $products_data['banquet_tax'] = $banquet_location_tax_value;
                    }
                    else{
                        $products->whereNOTIn('p.category_id', $buffet_food_and_beverage_array);
                        $products->whereNOTIn('p.category_id', $combo_categories_ids_array);
                        // $products->whereNOTIn('p.sub_category_id', $buffet_food_and_beverage_array);
                    }
                }

                if (!empty($filters['search']))
                    $products->where(function ($products) use ($filters) {
                        $products
                            ->where('p.sku', 'like', "%{$filters['search']}%")
                            ->orWhere('p.name', 'like', "%{$filters['search']}%")
                            ->orWhere('p.product_custom_field1', 'like', "%{$filters['search']}%")
                            ->orWhere('v.name', 'like', "%{$filters['search']}%")
                            ->orWhere('v.sub_sku', 'like', "%{$filters['search']}%");
                    });
                // End Filters

                // Query Pagination

                $perPage = 10;
                $skip = 0;
                if(!empty($filters['per_page']))
                {
                    if (($filters['per_page']) != -1) 
                    {
                        $perPage = $filters['per_page'];
                        (isset($filters['page'])) ? $skip = (($filters['page'] -1 ) * $perPage) : $skip = 0;
                        $products->skip($skip)->take($perPage);
                    }
                    else
                    {
                         $products->get();
                    }
                }
                else
                {
                    $products->skip($skip)->take($perPage);
                }
        
                // End Query Pagination
                $products = $products->get();
// return($products);


        // $buffet_food_and_beverage_array = array_map('intval', explode(',', $buffet_food_and_beverage));
        // $products_filter['food_beverage'] = $products->whereIn('product_category_id' , $buffet_food_and_beverage_array)->whereIn('product_subCategory_id' , $buffet_food_and_beverage_array);

        $products_data['combo_products'] = $products->where('product_type' , '=' ,'combo')->whereIn('product_category_id', $combo_categories_ids_array)->values();
        $products_data['other_products'] = $products->where('product_type' , '!=' ,'combo')->whereIn('product_category_id', $buffet_food_and_beverage_array)->values();
        
        // Security Products
        $products_data['security products/الأمن'] = $products->filter(function ($product) use ($parties_security_ids_array) {
                return in_array($product->product_category_id, $parties_security_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_security_ids_array);
            })->values();
        // $products_data['security_products'] = $products->whereIn('product_category_id', $parties_security_ids_array)->values();
        // $products_data['security_products'] = $products->whereIn('product_subCategory_id', $parties_security_ids_array)->values();
        // End Security Products

        // Digital Products
        $products_data['digital_products/ديجيتال'] = $products->filter(function ($product) use ($parties_video_and_photos_ids_array) {
                return in_array($product->product_category_id, $parties_video_and_photos_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_video_and_photos_ids_array);
            })->values();
        // $products_data['digital_products'] = $products->whereIn('product_category_id', $parties_video_and_photos_ids_array)->values();
        // $products_data['digital_products'] = $products->whereIn('product_subCategory_id', $parties_video_and_photos_ids_array)->values();
        // End Digital Products
        
        // Wedding Products
        $products_data['wedding_products/الزفــــة'] = $products->filter(function ($product) use ($parties_wedding_ids_array) {
                return in_array($product->product_category_id, $parties_wedding_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_wedding_ids_array);
            })->values();
        // $products_data['wedding_products'] = $products->whereIn('product_category_id', $parties_wedding_ids_array)->values();
        // $products_data['wedding_products'] = $products->whereIn('product_subCategory_id', $parties_wedding_ids_array)->values();
        // End Wedding Products
        
        // Laser Products
        $products_data['laser_products/ليــزر'] = $products->filter(function ($product) use ($parties_laser_ids_array) {
                return in_array($product->product_category_id, $parties_laser_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_laser_ids_array);
            })->values();
        // $products_data['laser_products'] = $products->whereIn('product_category_id', $parties_laser_ids_array)->values();
        // $products_data['laser_products'] = $products->whereIn('product_subCategory_id', $parties_laser_ids_array)->values();
        // End Laser Products
        
        // Dj Products
        $products_data['dj_products/دي جي'] = $products->filter(function ($product) use ($parties_dj_ids_array) {
                return in_array($product->product_category_id, $parties_dj_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_dj_ids_array);
            })->values();
        // $products_data['dj_products'] = $products->whereIn('product_category_id', $parties_dj_ids_array)->values();
        // $products_data['dj_products'] = $products->whereIn('product_subCategory_id', $parties_dj_ids_array)->values();
        // End Dj Products
        
        // Smoking Products
        $products_data['smoking_products/دخـــان'] = $products->filter(function ($product) use ($parties_smoking_ids_array) {
                return in_array($product->product_category_id, $parties_smoking_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_smoking_ids_array);
            })->values();
        // $products_data['smoking_products'] = $products->whereIn('product_category_id', $parties_smoking_ids_array)->values();
        // $products_data['smoking_products'] = $products->whereIn('product_subCategory_id', $parties_smoking_ids_array)->values();
        // End Smoking Products
        
        // Screens Products
        $products_data['screens_products/شــاشـــات'] = $products->filter(function ($product) use ($parties_screens_ids_array) {
                return in_array($product->product_category_id, $parties_screens_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_screens_ids_array);
            })->values();
        // $products_data['screens_products'] = $products->whereIn('product_category_id', $parties_screens_ids_array)->values();
        // $products_data['screens_products'] = $products->whereIn('product_subCategory_id', $parties_screens_ids_array)->values();
        // End Screens Products
        
        // Sounds Products
        $products_data['sounds_products/صــوت'] = $products->filter(function ($product) use ($parties_sounds_ids_array) {
                return in_array($product->product_category_id, $parties_sounds_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_sounds_ids_array);
            })->values();
        // $products_data['sounds_products'] = $products->whereIn('product_category_id', $parties_sounds_ids_array)->values();
        // $products_data['sounds_products'] = $products->whereIn('product_subCategory_id', $parties_sounds_ids_array)->values();
        // End Sounds Products
        
        // Light Products
        $products_data['lights_products/إضاءة'] = $products->filter(function ($product) use ($parties_lights_ids_array) {
                return in_array($product->product_category_id, $parties_lights_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_lights_ids_array);
            })->values();
        // $products_data['lights_products'] = $products->whereIn('product_category_id', $parties_lights_ids_array)->values();
        // $products_data['lights_products'] = $products->whereIn('product_subCategory_id', $parties_lights_ids_array)->values();
        // End Light Products
        
        // Kosha Products
        $products_data['kosha_products/كـــوشة'] = $products->filter(function ($product) use ($parties_kosha_ids_array) {
                return in_array($product->product_category_id, $parties_kosha_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_kosha_ids_array);
            })->values();
        // $products_data['kosha_products'] = $products->whereIn('product_category_id', $parties_kosha_ids_array)->values();
        // $products_data['kosha_products'] = $products->whereIn('product_subCategory_id', $parties_kosha_ids_array)->values();
        // End Kosha Products
        
        // Centerpiece Products
        $products_data['centerpiece_products/سينتربيس'] = $products->filter(function ($product) use ($parties_centerpiece_ids_array) {
                return in_array($product->product_category_id, $parties_centerpiece_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_centerpiece_ids_array);
            })->values();
        // $products_data['centerpiece_products'] = $products->whereIn('product_category_id', $parties_centerpiece_ids_array)->values();
        // $products_data['centerpiece_products'] = $products->whereIn('product_subCategory_id', $parties_centerpiece_ids_array)->values();
        // End Centerpiece Products
        
        // Tables Products
        $products_data['tables_products/ترابيزات'] = $products->filter(function ($product) use ($parties_tables_ids_array) {
                return in_array($product->product_category_id, $parties_tables_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_tables_ids_array);
            })->values();
        // $products_data['tables_products'] = $products->whereIn('product_category_id', $parties_tables_ids_array)->values();
        // $products_data['tables_products'] = $products->whereIn('product_subCategory_id', $parties_tables_ids_array)->values();
        // End Tables Products
        
        // Stairs Cover Products
        $products_data['stairs_cover_products/تزين السلم'] = $products->filter(function ($product) use ($parties_stairs_cover_ids_array) {
                return in_array($product->product_category_id, $parties_stairs_cover_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_stairs_cover_ids_array);
            })->values();
        // $products_data['stairs_cover_products'] = $products->whereIn('product_category_id', $parties_stairs_cover_ids_array)->values();
        // $products_data['stairs_cover_products'] = $products->whereIn('product_subCategory_id', $parties_stairs_cover_ids_array)->values();
        // End Stairs Cover Products
        
        // Guest Book Products
        $products_data['guest_book_products/جيست بوك'] = $products->filter(function ($product) use ($parties_guest_book_ids_array) {
                return in_array($product->product_category_id, $parties_guest_book_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_guest_book_ids_array);
            })->values();
        // $products_data['guest_book_products'] = $products->whereIn('product_category_id', $parties_guest_book_ids_array)->values();
        // $products_data['guest_book_products'] = $products->whereIn('product_subCategory_id', $parties_guest_book_ids_array)->values();
        // End Guest Book Products
        
        // Chairs Cover Products
        $products_data['chairs_cover_products/كسوة الكراسي'] = $products->filter(function ($product) use ($parties_chairs_cover_ids_array) {
                return in_array($product->product_category_id, $parties_chairs_cover_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_chairs_cover_ids_array);
            })->values();
        // $products_data['chairs_cover_products'] = $products->whereIn('product_category_id', $parties_chairs_cover_ids_array)->values();
        // $products_data['chairs_cover_products'] = $products->whereIn('product_subCategory_id', $parties_chairs_cover_ids_array)->values();
        // End Chairs Cover Products
        
        // Stage Products
        $products_data['stage_products/الاستيدج'] = $products->filter(function ($product) use ($parties_stage_ids_array) {
                return in_array($product->product_category_id, $parties_stage_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_stage_ids_array);
            })->values();
        // $products_data['stage_products'] = $products->whereIn('product_category_id', $parties_stage_ids_array)->values();
        // $products_data['stage_products'] = $products->whereIn('product_subCategory_id', $parties_stage_ids_array)->values();
        // End Stage Products
        
        // Dance Floor Products
        $products_data['dance_floor_products/دانس فلور'] = $products->filter(function ($product) use ($parties_dance_floor_ids_array) {
                return in_array($product->product_category_id, $parties_dance_floor_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_dance_floor_ids_array);
            })->values();
        // $products_data['dance_floor_products'] = $products->whereIn('product_category_id', $parties_dance_floor_ids_array)->values();
        // $products_data['dance_floor_products'] = $products->whereIn('product_subCategory_id', $parties_dance_floor_ids_array)->values();
        // End Dance Floor Products
        
        // Kate Walk Products
        $products_data['kate_walk_products/كات ووك'] = $products->filter(function ($product) use ($parties_kate_walk_ids_array) {
                return in_array($product->product_category_id, $parties_kate_walk_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_kate_walk_ids_array);
            })->values();
        // $products_data['kate_walk_products'] = $products->whereIn('product_category_id', $parties_kate_walk_ids_array)->values();
        // $products_data['kate_walk_products'] = $products->whereIn('product_subCategory_id', $parties_kate_walk_ids_array)->values();
        // End Kate Walk Products
        
        // High Table Products
        $products_data['high_table_products/هاي تابول'] = $products->filter(function ($product) use ($parties_high_table_ids_array) {
                return in_array($product->product_category_id, $parties_high_table_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_high_table_ids_array);
            })->values();
        // $products_data['high_table_products'] = $products->whereIn('product_category_id', $parties_high_table_ids_array)->values();
        // $products_data['high_table_products'] = $products->whereIn('product_subCategory_id', $parties_high_table_ids_array)->values();
        // End High Table Products
        
        // Chocolate Fountain Products
        $products_data['chocolate_fountain_products/نافورة شيكولاته'] = $products->filter(function ($product) use ($parties_chocolate_fountain_ids_array) {
                return in_array($product->product_category_id, $parties_chocolate_fountain_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_chocolate_fountain_ids_array);
            })->values();
        // $products_data['chocolate_fountain_products'] = $products->whereIn('product_category_id', $parties_chocolate_fountain_ids_array)->values();
        // $products_data['chocolate_fountain_products'] = $products->whereIn('product_subCategory_id', $parties_chocolate_fountain_ids_array)->values();
        // End Chocolate Fountain Products
        
        // B Light Products
        $products_data['b_Light_products/بي لايت'] = $products->filter(function ($product) use ($parties_b_Light_ids_array) {
                return in_array($product->product_category_id, $parties_b_Light_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_b_Light_ids_array);
            })->values();
        // $products_data['b_Light_products'] = $products->whereIn('product_category_id', $parties_b_Light_ids_array)->values();
        // $products_data['b_Light_products'] = $products->whereIn('product_subCategory_id', $parties_b_Light_ids_array)->values();
        // End B Light Products
        
        // Celling Products
        $products_data['celling_products/سيلينج'] = $products->filter(function ($product) use ($parties_celling_ids_array) {
                return in_array($product->product_category_id, $parties_celling_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_celling_ids_array);
            })->values();
        // $products_data['celling_products'] = $products->whereIn('product_category_id', $parties_celling_ids_array)->values();
        // $products_data['celling_products'] = $products->whereIn('product_subCategory_id', $parties_celling_ids_array)->values();
        // End Celling Products
        
        // Lounge Products
        $products_data['lounge_products/لاونج'] = $products->filter(function ($product) use ($parties_lounge_ids_array) {
                return in_array($product->product_category_id, $parties_lounge_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_lounge_ids_array);
            })->values();
        // $products_data['lounge_products'] = $products->whereIn('product_category_id', $parties_lounge_ids_array)->values();
        // $products_data['lounge_products'] = $products->whereIn('product_subCategory_id', $parties_lounge_ids_array)->values();
        // End Lounge Products
        
        // Acrylic Chairs Products
        $products_data['acrylic_chairs_products/كراسي اكليرك'] = $products->filter(function ($product) use ($parties_acrylic_chairs_ids_array) {
                return in_array($product->product_category_id, $parties_acrylic_chairs_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_acrylic_chairs_ids_array);
            })->values();
        // $products_data['acrylic_chairs_products'] = $products->whereIn('product_category_id', $parties_acrylic_chairs_ids_array)->values();
        // $products_data['acrylic_chairs_products'] = $products->whereIn('product_subCategory_id', $parties_acrylic_chairs_ids_array)->values();
        // End Acrylic Chairs Products
        
        // Crylic Tables Products
        $products_data['acrylic_tables_products/ترابيزات اكليرك'] = $products->filter(function ($product) use ($parties_acrylic_tables_ids_array) {
                return in_array($product->product_category_id, $parties_acrylic_tables_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_acrylic_tables_ids_array);
            })->values();
        // $products_data['acrylic_tables_products'] = $products->whereIn('product_category_id', $parties_acrylic_tables_ids_array)->values();
        // $products_data['acrylic_tables_products'] = $products->whereIn('product_subCategory_id', $parties_acrylic_tables_ids_array)->values();
        // End Crylic Tables Products
        
        // Totmat Products
        $products_data['totmat_products/تومات'] = $products->filter(function ($product) use ($parties_totmat_ids_array) {
                return in_array($product->product_category_id, $parties_totmat_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_totmat_ids_array);
            })->values();
        // $products_data['totmat_products'] = $products->whereIn('product_category_id', $parties_totmat_ids_array)->values();
        // $products_data['totmat_products'] = $products->whereIn('product_subCategory_id', $parties_totmat_ids_array)->values();
        // End Totmat Products
        
        // Tart Kosha Products
        $products_data['tart_kosha_products/كوشة التورته'] = $products->filter(function ($product) use ($parties_tart_kosha_ids_array) {
                return in_array($product->product_category_id, $parties_tart_kosha_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_tart_kosha_ids_array);
            })->values();
        // $products_data['tart_kosha_products'] = $products->whereIn('product_category_id', $parties_tart_kosha_ids_array)->values();
        // $products_data['tart_kosha_products'] = $products->whereIn('product_subCategory_id', $parties_tart_kosha_ids_array)->values();
        // End Tart Kosha Products
        
        // Candlestick Products
        $products_data['candlestick_products/شمعدان'] = $products->filter(function ($product) use ($parties_candlestick_ids_array) {
                return in_array($product->product_category_id, $parties_candlestick_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_candlestick_ids_array);
            })->values();
        // $products_data['candlestick_products'] = $products->whereIn('product_category_id', $parties_candlestick_ids_array)->values();
        // $products_data['candlestick_products'] = $products->whereIn('product_subCategory_id', $parties_candlestick_ids_array)->values();
        // End Candlestick Products
        
        // Spark Show Products
        $products_data['spark_show_products/عرض شرارة'] = $products->filter(function ($product) use ($parties_spark_show_ids_array) {
                return in_array($product->product_category_id, $parties_spark_show_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_spark_show_ids_array);
            })->values();
        // $products_data['spark_show_products'] = $products->whereIn('product_category_id', $parties_spark_show_ids_array)->values();
        // $products_data['spark_show_products'] = $products->whereIn('product_subCategory_id', $parties_spark_show_ids_array)->values();
        // End Spark Show Products
        
        // Fire Show Products
        $products_data['fire_show_products/عرض النار'] = $products->filter(function ($product) use ($parties_fire_show_ids_array) {
                return in_array($product->product_category_id, $parties_fire_show_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_fire_show_ids_array);
            })->values();
        // $products_data['fire_show_products'] = $products->whereIn('product_category_id', $parties_fire_show_ids_array)->values();
        // $products_data['fire_show_products'] = $products->whereIn('product_subCategory_id', $parties_fire_show_ids_array)->values();
        // End Fire Show Products
        
        // Bubbles Products
        $products_data['bubbles_products/منتجات الفقاعات'] = $products->filter(function ($product) use ($parties_bubbles_ids_array) {
                return in_array($product->product_category_id, $parties_bubbles_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_bubbles_ids_array);
            })->values();
        // $products_data['bubbles_products'] = $products->whereIn('product_category_id', $parties_bubbles_ids_array)->values();
        // $products_data['bubbles_products'] = $products->whereIn('product_subCategory_id', $parties_bubbles_ids_array)->values();
        // End Bubbles Products
        
        // Garden Package Products
        $products_data['garden_package_products/منتجات حزمة الحديقة'] = $products->filter(function ($product) use ($parties_garden_package_ids_array) {
                return in_array($product->product_category_id, $parties_garden_package_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_garden_package_ids_array);
            })->values();
        // $products_data['garden_package_products'] = $products->whereIn('product_category_id', $parties_garden_package_ids_array)->values();
        // $products_data['garden_package_products'] = $products->whereIn('product_subCategory_id', $parties_garden_package_ids_array)->values();
        // End Garden Package Products
        
        // Led Screen Products
        $products_data['led_screen_products/ليد سكرين'] = $products->filter(function ($product) use ($parties_led_screen_ids_array) {
                return in_array($product->product_category_id, $parties_led_screen_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_led_screen_ids_array);
            })->values();
        // $products_data['led_screen_products'] = $products->whereIn('product_category_id', $parties_led_screen_ids_array)->values();
        // $products_data['led_screen_products'] = $products->whereIn('product_subCategory_id', $parties_led_screen_ids_array)->values();
        // End Led Screen Products
        
        // Garden Coloring Products
        $products_data['garden_coloring_products/منتجات تلوين الحديقة'] = $products->filter(function ($product) use ($parties_garden_coloring_ids_array) {
                return in_array($product->product_category_id, $parties_garden_coloring_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_garden_coloring_ids_array);
            })->values();
        // $products_data['garden_coloring_products'] = $products->whereIn('product_category_id', $parties_garden_coloring_ids_array)->values();
        // $products_data['garden_coloring_products'] = $products->whereIn('product_subCategory_id', $parties_garden_coloring_ids_array)->values();
        // End Garden Coloring Products
        
        // Chairs Products
        $products_data['chairs_products/الكراسي'] = $products->filter(function ($product) use ($parties_chairs_ids_array) {
                return in_array($product->product_category_id, $parties_chairs_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_chairs_ids_array);
            })->values();
        // $products_data['chairs_products'] = $products->whereIn('product_category_id', $parties_chairs_ids_array)->values();
        // $products_data['chairs_products'] = $products->whereIn('product_subCategory_id', $parties_chairs_ids_array)->values();
        // End Chairs Products
        
        // Accessories Products
        $products_data['accessories_products/اكسسوارات'] = $products->filter(function ($product) use ($parties_accessories_ids_array) {
                return in_array($product->product_category_id, $parties_accessories_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_accessories_ids_array);
            })->values();
        // $products_data['accessories_products'] = $products->whereIn('product_category_id', $parties_accessories_ids_array)->values();
        // $products_data['accessories_products'] = $products->whereIn('product_subCategory_id', $parties_accessories_ids_array)->values();
        // End Accessories Products
        
        // Trass Products
        $products_data['trass_products/تراس'] = $products->filter(function ($product) use ($parties_trass_ids_array) {
                return in_array($product->product_category_id, $parties_trass_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_trass_ids_array);
            })->values();
        // $products_data['trass_products'] = $products->whereIn('product_category_id', $parties_trass_ids_array)->values();
        // $products_data['trass_products'] = $products->whereIn('product_subCategory_id', $parties_trass_ids_array)->values();
        // End Trass Products
        
        // Gold Chairs Products
        $products_data['gold_chairs_products/كراسي ذهبي'] = $products->filter(function ($product) use ($parties_gold_chairs_ids_array) {
                return in_array($product->product_category_id, $parties_gold_chairs_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_gold_chairs_ids_array);
            })->values();
        // $products_data['gold_chairs_products'] = $products->whereIn('product_category_id', $parties_gold_chairs_ids_array)->values();
        // $products_data['gold_chairs_products'] = $products->whereIn('product_subCategory_id', $parties_gold_chairs_ids_array)->values();
        // End Gold Chairs Products
        
        // Entrance Products
        $products_data['entrance_products/المدخل'] = $products->filter(function ($product) use ($parties_entrance_ids_array) {
                return in_array($product->product_category_id, $parties_entrance_ids_array) ||
                    in_array($product->product_subCategory_id, $parties_entrance_ids_array);
            })->values();
        // $products_data['entrance_products'] = $products->whereIn('product_category_id', $parties_entrance_ids_array)->values();
        // $products_data['entrance_products'] = $products->whereIn('product_subCategory_id', $parties_entrance_ids_array)->values();
        // End Entrance Products
        
        // $products_data['lights_products'] = $products->whereIn('product_category_id', $parties_lights_ids_array)->values();
        // $products_data['lights_products'] = $products->whereIn('product_category_id', $parties_lights_ids_array)->values();
        
        
        
        // $products_data['lights_products'] = $products->whereIn('product_category_id', $parties_lights_ids_array)->OrWhereIn('product_subCategory_id', $parties_lights_ids_array)->values();
        // $products_data['lights_products'] = $products->whereIn(['product_category_id' , 'product_subCategory_id'], $parties_lights_ids_array)->values();
        // $products_data['lights_products'] = $products->Where(function ($query) {
        //         $query->whereIn('product_category_id', $parties_lights_ids_array)
        //               ->OrWhereIn('product_subCategory_id', $parties_lights_ids_array);
        //     });

// return($products_data['combo_products']);

        if (!empty($filters['combo_details'])) {
            
            // $filtered = $products->filter(function ($product) use ($parties_lights_ids_array) {
            //     return in_array($product->product_category_id, $parties_lights_ids_array) ||
            //         in_array($product->product_subCategory_id, $parties_lights_ids_array);
            // });
            
            // return($filtered);
            
            // return(gettype(json_decode($products_data['lights_products'])));
            // $aa = json_decode($products_data['lights_products']);
            // $bb = $products->whereIn('product_subCategory_id', $parties_lights_ids_array)->values();
            // foreach( $bb as $b )
            // {
            //     array_push($aa , $b);
            // }
            // return($aa);
            
            // return($products_data['lights_products']);
            // $products_data['lights_products'] = $products->whereIn('product_subCategory_id', $parties_lights_ids_array)->values();
            
            $combo_variations = $products->where('product_id', $filters['combo_details'])->values();
            $combo_variations_details = json_decode($combo_variations);
// return($combo_variations_details);
            foreach($combo_variations_details as $combo_variations_detail)
            {
                $combo_variation = json_decode($combo_variations_detail->combo_variations);
                // return($combo_variation);
                foreach($combo_variation as $variation_product)
                {
                    // return($products_data['other_products']);
                    // return($variation_product->variation_id);
                    $variation_product_details = $products_data['other_products']->where('variation_id' , $variation_product->variation_id);
                    $variation_product_details = $variation_product_details->values();
                    if(!$variation_product_details->isEmpty())
                    foreach($variation_product_details as $variation_product_detail)
                    {
                        // return($variation_product_details);
                            array_push($combo_details, (object)[
                              'product_id' => $variation_product_detail->product_id,
                              'product_name_ar' => $variation_product_detail->product_name_ar,
                              'product_name_en' => $variation_product_detail->product_name_en,
                              'product_type' => $variation_product_detail->product_type,
                              'product_category_id' => $variation_product_detail->product_category_id,
                              'product_subCategory_id' => $variation_product_detail->product_subCategory_id,
                              'product_description_ar' => $variation_product_detail->product_description_ar,
                              'product_description_eng' => $variation_product_detail->product_description_eng,
                              'product_image' => $variation_product_detail->product_image,
                              'variation_id' => $variation_product_detail->variation_id,
                              'variation_name' => $variation_product_detail->variation_name,
                              'sku' => $variation_product_detail->sku,
                              'combo_variations' => $variation_product_detail->combo_variations,
                              'v_dsp_inc_tax' => $variation_product_detail->v_dsp_inc_tax,
                              'quantity' => $variation_product->quantity,
                            ]);
                    }
                }
            }
            return($combo_details);
        }
                    
        
        
        // return(gettype(json_decode($combo_variations)));
        return($products_data);
 
        $products_data = collect($products_data);

        $perPage = count($products_data);
        $sells = $this->paginate($products_data, $perPage);
        $sells->appends(Arr::except($filters, ['page']));

        $response = ((new PaginatedResourceResponse(CollectionResource::make($sells)))->toResponse(request()));
        $data = $response->getData();
        $response->setData($data);
        return $response;

    }

    /**
     * Create a new command instance.
     *
     * @return string
     */
    public function queryToSql($products)
    {
        return vsprintf(str_replace(array('?'), array('\'%s\''), $products->toSql()), $products->getBindings());
    }

    /**
     * The attributes that are mass assignable.
     *
     *
     * @param $items
     * @param int $perPage
     * @param null $page
     * @param array $options
     * @return LengthAwarePaginator
     */
    public function paginate($items, $perPage = 5, $page = null, $options = [])
    {
        $page = $page ?: (Paginator::resolveCurrentPage() ?: 1);
        $items = $items instanceof Collection ? $items : Collection::make($items);
        return new LengthAwarePaginator($items->forPage($page, $perPage), $items->count(), $perPage, $page, $options);
    }
}
