<?php

namespace Modules\ReportsModule\Http\Controllers;

use stdClass;
use App\User;
use App\Category;
use App\Product;
use Exception;
use Illuminate\Database\Query\JoinClause;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Resources\Json\PaginatedResourceResponse;
use Illuminate\Pagination\LengthAwarePaginator;
use Illuminate\Pagination\Paginator;
use Illuminate\Support\Arr;
use Illuminate\Support\Collection;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Modules\Connector\Http\Controllers\Api\ApiController;
use Modules\ReportsModule\Transformers\CollectionResource;
use Illuminate\Support\Str;

class FinanceCalculationsGroupedCostReportApiController extends ApiController
{
    /**
     * Display a listing of the resource.
     * @return JsonResponse
     * @throws Exception
     */
    public function index()
    {

        $reports_module_setting = DB::table('reports_module')
            ->get();
        // return($reports_module_setting);

        $service_15_tax_id = 0;
        $service_25_tax_id = 0;
        $banquet_location_ids = 0;
        $banquet_location_ids_array = [];
        $main_warehouse_location_ids = 0;
        $main_warehouse_location_ids_array = [];
        $general_warehouse_location_ids = 0;
        $general_warehouse_location_ids_array = [];
        $FB_prefix = 0;
        // $FB_prefixs_array = [];
        $hotel_room_customer_group_ids = 0;
        $hotel_room_customer_group_ids_array = [];
        $officer_customer_group_ids = 0;
        $officer_customer_group_ids_array = [];
        $companies_customer_group_ids = 0;
        $companies_customer_group_ids_array = [];
        $general_hospitality_customer_group_ids = 0;
        $general_hospitality_customer_group_ids_array = [];
        $hospitality_customer_group_ids = 0;
        $hospitality_customer_group_ids_array = [];
        $hotel_hospitality_customer_group_ids = 0;
        $hotel_hospitality_customer_group_ids_array = [];
        $banquet_hospitality_customer_group_ids = 0;
        $banquet_hospitality_customer_group_ids_array = [];
        $PrePaid_customer_group_ids = 0;
        $PrePaid_customer_group_ids_array = [];
        $combo_categories_ids = 0;
        $combo_categories_ids_array = [];
        $food_categories_ids = 0;
        $food_categories_ids_array = [];
        $beverage_categories_ids = 0;
        $beverage_categories_ids_array = [];
        $food_and_beverage_categories_ids_array = [];
        // $broken_categories_ids = 0;
        // $broken_categories_ids_array = [];
        // $shisha_categories_ids = 0;
        // $shisha_categories_ids_array = [];
        // $other_categories_ids = 0;
        // $other_categories_ids_array = [];
        // $market_categories_ids = 0;
        // $market_categories_ids_array = [];
        // $activities_categories_ids = 0;
        // $activities_categories_ids_array = [];
        // $security_categories_ids = 0;
        // $security_categories_ids_array = [];
        // $laundry_categories_ids = 0;
        // $laundry_categories_ids_array = [];
        // $hairdresser_categories_ids = 0;
        // $hairdresser_categories_ids_array = [];
        // $animals_categories_ids = 0;    //Administration Department
        // $animals_categories_ids_array = [];    //Administration Department
        // $employees_purchase_from_warehouse_customer_group_ids = 0;    //Employees Purchase from General or Main Warehouses
        // $employees_purchase_from_warehouse_customer_group_ids_array = [];    //Employees Purchase from General or Main Warehouses


        foreach ($reports_module_setting as $report_module_setting) {
            if ($report_module_setting->item == "service_15_tax_id")
                $service_15_tax_id = $report_module_setting->value;

            if ($report_module_setting->item == "service_25_tax_id")
                $service_25_tax_id = $report_module_setting->value;

            if ($report_module_setting->item == "general_warehouse_location_id")
                $general_warehouse_location_ids = json_decode($report_module_setting->value);

            if ($report_module_setting->item == "main_warehouse_location_id")
                $main_warehouse_location_ids = json_decode($report_module_setting->value);

            if ($report_module_setting->item == "banquet_location_id")
                $banquet_location_ids = json_decode($report_module_setting->value);

            if ($report_module_setting->item == "FB prefix")
                $FB_prefix = $report_module_setting->value;

            if ($report_module_setting->item == "hotel_room_customer_group_id")
                $hotel_room_customer_group_ids = json_decode($report_module_setting->value);

            if ($report_module_setting->item == "officer_customer_group_id")
                $officer_customer_group_ids = json_decode($report_module_setting->value);

            if ($report_module_setting->item == "companies_customer_group_id")
                $companies_customer_group_ids = json_decode($report_module_setting->value);

            if ($report_module_setting->item == "general_hospitality_customer_group_id")
                $general_hospitality_customer_group_ids = json_decode($report_module_setting->value);

            if ($report_module_setting->item == "hospitality_customer_group_id")
                $hospitality_customer_group_ids = json_decode($report_module_setting->value);

            if ($report_module_setting->item == "hotel_hospitality_customer_group_id")
                $hotel_hospitality_customer_group_ids = json_decode($report_module_setting->value);

            if ($report_module_setting->item == "banquet_hospitality_customer_group_id")
                $banquet_hospitality_customer_group_ids = json_decode($report_module_setting->value);

            if ($report_module_setting->item == "PrePaid_customer_group_id")
                $PrePaid_customer_group_ids = json_decode($report_module_setting->value);
            
            if($report_module_setting->item == "combo_categories_id")
                $combo_categories_ids = json_decode($report_module_setting->value);
                
            if ($report_module_setting->item == "food_categories_id")
                $food_categories_ids = json_decode($report_module_setting->value);

            if ($report_module_setting->item == "beverage_categories_id")
                $beverage_categories_ids = json_decode($report_module_setting->value);

            // if ($report_module_setting->item == "broken_categories_id")
            //     $broken_categories_ids = json_decode($report_module_setting->value);

            // if ($report_module_setting->item == "shisha_categories_id")
            //     $shisha_categories_ids = json_decode($report_module_setting->value);

            // if ($report_module_setting->item == "other_categories_id")
            //     $other_categories_ids = json_decode($report_module_setting->value);

            // if ($report_module_setting->item == "market_categories_id")
            //     $market_categories_ids = json_decode($report_module_setting->value);

            // if ($report_module_setting->item == "activities_categories_id")
            //     $activities_categories_ids = json_decode($report_module_setting->value);

            // if ($report_module_setting->item == "security_categories_id")
            //     $security_categories_ids = json_decode($report_module_setting->value);

            // if ($report_module_setting->item == "laundry_categories_id")
            //     $laundry_categories_ids = json_decode($report_module_setting->value);

            // if ($report_module_setting->item == "hairdresser_categories_id")
            //     $hairdresser_categories_ids = json_decode($report_module_setting->value);

            // if ($report_module_setting->item == "animals_categories_id")
            //     $animals_categories_ids = json_decode($report_module_setting->value);

            // if ($report_module_setting->item == "employees_purchase_from_warehouse_customer_group_id")
            //     $employees_purchase_from_warehouse_customer_group_ids = json_decode($report_module_setting->value);
        }

        foreach ($banquet_location_ids as $banquet_location_id) {
            array_push($banquet_location_ids_array, $banquet_location_id->id);
        }

        foreach ($main_warehouse_location_ids as $main_warehouse_location_id) {
            array_push($main_warehouse_location_ids_array, $main_warehouse_location_id->id);
        }

        foreach ($general_warehouse_location_ids as $general_warehouse_location_id) {
            array_push($general_warehouse_location_ids_array, $general_warehouse_location_id->id);
        }

        foreach ($hotel_room_customer_group_ids as $hotel_room_customer_group_id) {
            array_push($hotel_room_customer_group_ids_array, $hotel_room_customer_group_id->id);
        }

        foreach ($officer_customer_group_ids as $officer_customer_group_id) {
            array_push($officer_customer_group_ids_array, $officer_customer_group_id->id);
        }

        foreach ($companies_customer_group_ids as $companies_customer_group_id) {
            array_push($companies_customer_group_ids_array, $companies_customer_group_id->id);
        }

        foreach ($general_hospitality_customer_group_ids as $general_hospitality_customer_group_id) {
            array_push($general_hospitality_customer_group_ids_array, $general_hospitality_customer_group_id->id);
        }

        foreach ($hospitality_customer_group_ids as $hospitality_customer_group_id) {
            array_push($hospitality_customer_group_ids_array, $hospitality_customer_group_id->id);
        }

        foreach ($hotel_hospitality_customer_group_ids as $hotel_hospitality_customer_group_id) {
            array_push($hotel_hospitality_customer_group_ids_array, $hotel_hospitality_customer_group_id->id);
        }

        foreach ($banquet_hospitality_customer_group_ids as $banquet_hospitality_customer_group_id) {
            array_push($banquet_hospitality_customer_group_ids_array, $banquet_hospitality_customer_group_id->id);
        }

        foreach ($PrePaid_customer_group_ids as $PrePaid_customer_group_id) {
            array_push($PrePaid_customer_group_ids_array, $PrePaid_customer_group_id->id);
        }
        
        foreach($combo_categories_ids as $combo_categories_id)
        {
            array_push($combo_categories_ids_array , $combo_categories_id->id);
        }
        
        foreach ($food_categories_ids as $food_categories_id) {
            // array_push($food_categories_ids_array, $food_categories_id->id);
            array_push($food_and_beverage_categories_ids_array, $food_categories_id->id);
        }

        foreach ($beverage_categories_ids as $beverage_categories_id) {
            // array_push($beverage_categories_ids_array, $beverage_categories_id->id);
            array_push($food_and_beverage_categories_ids_array, $beverage_categories_id->id);
        }

        // foreach ($broken_categories_ids as $broken_categories_id) {
        //     array_push($broken_categories_ids_array, $broken_categories_id->id);
        // }

        // foreach ($shisha_categories_ids as $shisha_categories_id) {
        //     array_push($shisha_categories_ids_array, $shisha_categories_id->id);
        // }

        // foreach ($other_categories_ids as $other_categories_id) {
        //     array_push($other_categories_ids_array, $other_categories_id->id);
        // }

        // foreach ($market_categories_ids as $market_categories_id) {
        //     array_push($market_categories_ids_array, $market_categories_id->id);
        // }

        // foreach ($activities_categories_ids as $activities_categories_ids) {
        //     array_push($activities_categories_ids_array, $activities_categories_ids->id);
        // }

        // foreach ($security_categories_ids as $security_categories_id) {
        //     array_push($security_categories_ids_array, $security_categories_id->id);
        // }

        // foreach ($laundry_categories_ids as $laundry_categories_id) {
        //     array_push($laundry_categories_ids_array, $laundry_categories_id->id);
        // }

        // foreach ($hairdresser_categories_ids as $hairdresser_categories_id) {
        //     array_push($hairdresser_categories_ids_array, $hairdresser_categories_id->id);
        // }

        // foreach ($animals_categories_ids as $animals_categories_id) {
        //     array_push($animals_categories_ids_array, $animals_categories_id->id);
        // }

        // foreach ($employees_purchase_from_warehouse_customer_group_ids as $employees_purchase_from_warehouse_customer_group_id) {
        //     array_push($employees_purchase_from_warehouse_customer_group_ids_array, $employees_purchase_from_warehouse_customer_group_id->id);
        // }


        // Sending locations according to login user
        $user = Auth::user();
        $business_id = $user->business_id;
        $permitted_locations = $user->permitted_locations($business_id);
        $filters = request()->only([
            'location_id', 'location_type', 'ratio_filter', 'start_date', 'end_date',
            'not_for_selling', 'is_inactive', 'search', 'managed_stock', 'per_page', 'page', 'category_id', 'sub_category_id'
        ]);

        $transactions = DB::table('transactions as t')
            ->select(
                DB::raw(' t.id as transaction_id '),
                DB::raw(' DATE(t.transaction_date) as transaction_date '),
                DB::raw(' t.location_id as transaction_location_id '),
                DB::raw(' t.invoice_no as transaction_invoice_no '),
                DB::raw(' t.customer_group_id as transaction_customer_group_id '),
                DB::raw(' t.contact_id as transaction_contact_id '),
                DB::raw(' t.total_before_tax as transaction_total_before_tax '),
                DB::raw(' t.tax_id as transaction_tax_id '),
                DB::raw(' t.tax_amount as transaction_tax_amount '),
                DB::raw('IF(t.discount_type = "percentage", (t.discount_amount/100)*t.total_before_tax , t.discount_amount) as transaction_discount_amount'),
                DB::raw(' t.final_total as transaction_final_total ')
            )
            ->leftjoin('business_locations as bl', 'bl.id', '=', 't.location_id')
            ->where('t.type', '=', 'sell')
            // ->where('t.id', 271221)
            ->where('t.status', '=', 'final');


        // Filters
        if (!empty($filters['location_id']))
            $transactions->whereIn('t.location_id', explode(',', $filters['location_id']));
        else if ($permitted_locations != 'all')
            $transactions->whereIn('t.location_id', $permitted_locations);

        if (!empty($filters['location_type'])) {
            if ($filters['location_type'] == 'null') {
                $transactions->whereNull('bl.custom_field1');
            } else {
                $transactions->whereIn('bl.custom_field1', explode(',', $filters['location_type']));
            }
        }

        if (!empty($filters['start_date']))
            $transactions->whereDate('t.transaction_date', '>=', $filters['start_date']);
        if (!empty($filters['end_date']))
            $transactions->whereDate('t.transaction_date', '<=', $filters['end_date']);

        $transactions = $transactions->get();
        
        // return($transactions);
        // Defines
        $purchase_lines_values = [];
        $transactions_data = [];
        $group_a = [];
        $group_a_total = [];
        $group_b = [];
        $group_b_total = [];
        $group_c = [];
        $group_c_total = [];
        $group_d = [];
        $group_d_total = [];
        $group_e = [];
        $group_e_total = [];
        $group_f = [];
        $group_f_total = [];
        $group_g = [];
        $group_g_total = [];
        $group_h = [];
        $group_h_total = [];
        $group_i = [];
        $group_i_total = [];
        $group_a_cost_final_calculations = [];
        $group_b_cost_final_calculations = [];
        $group_c_cost_final_calculations = [];
        $group_d_cost_final_calculations = [];
        $group_e_cost_final_calculations = [];
        $group_f_cost_final_calculations = [];
        $group_g_cost_final_calculations = [];
        $group_h_cost_final_calculations = [];
        $group_i_cost_final_calculations = [];
        $final_totals = [];
        $finance_calculations = [];
        $final_finance_cost_calculations_data = [];
        $final_finance_calculations = [];
        $obj = new stdClass;
        $ids = [];

        // End Defines

        /**
         * Get All Sales Transactions
         * 
         * 
         */
        foreach ($transactions as $transaction) {

            $transaction_sell_lines = DB::table('transaction_sell_lines as tsl')
                ->select(
                    DB::raw(' tsl.product_id as product_id '),
                    DB::raw(' p.category_id as product_category_id '),
                    DB::raw(' p.sub_category_id as product_sub_category_id '),
                    DB::raw(' p.enable_stock AS product_enable_stock'),
                    DB::raw(' (tsl.quantity - tsl.quantity_returned) as sell_line_sold_qty '),
                    DB::raw('IF(tsl.line_discount_type = "percentage", (tsl.line_discount_amount/100)*tsl.unit_price_before_discount , tsl.line_discount_amount) as sell_line_discount_amount'),
                    DB::raw(' tsl.tax_id as sell_line_tax_id '),
                    DB::raw(' tsl.item_tax as sell_line_item_tax '),
                    DB::raw(' tsl.unit_price_before_discount as sell_line_unit_price_before_discount '),
                    
                    DB::raw(' tsl_pl.purchase_line_id as tsl_pl_purchase_line_id '),
                    DB::raw(' (tsl_pl.quantity - tsl_pl.qty_returned) as tsl_pl_sold_qty '),
                    DB::raw(' v.dpp_inc_tax as product_purchase_price_inc_tax')
                )
                ->leftjoin('products as p', 'p.id', '=', 'tsl.product_id')
                ->leftjoin('transaction_sell_lines_purchase_lines as tsl_pl','tsl.id', '=', 'tsl_pl.sell_line_id')
                ->leftjoin('variations as v','v.id', '=', 'tsl.variation_id')
                ->where('tsl.transaction_id', $transaction->transaction_id)
                // return($this->queryToSql($transaction_sell_lines));
                ->get();

            array_push($transactions_data, (object)[
                'transaction_id' => $transaction->transaction_id,
                'transaction_location_id' => $transaction->transaction_location_id,
                'transaction_date' => $transaction->transaction_date,
                'transaction_invoice_no' => $transaction->transaction_invoice_no,
                'transaction_customer_group_id' => $transaction->transaction_customer_group_id,
                'sell_lines' => $transaction_sell_lines,

            ]);
        }

        // return($transactions_data);


        /**
         * End Get All Sales Transactions
         * 
         * Filter sales according to report groups
         */
        foreach ($transactions_data as $transaction_data) {
            if (in_array($transaction_data->transaction_location_id, $banquet_location_ids_array)) {
                array_push($group_g,  $transaction_data);
                // return('group G');
            } elseif (in_array($transaction_data->transaction_location_id, $main_warehouse_location_ids_array)) {
                array_push($group_h,  $transaction_data);
                // return('group H');
            } elseif (in_array($transaction_data->transaction_location_id, $general_warehouse_location_ids_array)) {
                array_push($group_i,  $transaction_data);
                // return($group_i);
                // return($transaction_data);
                // return('group I');
            } elseif (str_contains($transaction_data->transaction_invoice_no, $FB_prefix)) {
                array_push($group_f,  $transaction_data);
                // return('group F');
            } elseif (
                !str_contains($transaction_data->transaction_invoice_no, $FB_prefix)
                && !in_array($transaction_data->transaction_location_id, $banquet_location_ids_array)
                && !in_array($transaction_data->transaction_location_id, $main_warehouse_location_ids_array)
                && !in_array($transaction_data->transaction_location_id, $general_warehouse_location_ids_array)
                && ($transaction_data->transaction_customer_group_id == null || in_array($transaction_data->transaction_customer_group_id, $hotel_room_customer_group_ids_array))
            ) {
                array_push($group_a,  $transaction_data);
            } elseif (in_array($transaction_data->transaction_customer_group_id, $officer_customer_group_ids_array)) {
                array_push($group_b,  $transaction_data);
            } elseif (in_array($transaction_data->transaction_customer_group_id, $companies_customer_group_ids_array)) {
                array_push($group_c,  $transaction_data);
            } elseif (
                in_array($transaction_data->transaction_customer_group_id, $general_hospitality_customer_group_ids_array)
                || in_array($transaction_data->transaction_customer_group_id, $hospitality_customer_group_ids_array)
                || in_array($transaction_data->transaction_customer_group_id, $hotel_hospitality_customer_group_ids_array)
                || in_array($transaction_data->transaction_customer_group_id, $banquet_hospitality_customer_group_ids_array)
            ) {
                array_push($group_d,  $transaction_data);
            } elseif (in_array($transaction_data->transaction_customer_group_id, $PrePaid_customer_group_ids_array)) {
                array_push($group_e,  $transaction_data);
            }
        }

        /**
         * End Filter sales according to report groups
         * 
         * Grouping sales in every report group by date
         */
        $group_a_grouped_by_transaction_date = collect($group_a)->groupBy('transaction_date');
        $group_b_grouped_by_transaction_date = collect($group_b)->groupBy('transaction_date');
        $group_c_grouped_by_transaction_date = collect($group_c)->groupBy('transaction_date');
        $group_d_grouped_by_transaction_date = collect($group_d)->groupBy('transaction_date');
        $group_e_grouped_by_transaction_date = collect($group_e)->groupBy('transaction_date');
        $group_f_grouped_by_transaction_date = collect($group_f)->groupBy('transaction_date');
        $group_g_grouped_by_transaction_date = collect($group_g)->groupBy('transaction_date');
        $group_h_grouped_by_transaction_date = collect($group_h)->groupBy('transaction_date');
        $group_i_grouped_by_transaction_date = collect($group_i)->groupBy('transaction_date');
        
        
        /**
         * Define General total variables
         * 
         *
         * 
         */
        $total_food_and_beverage_product_cost = 0 ;
        $total_other_product_cost = 0 ;

        // Group A Total Line
        $group_a_total_food_and_beverage_product_cost = 0 ;
        $group_a_total_other_product_cost = 0 ;
        // End Group A Total Line

        // Group B Total Line
        $group_b_total_food_and_beverage_product_cost = 0 ;
        $group_b_total_other_product_cost = 0 ;
        // End Group B Total Line

        // Group C Total Line
        $group_c_total_food_and_beverage_product_cost = 0 ;
        $group_c_total_other_product_cost = 0 ;
        // End Group C Total Line

        // Group D Total Line
        $group_d_total_food_and_beverage_product_cost = 0 ;
        $group_d_total_other_product_cost = 0 ;
        // End Group D Total Line

        // Group E Total Line
        $group_e_total_food_and_beverage_product_cost = 0 ;
        $group_e_total_other_product_cost = 0 ;
        // End Group E Total Line

        // Group F Total Line
        $group_f_total_food_and_beverage_product_cost = 0 ;
        $group_f_total_other_product_cost = 0 ;
        // End Group F Total Line

        // Group G Total Line
        $group_g_total_food_and_beverage_product_cost = 0 ;
        $group_g_total_other_product_cost = 0 ;
        // End Group G Total Line

        // Group H Total Line
        $group_h_total_food_and_beverage_product_cost = 0 ;
        $group_h_total_other_product_cost = 0 ;
        // End Group H Total Line

        // Group I Total Line
        $group_i_total_food_and_beverage_product_cost = 0 ;
        $group_i_total_other_product_cost = 0 ;
        // End Group I Total Line

        /**
         * End Grouping sales in every report groups by date
         * 
         * Group A calculations
         *
         * Group A >> One Date
         */
        //  return($group_a_grouped_by_transaction_date);
        foreach ($group_a_grouped_by_transaction_date as $group_a_one_transaction_date) {

            $food_and_beverage_product_cost = 0;
            $other_product_cost = 0;
            
            /**
             * End Group A >> One Date
             *
             * Group A >> One Date >> Loop on this day transaction 
             */
            foreach ($group_a_one_transaction_date as $a) {

                /**
                 * Group A >> One Date >> Loop on this day transaction >> loop on this transaction sell lines
                 *
                 *  
                 */
                //  return($a->sell_lines);
                foreach ($a->sell_lines as $a->sell_line) {
                    $product_category_id = $a->sell_line->product_category_id;
                    $product_sub_category_id = $a->sell_line->product_sub_category_id;

                    if( (!in_array($product_sub_category_id, $combo_categories_ids_array )) && (!in_array($product_category_id, $combo_categories_ids_array)) )
                    {
                        
                        //Cost Calculations
                        if ((in_array($product_sub_category_id, $food_and_beverage_categories_ids_array)) || (in_array($product_category_id, $food_and_beverage_categories_ids_array))) {
    
                            if($a->sell_line->product_enable_stock == 0)
                            {   
                                // $sold_qty = $a->sell_line->sell_line_sold_qty;
                                $food_and_beverage_product_cost += ($a->sell_line->sell_line_sold_qty) * ($a->sell_line->product_purchase_price_inc_tax);
                                // return('1');
                            }
                            else
                            {
                                $purchase_lines = DB::table('purchase_lines as pl')
                                        ->select(
                                            DB::raw(' pl.purchase_price_inc_tax AS pl_product_cost ')
                                            )
                                        ->where('pl.id', $a->sell_line->tsl_pl_purchase_line_id)
                                        ->get();
                                // return($purchase_lines);
                                // return('2');
                                // array_push($purchase_lines_values, (object)[
                                    
                                //     'tsl_pl_purchase_line_id' => $a->sell_line->tsl_pl_purchase_line_id,
                                //     'pl_product_cost_in_array' => $purchase_lines[0]->pl_product_cost,
                                // ]);
                                if($a->sell_line->tsl_pl_purchase_line_id != 0 and $purchase_lines->count() > 0 )
                                {
                                    // $sold_qty = $a->sell_line->tsl_pl_sold_qty;
                                    $food_and_beverage_product_cost += ($a->sell_line->tsl_pl_sold_qty) * ($purchase_lines[0]->pl_product_cost) ;
            
                                // return($product_cost);
                                }
                                else
                                {
                                    if($a->sell_line->tsl_pl_sold_qty == null)
                                    {
                                        // $sold_qty = $a->sell_line->sell_line_sold_qty;
                                        $food_and_beverage_product_cost +=  ($a->sell_line->sell_line_sold_qty) * ($a->sell_line->product_purchase_price_inc_tax);
                                // return('3');
                                    }
                                    else
                                    {
                                        // $sold_qty = $transaction->tsl_pl_sold_qty;
                                        $food_and_beverage_product_cost +=  ($a->sell_line->tsl_pl_sold_qty) * ($a->sell_line->product_purchase_price_inc_tax);
                                // return('4');
                                    }
                                }
                            }
                        
                        } else {
    
                            if($a->sell_line->product_enable_stock == 0)
                            {   
                                // $sold_qty = $a->sell_line->sell_line_sold_qty;
                                $other_product_cost += ($a->sell_line->sell_line_sold_qty) * ($a->sell_line->product_purchase_price_inc_tax);
                                // return('1');
                            }
                            else
                            {
                                $purchase_lines = DB::table('purchase_lines as pl')
                                        ->select(
                                            DB::raw(' pl.purchase_price_inc_tax AS pl_product_cost ')
                                            )
                                        ->where('pl.id', $a->sell_line->tsl_pl_purchase_line_id)
                                        ->get();
                                // return('2');
                                // return($purchase_lines);
                                // array_push($purchase_lines_values, (object)[
                                    
                                //     'tsl_pl_purchase_line_id' => $a->sell_line->tsl_pl_purchase_line_id,
                                //     'pl_product_cost_in_array' => $purchase_lines[0]->pl_product_cost,
                                // ]);
                                if($a->sell_line->tsl_pl_purchase_line_id != 0 and $purchase_lines->count() > 0 )
                                {
                                    // $sold_qty = $a->sell_line->tsl_pl_sold_qty;
                                    $other_product_cost += ($a->sell_line->tsl_pl_sold_qty) * ($purchase_lines[0]->pl_product_cost) ;
            
                                // return($product_cost);
                                // return('2');
                                }
                                else
                                {
                                    if($a->sell_line->tsl_pl_sold_qty == null)
                                    {
                                        // $sold_qty = $a->sell_line->sell_line_sold_qty;
                                        $other_product_cost +=  ($a->sell_line->sell_line_sold_qty) * ($a->sell_line->product_purchase_price_inc_tax);
                                // return('3');
                                    }
                                    else
                                    {
                                        // $sold_qty = $transaction->tsl_pl_sold_qty;
                                        $other_product_cost +=  ($a->sell_line->tsl_pl_sold_qty) * ($a->sell_line->product_purchase_price_inc_tax);
                                // return('4');
                                    }
                                }
                            }
                        }
                        
                    }

                }

                /**
                 * End Cost Calculations
                 *
                 */

            }
                $total_food_and_beverage_product_cost += $food_and_beverage_product_cost;
                $total_other_product_cost += $other_product_cost;
                
                // Group A Totals
                $group_a_total_food_and_beverage_product_cost += $food_and_beverage_product_cost;
                $group_a_total_other_product_cost += $other_product_cost;
                // End Group A Totals

            array_push($group_a_cost_final_calculations, (object)[
                    'transaction_date' => $group_a_one_transaction_date[0]->transaction_date,
                    'food_and_beverage_product_cost' => $food_and_beverage_product_cost,
                    'other_product_cost' => $other_product_cost,
                ]);
            }
            if(!empty($group_a_cost_final_calculations))
                array_push($group_a_total, (object)[
                    'food_and_beverage_product_cost' => $group_a_total_food_and_beverage_product_cost,
                    'other_product_cost' => $group_a_total_other_product_cost,
                ]);
            // return($group_a_cost_final_calculations);

        /**
         * End Group A
         *
         * 
         */

        /**
         * Group B calculations
         *
         * Group B >> One Date
         */
        foreach ($group_b_grouped_by_transaction_date as $group_b_one_transaction_date) {

            $food_and_beverage_product_cost = 0;
            $other_product_cost = 0;
            
            /**
             * End Group B >> One Date
             *
             * Group B >> One Date >> Loop on this day transaction 
             */
            foreach ($group_b_one_transaction_date as $b) {

                /**
                 * Group B >> One Date >> Loop on this day transaction >> loop on this transaction sell lines
                 *
                 *  
                 */

                foreach ($b->sell_lines as $b->sell_line) {
                    $product_category_id = $b->sell_line->product_category_id;
                    $product_sub_category_id = $b->sell_line->product_sub_category_id;

                    if( (!in_array($product_sub_category_id, $combo_categories_ids_array )) && (!in_array($product_category_id, $combo_categories_ids_array)) )
                    {
                        
                        //Cost Calculations
                        if ((in_array($product_sub_category_id, $food_and_beverage_categories_ids_array)) || (in_array($product_category_id, $food_and_beverage_categories_ids_array))) {
    
                            if($b->sell_line->product_enable_stock == 0)
                            {   
                                $food_and_beverage_product_cost += ($b->sell_line->sell_line_sold_qty) * ($b->sell_line->product_purchase_price_inc_tax);
                            }
                            else
                            {
                                $purchase_lines = DB::table('purchase_lines as pl')
                                        ->select(
                                            DB::raw(' pl.purchase_price_inc_tax AS pl_product_cost ')
                                            )
                                        ->where('pl.id', $b->sell_line->tsl_pl_purchase_line_id)
                                        ->get();
    
    
                                if($b->sell_line->tsl_pl_purchase_line_id != 0 and $purchase_lines->count() > 0 )
                                {
                                    $food_and_beverage_product_cost += ($b->sell_line->tsl_pl_sold_qty) * ($purchase_lines[0]->pl_product_cost) ;
                                }
                                else
                                {
                                    if($b->sell_line->tsl_pl_sold_qty == null)
                                    {
                                        $food_and_beverage_product_cost +=  ($b->sell_line->sell_line_sold_qty) * ($b->sell_line->product_purchase_price_inc_tax);
                                    }
                                    else
                                    {
                                        $food_and_beverage_product_cost +=  ($b->sell_line->tsl_pl_sold_qty) * ($b->sell_line->product_purchase_price_inc_tax);
                                    }
                                }
                            }
                        
                        } else {
                            // array_push($ids,  $product_sub_category_id);
                            // array_push($ids,  $product_category_id);
                            
                            if($b->sell_line->product_enable_stock == 0)
                            {   
                                $other_product_cost += ($b->sell_line->sell_line_sold_qty) * ($b->sell_line->product_purchase_price_inc_tax);
                            }
                            else
                            {
                                $purchase_lines = DB::table('purchase_lines as pl')
                                        ->select(
                                            DB::raw(' pl.purchase_price_inc_tax AS pl_product_cost ')
                                            )
                                        ->where('pl.id', $b->sell_line->tsl_pl_purchase_line_id)
                                        ->get();
                                if($b->sell_line->tsl_pl_purchase_line_id != 0 and $purchase_lines->count() > 0 )
                                {
                                    $other_product_cost += ($b->sell_line->tsl_pl_sold_qty) * ($purchase_lines[0]->pl_product_cost) ;
                                }
                                else
                                {
                                    if($b->sell_line->tsl_pl_sold_qty == null)
                                    {
                                        $other_product_cost +=  ($b->sell_line->sell_line_sold_qty) * ($b->sell_line->product_purchase_price_inc_tax);
                                    }
                                    else
                                    {
                                        $other_product_cost +=  ($b->sell_line->tsl_pl_sold_qty) * ($b->sell_line->product_purchase_price_inc_tax);
                                    }
                                }
                            }
                        }
                        
                    }

                }
                // return($food_and_beverage_categories_ids_array);
                // return($ids);

                /**
                 * End Cost Calculations
                 *
                 */

            }
                $total_food_and_beverage_product_cost += $food_and_beverage_product_cost;
                $total_other_product_cost += $other_product_cost;
                
                // Group B Totals
                $group_b_total_food_and_beverage_product_cost += $food_and_beverage_product_cost;
                $group_b_total_other_product_cost += $other_product_cost;
                // End Group B Totals

            array_push($group_b_cost_final_calculations, (object)[
                    'transaction_date' => $group_b_one_transaction_date[0]->transaction_date,
                    'food_and_beverage_product_cost' => $food_and_beverage_product_cost,
                    'other_product_cost' => $other_product_cost,
                ]);
            }
            if(!empty($group_b_cost_final_calculations))
                array_push($group_b_total, (object)[
                    'food_and_beverage_product_cost' => $group_b_total_food_and_beverage_product_cost,
                    'other_product_cost' => $group_b_total_other_product_cost,
                ]);

        /**
         * End Group B
         *
         * 
         */

        /**
         * Group C calculations
         *
         * Group C >> One Date
         */
        foreach ($group_c_grouped_by_transaction_date as $group_c_one_transaction_date) {

            $food_and_beverage_product_cost = 0;
            $other_product_cost = 0;
            
            /**
             * End Group C >> One Date
             *
             * Group C >> One Date >> Loop on this day transaction 
             */
            foreach ($group_c_one_transaction_date as $c) {

                /**
                 * Group C >> One Date >> Loop on this day transaction >> loop on this transaction sell lines
                 *
                 *  
                 */

                foreach ($c->sell_lines as $c->sell_line) {
                    $product_category_id = $c->sell_line->product_category_id;
                    $product_sub_category_id = $c->sell_line->product_sub_category_id;

                    if( (!in_array($product_sub_category_id, $combo_categories_ids_array )) && (!in_array($product_category_id, $combo_categories_ids_array)) )
                    {
                        
                        //Cost Calculations
                        if ((in_array($product_sub_category_id, $food_and_beverage_categories_ids_array)) || (in_array($product_category_id, $food_and_beverage_categories_ids_array))) {
    
                            if($c->sell_line->product_enable_stock == 0)
                            {   
                                $food_and_beverage_product_cost += ($c->sell_line->sell_line_sold_qty) * ($c->sell_line->product_purchase_price_inc_tax);
                            }
                            else
                            {
                                $purchase_lines = DB::table('purchase_lines as pl')
                                        ->select(
                                            DB::raw(' pl.purchase_price_inc_tax AS pl_product_cost ')
                                            )
                                        ->where('pl.id', $c->sell_line->tsl_pl_purchase_line_id)
                                        ->get();
    
    
                                if($c->sell_line->tsl_pl_purchase_line_id != 0 and $purchase_lines->count() > 0 )
                                {
                                    $food_and_beverage_product_cost += ($c->sell_line->tsl_pl_sold_qty) * ($purchase_lines[0]->pl_product_cost) ;
                                }
                                else
                                {
                                    if($c->sell_line->tsl_pl_sold_qty == null)
                                    {
                                        $food_and_beverage_product_cost +=  ($c->sell_line->sell_line_sold_qty) * ($c->sell_line->product_purchase_price_inc_tax);
                                    }
                                    else
                                    {
                                        $food_and_beverage_product_cost +=  ($c->sell_line->tsl_pl_sold_qty) * ($c->sell_line->product_purchase_price_inc_tax);
                                    }
                                }
                            }
                        
                        } else {
                            
                            if($c->sell_line->product_enable_stock == 0)
                            {   
                                $other_product_cost += ($c->sell_line->sell_line_sold_qty) * ($c->sell_line->product_purchase_price_inc_tax);
                            }
                            else
                            {
                                $purchase_lines = DB::table('purchase_lines as pl')
                                        ->select(
                                            DB::raw(' pl.purchase_price_inc_tax AS pl_product_cost ')
                                            )
                                        ->where('pl.id', $c->sell_line->tsl_pl_purchase_line_id)
                                        ->get();
                                if($c->sell_line->tsl_pl_purchase_line_id != 0 and $purchase_lines->count() > 0 )
                                {
                                    $other_product_cost += ($c->sell_line->tsl_pl_sold_qty) * ($purchase_lines[0]->pl_product_cost) ;
                                }
                                else
                                {
                                    if($c->sell_line->tsl_pl_sold_qty == null)
                                    {
                                        $other_product_cost +=  ($c->sell_line->sell_line_sold_qty) * ($c->sell_line->product_purchase_price_inc_tax);
                                    }
                                    else
                                    {
                                        $other_product_cost +=  ($c->sell_line->tsl_pl_sold_qty) * ($c->sell_line->product_purchase_price_inc_tax);
                                    }
                                }
                            }
                        }
                        
                    }

                }

                /**
                 * End Cost Calculations
                 *
                 */

            }
                $total_food_and_beverage_product_cost += $food_and_beverage_product_cost;
                $total_other_product_cost += $other_product_cost;
                
                // Group C Totals
                $group_c_total_food_and_beverage_product_cost += $food_and_beverage_product_cost;
                $group_c_total_other_product_cost += $other_product_cost;
                // End Group C Totals

            array_push($group_c_cost_final_calculations, (object)[
                    'transaction_date' => $group_c_one_transaction_date[0]->transaction_date,
                    'food_and_beverage_product_cost' => $food_and_beverage_product_cost,
                    'other_product_cost' => $other_product_cost,
                ]);
            }
            if(!empty($group_c_cost_final_calculations))
                array_push($group_c_total, (object)[
                    'food_and_beverage_product_cost' => $group_c_total_food_and_beverage_product_cost,
                    'other_product_cost' => $group_c_total_other_product_cost,
                ]);

        /**
         * End Group C
         *
         * 
         */

        /**
         * Group D calculations
         *
         * Group D >> One Date
         */
        foreach ($group_d_grouped_by_transaction_date as $group_d_one_transaction_date) {

            $food_and_beverage_product_cost = 0;
            $other_product_cost = 0;
            
            /**
             * End Group D >> One Date
             *
             * Group D >> One Date >> Loop on this day transaction 
             */
            foreach ($group_d_one_transaction_date as $d) {
            
                /**
                 * Group D >> One Date >> Loop on this day transaction >> loop on this transaction sell lines
                 *
                 *  
                 */
            
                foreach ($d->sell_lines as $d->sell_line) {
                    $product_category_id = $d->sell_line->product_category_id;
                    $product_sub_category_id = $d->sell_line->product_sub_category_id;
            
                    if( (!in_array($product_sub_category_id, $combo_categories_ids_array )) && (!in_array($product_category_id, $combo_categories_ids_array)) )
                    {
                        
                        //Cost Calculations
                        if ((in_array($product_sub_category_id, $food_and_beverage_categories_ids_array)) || (in_array($product_category_id, $food_and_beverage_categories_ids_array))) {
                
                            if($d->sell_line->product_enable_stock == 0)
                            {   
                                $food_and_beverage_product_cost += ($d->sell_line->sell_line_sold_qty) * ($d->sell_line->product_purchase_price_inc_tax);
                            }
                            else
                            {
                                $purchase_lines = DB::table('purchase_lines as pl')
                                        ->select(
                                            DB::raw(' pl.purchase_price_inc_tax AS pl_product_cost ')
                                            )
                                        ->where('pl.id', $d->sell_line->tsl_pl_purchase_line_id)
                                        ->get();
                
                
                                if($d->sell_line->tsl_pl_purchase_line_id != 0 and $purchase_lines->count() > 0 )
                                {
                                    $food_and_beverage_product_cost += ($d->sell_line->tsl_pl_sold_qty) * ($purchase_lines[0]->pl_product_cost) ;
                                }
                                else
                                {
                                    if($d->sell_line->tsl_pl_sold_qty == null)
                                    {
                                        $food_and_beverage_product_cost +=  ($d->sell_line->sell_line_sold_qty) * ($d->sell_line->product_purchase_price_inc_tax);
                                    }
                                    else
                                    {
                                        $food_and_beverage_product_cost +=  ($d->sell_line->tsl_pl_sold_qty) * ($d->sell_line->product_purchase_price_inc_tax);
                                    }
                                }
                            }
                        
                        } else {
                            
                            if($d->sell_line->product_enable_stock == 0)
                            {   
                                $other_product_cost += ($d->sell_line->sell_line_sold_qty) * ($d->sell_line->product_purchase_price_inc_tax);
                            }
                            else
                            {
                                $purchase_lines = DB::table('purchase_lines as pl')
                                        ->select(
                                            DB::raw(' pl.purchase_price_inc_tax AS pl_product_cost ')
                                            )
                                        ->where('pl.id', $d->sell_line->tsl_pl_purchase_line_id)
                                        ->get();
                                if($d->sell_line->tsl_pl_purchase_line_id != 0 and $purchase_lines->count() > 0 )
                                {
                                    $other_product_cost += ($d->sell_line->tsl_pl_sold_qty) * ($purchase_lines[0]->pl_product_cost) ;
                                }
                                else
                                {
                                    if($d->sell_line->tsl_pl_sold_qty == null)
                                    {
                                        $other_product_cost +=  ($d->sell_line->sell_line_sold_qty) * ($d->sell_line->product_purchase_price_inc_tax);
                                    }
                                    else
                                    {
                                        $other_product_cost +=  ($d->sell_line->tsl_pl_sold_qty) * ($d->sell_line->product_purchase_price_inc_tax);
                                    }
                                }
                            }
                        }
                        
                    }
            
                }

    /**
     * End Cost Calculations
     *
     */

}       
        $total_food_and_beverage_product_cost += $food_and_beverage_product_cost;
        $total_other_product_cost += $other_product_cost;
        
        // Group D Totals
        $group_d_total_food_and_beverage_product_cost += $food_and_beverage_product_cost;
        $group_d_total_other_product_cost += $other_product_cost;
        // End Group D Totals

        array_push($group_d_cost_final_calculations, (object)[
                'transaction_date' => $group_d_one_transaction_date[0]->transaction_date,
                'food_and_beverage_product_cost' => $food_and_beverage_product_cost,
                'other_product_cost' => $other_product_cost,
            ]);
        }
        if(!empty($group_d_cost_final_calculations))
            array_push($group_d_total, (object)[
                'food_and_beverage_product_cost' => $group_d_total_food_and_beverage_product_cost,
                'other_product_cost' => $group_d_total_other_product_cost,
            ]);

        /**
         * End Group D
         *
         * 
         */

        /**
         * Group E calculations
         *
         * Group E >> One Date
         */
        foreach ($group_e_grouped_by_transaction_date as $group_e_one_transaction_date) {

            $food_and_beverage_product_cost = 0;
            $other_product_cost = 0;

            /**
            * End Group E >> One Date
            *
            * Group E >> One Date >> Loop on this day transaction 
            */
            foreach ($group_e_one_transaction_date as $e) {

                /**
                * Group E >> One Date >> Loop on this day transaction >> loop on this transaction sell lines
                *
                *  
                */

                foreach ($e->sell_lines as $e->sell_line) {
                    $product_category_id = $e->sell_line->product_category_id;
                    $product_sub_category_id = $e->sell_line->product_sub_category_id;

                    if( (!in_array($product_sub_category_id, $combo_categories_ids_array )) && (!in_array($product_category_id, $combo_categories_ids_array)) )
                    {
                        
                        //Cost Calculations
                        if ((in_array($product_sub_category_id, $food_and_beverage_categories_ids_array)) || (in_array($product_category_id, $food_and_beverage_categories_ids_array))) {
    
                            if($e->sell_line->product_enable_stock == 0)
                            {   
                                $food_and_beverage_product_cost += ($e->sell_line->sell_line_sold_qty) * ($e->sell_line->product_purchase_price_inc_tax);
                            }
                            else
                            {
                                $purchase_lines = DB::table('purchase_lines as pl')
                                        ->select(
                                            DB::raw(' pl.purchase_price_inc_tax AS pl_product_cost ')
                                            )
                                        ->where('pl.id', $e->sell_line->tsl_pl_purchase_line_id)
                                        ->get();
    
    
                                if($e->sell_line->tsl_pl_purchase_line_id != 0 and $purchase_lines->count() > 0 )
                                {
                                    $food_and_beverage_product_cost += ($e->sell_line->tsl_pl_sold_qty) * ($purchase_lines[0]->pl_product_cost) ;
                                }
                                else
                                {
                                    if($e->sell_line->tsl_pl_sold_qty == null)
                                    {
                                        $food_and_beverage_product_cost +=  ($e->sell_line->sell_line_sold_qty) * ($e->sell_line->product_purchase_price_inc_tax);
                                    }
                                    else
                                    {
                                        $food_and_beverage_product_cost +=  ($e->sell_line->tsl_pl_sold_qty) * ($e->sell_line->product_purchase_price_inc_tax);
                                    }
                                }
                            }
                        
                        } else {
                            
                            if($e->sell_line->product_enable_stock == 0)
                            {   
                                $other_product_cost += ($e->sell_line->sell_line_sold_qty) * ($e->sell_line->product_purchase_price_inc_tax);
                            }
                            else
                            {
                                $purchase_lines = DB::table('purchase_lines as pl')
                                        ->select(
                                            DB::raw(' pl.purchase_price_inc_tax AS pl_product_cost ')
                                            )
                                        ->where('pl.id', $e->sell_line->tsl_pl_purchase_line_id)
                                        ->get();
                                if($e->sell_line->tsl_pl_purchase_line_id != 0 and $purchase_lines->count() > 0 )
                                {
                                    $other_product_cost += ($e->sell_line->tsl_pl_sold_qty) * ($purchase_lines[0]->pl_product_cost) ;
                                }
                                else
                                {
                                    if($e->sell_line->tsl_pl_sold_qty == null)
                                    {
                                        $other_product_cost +=  ($e->sell_line->sell_line_sold_qty) * ($e->sell_line->product_purchase_price_inc_tax);
                                    }
                                    else
                                    {
                                        $other_product_cost +=  ($e->sell_line->tsl_pl_sold_qty) * ($e->sell_line->product_purchase_price_inc_tax);
                                    }
                                }
                            }
                        }
                        
                    }

                }

                /**
                * End Cost Calculations
                *
                */

            }
                $total_food_and_beverage_product_cost += $food_and_beverage_product_cost;
                $total_other_product_cost += $other_product_cost;
                
                // Group E Totals
                $group_e_total_food_and_beverage_product_cost += $food_and_beverage_product_cost;
                $group_e_total_other_product_cost += $other_product_cost;
                // End Group E Totals

            array_push($group_e_cost_final_calculations, (object)[
                    'transaction_date' => $group_e_one_transaction_date[0]->transaction_date,
                    'food_and_beverage_product_cost' => $food_and_beverage_product_cost,
                    'other_product_cost' => $other_product_cost,
                ]);
            }
            if(!empty($group_e_cost_final_calculations))
                array_push($group_e_total, (object)[
                    'food_and_beverage_product_cost' => $group_e_total_food_and_beverage_product_cost,
                    'other_product_cost' => $group_e_total_other_product_cost,
                ]);

        /**
         * End Group E
         *
         * 
         */

        /**
         * Group F calculations
         *
         * Group F >> One Date
         */
         
        foreach ($group_f_grouped_by_transaction_date as $group_f_one_transaction_date) {

            $food_and_beverage_product_cost = 0;
            $other_product_cost = 0;

            /**
            * End Group F >> One Date
            *
            * Group F >> One Date >> Loop on this day transaction 
            */
            foreach ($group_f_one_transaction_date as $f) {

                /**
                * Group F >> One Date >> Loop on this day transaction >> loop on this transaction sell lines
                *
                *  
                */

                foreach ($f->sell_lines as $f->sell_line) {
                    $product_category_id = $f->sell_line->product_category_id;
                    $product_sub_category_id = $f->sell_line->product_sub_category_id;

                    if( (!in_array($product_sub_category_id, $combo_categories_ids_array )) && (!in_array($product_category_id, $combo_categories_ids_array)) )
                    {
                        
                        //Cost Calculations
                        if ((in_array($product_sub_category_id, $food_and_beverage_categories_ids_array)) || (in_array($product_category_id, $food_and_beverage_categories_ids_array))) {
    
                            if($f->sell_line->product_enable_stock == 0)
                            {   
                                $food_and_beverage_product_cost += ($f->sell_line->sell_line_sold_qty) * ($f->sell_line->product_purchase_price_inc_tax);
                            }
                            else
                            {
                                $purchase_lines = DB::table('purchase_lines as pl')
                                        ->select(
                                            DB::raw(' pl.purchase_price_inc_tax AS pl_product_cost ')
                                            )
                                        ->where('pl.id', $f->sell_line->tsl_pl_purchase_line_id)
                                        ->get();
    
    
                                if($f->sell_line->tsl_pl_purchase_line_id != 0 and $purchase_lines->count() > 0 )
                                {
                                    $food_and_beverage_product_cost += ($f->sell_line->tsl_pl_sold_qty) * ($purchase_lines[0]->pl_product_cost) ;
                                }
                                else
                                {
                                    if($f->sell_line->tsl_pl_sold_qty == null)
                                    {
                                        $food_and_beverage_product_cost +=  ($f->sell_line->sell_line_sold_qty) * ($f->sell_line->product_purchase_price_inc_tax);
                                    }
                                    else
                                    {
                                        $food_and_beverage_product_cost +=  ($f->sell_line->tsl_pl_sold_qty) * ($f->sell_line->product_purchase_price_inc_tax);
                                    }
                                }
                            }
                        
                        } else {
                            
                            if($f->sell_line->product_enable_stock == 0)
                            {   
                                $other_product_cost += ($f->sell_line->sell_line_sold_qty) * ($f->sell_line->product_purchase_price_inc_tax);
                            }
                            else
                            {
                                $purchase_lines = DB::table('purchase_lines as pl')
                                        ->select(
                                            DB::raw(' pl.purchase_price_inc_tax AS pl_product_cost ')
                                            )
                                        ->where('pl.id', $f->sell_line->tsl_pl_purchase_line_id)
                                        ->get();
                                if($f->sell_line->tsl_pl_purchase_line_id != 0 and $purchase_lines->count() > 0 )
                                {
                                    $other_product_cost += ($f->sell_line->tsl_pl_sold_qty) * ($purchase_lines[0]->pl_product_cost) ;
                                }
                                else
                                {
                                    if($f->sell_line->tsl_pl_sold_qty == null)
                                    {
                                        $other_product_cost +=  ($f->sell_line->sell_line_sold_qty) * ($f->sell_line->product_purchase_price_inc_tax);
                                    }
                                    else
                                    {
                                        $other_product_cost +=  ($f->sell_line->tsl_pl_sold_qty) * ($f->sell_line->product_purchase_price_inc_tax);
                                    }
                                }
                            }
                        }
                        
                    }

                }

                /**
                * End Cost Calculations
                *
                */

            }
                $total_food_and_beverage_product_cost += $food_and_beverage_product_cost;
                $total_other_product_cost += $other_product_cost;
                
                // Group F Totals
                $group_f_total_food_and_beverage_product_cost += $food_and_beverage_product_cost;
                $group_f_total_other_product_cost += $other_product_cost;
                // End Group F Totals

            array_push($group_f_cost_final_calculations, (object)[
                    'transaction_date' => $group_f_one_transaction_date[0]->transaction_date,
                    'food_and_beverage_product_cost' => $food_and_beverage_product_cost,
                    'other_product_cost' => $other_product_cost,
                ]);
            }
            if(!empty($group_f_cost_final_calculations))
                array_push($group_f_total, (object)[
                    'food_and_beverage_product_cost' => $group_f_total_food_and_beverage_product_cost,
                    'other_product_cost' => $group_f_total_other_product_cost,
                ]);

        /**
         * End Group F
         *
         * 
         */

        /**
         * Group G calculations
         *
         * Group G >> One Date
         */
        foreach ($group_g_grouped_by_transaction_date as $group_g_one_transaction_date) {

            $food_and_beverage_product_cost = 0;
            $other_product_cost = 0;

            /**
            * End Group g >> One Date
            *
            * Group g >> One Date >> Loop on this day transaction 
            */
            foreach ($group_g_one_transaction_date as $g) {

                /**
                * Group g >> One Date >> Loop on this day transaction >> loop on this transaction sell lines
                *
                *  
                */

                foreach ($g->sell_lines as $g->sell_line) {
                    $product_category_id = $g->sell_line->product_category_id;
                    $product_sub_category_id = $g->sell_line->product_sub_category_id;

                    if( (!in_array($product_sub_category_id, $combo_categories_ids_array )) && (!in_array($product_category_id, $combo_categories_ids_array)) )
                    {
                        
                        //Cost Calculations
                        if ((in_array($product_sub_category_id, $food_and_beverage_categories_ids_array)) || (in_array($product_category_id, $food_and_beverage_categories_ids_array))) {
    
                            if($g->sell_line->product_enable_stock == 0)
                            {   
                                $food_and_beverage_product_cost += ($g->sell_line->sell_line_sold_qty) * ($g->sell_line->product_purchase_price_inc_tax);
                            }
                            else
                            {
                                $purchase_lines = DB::table('purchase_lines as pl')
                                        ->select(
                                            DB::raw(' pl.purchase_price_inc_tax AS pl_product_cost ')
                                            )
                                        ->where('pl.id', $g->sell_line->tsl_pl_purchase_line_id)
                                        ->get();
    
    
                                if($g->sell_line->tsl_pl_purchase_line_id != 0 and $purchase_lines->count() > 0 )
                                {
                                    $food_and_beverage_product_cost += ($g->sell_line->tsl_pl_sold_qty) * ($purchase_lines[0]->pl_product_cost) ;
                                }
                                else
                                {
                                    if($g->sell_line->tsl_pl_sold_qty == null)
                                    {
                                        $food_and_beverage_product_cost +=  ($g->sell_line->sell_line_sold_qty) * ($g->sell_line->product_purchase_price_inc_tax);
                                    }
                                    else
                                    {
                                        $food_and_beverage_product_cost +=  ($g->sell_line->tsl_pl_sold_qty) * ($g->sell_line->product_purchase_price_inc_tax);
                                    }
                                }
                            }
                        
                        } else {
                            
                            if($g->sell_line->product_enable_stock == 0)
                            {   
                                $other_product_cost += ($g->sell_line->sell_line_sold_qty) * ($g->sell_line->product_purchase_price_inc_tax);
                            }
                            else
                            {
                                $purchase_lines = DB::table('purchase_lines as pl')
                                        ->select(
                                            DB::raw(' pl.purchase_price_inc_tax AS pl_product_cost ')
                                            )
                                        ->where('pl.id', $g->sell_line->tsl_pl_purchase_line_id)
                                        ->get();
                                if($g->sell_line->tsl_pl_purchase_line_id != 0 and $purchase_lines->count() > 0 )
                                {
                                    $other_product_cost += ($g->sell_line->tsl_pl_sold_qty) * ($purchase_lines[0]->pl_product_cost) ;
                                }
                                else
                                {
                                    if($g->sell_line->tsl_pl_sold_qty == null)
                                    {
                                        $other_product_cost +=  ($g->sell_line->sell_line_sold_qty) * ($g->sell_line->product_purchase_price_inc_tax);
                                    }
                                    else
                                    {
                                        $other_product_cost +=  ($g->sell_line->tsl_pl_sold_qty) * ($g->sell_line->product_purchase_price_inc_tax);
                                    }
                                }
                            }
                        }
                        
                    }

                }

                /**
                * End Cost Calculations
                *
                */

            }
                $total_food_and_beverage_product_cost += $food_and_beverage_product_cost;
                $total_other_product_cost += $other_product_cost;
                
                // Group G Totals
                $group_g_total_food_and_beverage_product_cost += $food_and_beverage_product_cost;
                $group_g_total_other_product_cost += $other_product_cost;
                // End Group G Totals

            array_push($group_g_cost_final_calculations, (object)[
                    'transaction_date' => $group_g_one_transaction_date[0]->transaction_date,
                    'food_and_beverage_product_cost' => $food_and_beverage_product_cost,
                    'other_product_cost' => $other_product_cost,
                ]);
            }
            if(!empty($group_g_cost_final_calculations))
                array_push($group_g_total, (object)[
                    'food_and_beverage_product_cost' => $group_g_total_food_and_beverage_product_cost,
                    'other_product_cost' => $group_g_total_other_product_cost,
                ]);

        /**
         * End Group G
         *
         * 
         */

        /**
         * Group H calculations
         *
         * Group H >> One Date
         */
        foreach ($group_h_grouped_by_transaction_date as $group_h_one_transaction_date) {

            $food_and_beverage_product_cost = 0;
            $other_product_cost = 0;

            /**
            * End Group H >> One Date
            *
            * Group H >> One Date >> Loop on this day transaction 
            */
            foreach ($group_h_one_transaction_date as $h) {

                /**
                * Group H >> One Date >> Loop on this day transaction >> loop on this transaction sell lines
                *
                *  
                */

                foreach ($h->sell_lines as $h->sell_line) {
                    $product_category_id = $h->sell_line->product_category_id;
                    $product_sub_category_id = $h->sell_line->product_sub_category_id;

                    if( (!in_array($product_sub_category_id, $combo_categories_ids_array )) && (!in_array($product_category_id, $combo_categories_ids_array)) )
                    {
                        
                        //Cost Calculations
                        if ((in_array($product_sub_category_id, $food_and_beverage_categories_ids_array)) || (in_array($product_category_id, $food_and_beverage_categories_ids_array))) {
    
                            if($h->sell_line->product_enable_stock == 0)
                            {   
                                $food_and_beverage_product_cost += ($h->sell_line->sell_line_sold_qty) * ($h->sell_line->product_purchase_price_inc_tax);
                            }
                            else
                            {
                                $purchase_lines = DB::table('purchase_lines as pl')
                                        ->select(
                                            DB::raw(' pl.purchase_price_inc_tax AS pl_product_cost ')
                                            )
                                        ->where('pl.id', $h->sell_line->tsl_pl_purchase_line_id)
                                        ->get();
    
    
                                if($h->sell_line->tsl_pl_purchase_line_id != 0 and $purchase_lines->count() > 0 )
                                {
                                    $food_and_beverage_product_cost += ($h->sell_line->tsl_pl_sold_qty) * ($purchase_lines[0]->pl_product_cost) ;
                                }
                                else
                                {
                                    if($h->sell_line->tsl_pl_sold_qty == null)
                                    {
                                        $food_and_beverage_product_cost +=  ($h->sell_line->sell_line_sold_qty) * ($h->sell_line->product_purchase_price_inc_tax);
                                    }
                                    else
                                    {
                                        $food_and_beverage_product_cost +=  ($h->sell_line->tsl_pl_sold_qty) * ($h->sell_line->product_purchase_price_inc_tax);
                                    }
                                }
                            }
                        
                        } else {
                            
                            if($h->sell_line->product_enable_stock == 0)
                            {   
                                $other_product_cost += ($h->sell_line->sell_line_sold_qty) * ($h->sell_line->product_purchase_price_inc_tax);
                            }
                            else
                            {
                                $purchase_lines = DB::table('purchase_lines as pl')
                                        ->select(
                                            DB::raw(' pl.purchase_price_inc_tax AS pl_product_cost ')
                                            )
                                        ->where('pl.id', $h->sell_line->tsl_pl_purchase_line_id)
                                        ->get();
                                if($h->sell_line->tsl_pl_purchase_line_id != 0 and $purchase_lines->count() > 0 )
                                {
                                    $other_product_cost += ($h->sell_line->tsl_pl_sold_qty) * ($purchase_lines[0]->pl_product_cost) ;
                                }
                                else
                                {
                                    if($h->sell_line->tsl_pl_sold_qty == null)
                                    {
                                        $other_product_cost +=  ($h->sell_line->sell_line_sold_qty) * ($h->sell_line->product_purchase_price_inc_tax);
                                    }
                                    else
                                    {
                                        $other_product_cost +=  ($h->sell_line->tsl_pl_sold_qty) * ($h->sell_line->product_purchase_price_inc_tax);
                                    }
                                }
                            }
                        }
                        
                    }

                }

                /**
                * End Cost Calculations
                *
                */

            }
                $total_food_and_beverage_product_cost += $food_and_beverage_product_cost;
                $total_other_product_cost += $other_product_cost;
                
                // Group H Totals
                $group_h_total_food_and_beverage_product_cost += $food_and_beverage_product_cost;
                $group_h_total_other_product_cost += $other_product_cost;
                // End Group H Totals

            array_push($group_h_cost_final_calculations, (object)[
                    'transaction_date' => $group_h_one_transaction_date[0]->transaction_date,
                    'food_and_beverage_product_cost' => $food_and_beverage_product_cost,
                    'other_product_cost' => $other_product_cost,
                ]);
            }
            if(!empty($group_h_cost_final_calculations))
                array_push($group_h_total, (object)[
                    'food_and_beverage_product_cost' => $group_h_total_food_and_beverage_product_cost,
                    'other_product_cost' => $group_h_total_other_product_cost,
                ]);

        /**
         * End Group H
         *
         * 
         */

        /**
         * Group I calculations
         *
         * Group I >> One Date
         */
        foreach ($group_i_grouped_by_transaction_date as $group_i_one_transaction_date) {

            $food_and_beverage_product_cost = 0;
            $other_product_cost = 0;

            /**
            * End Group I >> One Date
            *
            * Group I >> One Date >> Loop on this day transaction 
            */
            foreach ($group_i_one_transaction_date as $i) {

                /**
                * Group I >> One Date >> Loop on this day transaction >> loop on this transaction sell lines
                *
                *  
                */

                foreach ($i->sell_lines as $i->sell_line) {
                    $product_category_id = $i->sell_line->product_category_id;
                    $product_sub_category_id = $i->sell_line->product_sub_category_id;

                    if( (!in_array($product_sub_category_id, $combo_categories_ids_array )) && (!in_array($product_category_id, $combo_categories_ids_array)) )
                    {
                        
                        //Cost Calculations
                        if ((in_array($product_sub_category_id, $food_and_beverage_categories_ids_array)) || (in_array($product_category_id, $food_and_beverage_categories_ids_array))) {
    
                            if($i->sell_line->product_enable_stock == 0)
                            {   
                                $food_and_beverage_product_cost += ($i->sell_line->sell_line_sold_qty) * ($i->sell_line->product_purchase_price_inc_tax);
                            }
                            else
                            {
                                $purchase_lines = DB::table('purchase_lines as pl')
                                        ->select(
                                            DB::raw(' pl.purchase_price_inc_tax AS pl_product_cost ')
                                            )
                                        ->where('pl.id', $i->sell_line->tsl_pl_purchase_line_id)
                                        ->get();
    
    
                                if($i->sell_line->tsl_pl_purchase_line_id != 0 and $purchase_lines->count() > 0 )
                                {
                                    $food_and_beverage_product_cost += ($i->sell_line->tsl_pl_sold_qty) * ($purchase_lines[0]->pl_product_cost) ;
                                }
                                else
                                {
                                    if($i->sell_line->tsl_pl_sold_qty == null)
                                    {
                                        $food_and_beverage_product_cost +=  ($i->sell_line->sell_line_sold_qty) * ($i->sell_line->product_purchase_price_inc_tax);
                                    }
                                    else
                                    {
                                        $food_and_beverage_product_cost +=  ($i->sell_line->tsl_pl_sold_qty) * ($i->sell_line->product_purchase_price_inc_tax);
                                    }
                                }
                            }
                        
                        } else {
                            
                            if($i->sell_line->product_enable_stock == 0)
                            {   
                                $other_product_cost += ($i->sell_line->sell_line_sold_qty) * ($i->sell_line->product_purchase_price_inc_tax);
                            }
                            else
                            {
                                $purchase_lines = DB::table('purchase_lines as pl')
                                        ->select(
                                            DB::raw(' pl.purchase_price_inc_tax AS pl_product_cost ')
                                            )
                                        ->where('pl.id', $i->sell_line->tsl_pl_purchase_line_id)
                                        ->get();
                                if($i->sell_line->tsl_pl_purchase_line_id != 0 and $purchase_lines->count() > 0 )
                                {
                                    $other_product_cost += ($i->sell_line->tsl_pl_sold_qty) * ($purchase_lines[0]->pl_product_cost) ;
                                }
                                else
                                {
                                    if($i->sell_line->tsl_pl_sold_qty == null)
                                    {
                                        $other_product_cost +=  ($i->sell_line->sell_line_sold_qty) * ($i->sell_line->product_purchase_price_inc_tax);
                                    }
                                    else
                                    {
                                        $other_product_cost +=  ($i->sell_line->tsl_pl_sold_qty) * ($i->sell_line->product_purchase_price_inc_tax);
                                    }
                                }
                            }
                        }
                        
                    }

                }

                /**
                * End Cost Calculations
                *
                */

            }
                $total_food_and_beverage_product_cost += $food_and_beverage_product_cost;
                $total_other_product_cost += $other_product_cost;
                
                // Group I Totals
                $group_i_total_food_and_beverage_product_cost += $food_and_beverage_product_cost;
                $group_i_total_other_product_cost += $other_product_cost;
                // End Group I Totals

            array_push($group_i_cost_final_calculations, (object)[
                    'transaction_date' => $group_i_one_transaction_date[0]->transaction_date,
                    'food_and_beverage_product_cost' => $food_and_beverage_product_cost,
                    'other_product_cost' => $other_product_cost,
                ]);
            }
            if(!empty($group_i_cost_final_calculations))
                array_push($group_i_total, (object)[
                    'food_and_beverage_product_cost' => $group_i_total_food_and_beverage_product_cost,
                    'other_product_cost' => $group_i_total_other_product_cost,
                ]);

        /**
         * End Group I
         *
         * 
         */
        
        /**
         * Final Totals
         *
         * 
         */    
         
        array_push($final_totals, (object)[
                'food_and_beverage_product_cost' => $total_food_and_beverage_product_cost ,
                'other_product_cost' => $total_other_product_cost,
            ]);
    
        /**
         * End Final Totals
         *
         * 
         */    

        /**
         * Final Finance Calculation Array
         *
         * 
         */

        array_push($final_finance_cost_calculations_data, (object)[
                    'group_a' => $group_a_cost_final_calculations,
                    'group_a_total' => $group_a_total,
                    'group_b' => $group_b_cost_final_calculations,
                    'group_b_total' => $group_b_total,
                    'group_c' => $group_c_cost_final_calculations,
                    'group_c_total' => $group_c_total,
                    'group_d' => $group_d_cost_final_calculations,
                    'group_d_total' => $group_d_total,
                    'group_e' => $group_e_cost_final_calculations,
                    'group_e_total' => $group_e_total,
                    'group_f' => $group_f_cost_final_calculations,
                    'group_f_total' => $group_f_total,
                    'group_g' => $group_g_cost_final_calculations,
                    'group_g_total' => $group_g_total,
                    'group_h' => $group_h_cost_final_calculations,
                    'group_h_total' => $group_h_total,
                    'group_i' => $group_i_cost_final_calculations,
                    'group_i_total' => $group_i_total,
                ]);
            $final_finance_calculations['data'] = $final_finance_cost_calculations_data;
            $final_finance_calculations['totals'] = $final_totals;
            return($final_finance_calculations);





        $perPage = 10;
        $skip = 0;
        if (!empty($filters['per_page'])) {
            if (($filters['per_page']) != -1) {
                $perPage = $filters['per_page'];
            } else {
                $perPage = count($transactions_data);
            }
        }


        $sells = $this->paginate($transactions_data, $perPage);
        $sells->appends(Arr::except($filters, ['page']));

        $response = ((new PaginatedResourceResponse(CollectionResource::make($sells)))->toResponse(request()));
        $data = $response->getData();




        $response->setData($data);
        return $response;
    }


    /**
     * Create a new command instance.
     *
     * @return string
     */
    public function queryToSql($query)
    {
        return vsprintf(str_replace(array('?'), array('\'%s\''), $query->toSql()), $query->getBindings());
    }

    /**
     * The attributes that are mass assignable.
     *
     *
     * @param $items
     * @param int $perPage
     * @param null $page
     * @param array $options
     * @return LengthAwarePaginator
     */
    public function paginate($items, $perPage = 5, $page = null, $options = [])
    {
        $page = $page ?: (Paginator::resolveCurrentPage() ?: 1);
        $items = $items instanceof Collection ? $items : Collection::make($items);
        return new LengthAwarePaginator($items->forPage($page, $perPage), $items->count(), $perPage, $page, $options);
    }
}
