<?php
namespace Modules\ReportsModule\Http\Controllers;

use stdClass;
use App\User;
use App\Category;
use App\Product;
use Exception;
use Illuminate\Database\Query\JoinClause;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Resources\Json\PaginatedResourceResponse;
use Illuminate\Pagination\LengthAwarePaginator;
use Illuminate\Pagination\Paginator;
use Illuminate\Support\Arr;
use Illuminate\Support\Collection;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Modules\Connector\Http\Controllers\Api\ApiController;
use Modules\ReportsModule\Transformers\CollectionResource;
use Illuminate\Support\Str;

class FinanceCalculationsGroupedInvoicesReportApiController extends ApiController
{
    /**
     * Display a listing of the resource.
     * @return JsonResponse
     * @throws Exception
     */
    public function index()
    {
        
        $reports_module_setting = DB::table('reports_module')
            ->get();
            // return($reports_module_setting);
        
        $service_15_tax_id = 0;
        $service_25_tax_id = 0;
        $banquet_location_ids = 0;
        $banquet_location_ids_array = [];
        $main_warehouse_location_ids = 0;
        $main_warehouse_location_ids_array = [];
        $general_warehouse_location_ids = 0;
        $general_warehouse_location_ids_array = [];
        $FB_prefix = 0;
        // $FB_prefixs_array = [];
        $hotel_room_customer_group_ids = 0;
        $hotel_room_customer_group_ids_array = [];
        $officer_customer_group_ids = 0;
        $officer_customer_group_ids_array = [];
        $companies_customer_group_ids = 0;
        $companies_customer_group_ids_array = [];
        $general_hospitality_customer_group_ids = 0;
        $general_hospitality_customer_group_ids_array = [];
        $hospitality_customer_group_ids = 0;
        $hospitality_customer_group_ids_array = [];
        $hotel_hospitality_customer_group_ids = 0;
        $hotel_hospitality_customer_group_ids_array = [];
        $banquet_hospitality_customer_group_ids = 0;
        $banquet_hospitality_customer_group_ids_array = [];
        $PrePaid_customer_group_ids = 0;
        $PrePaid_customer_group_ids_array = [];
        $food_categories_ids = 0;
        $food_categories_ids_array = [];
        $beverage_categories_ids = 0;
        $beverage_categories_ids_array = [];
        $broken_categories_ids = 0;
        $broken_categories_ids_array = [];
        $shisha_categories_ids = 0;
        $shisha_categories_ids_array = [];
        $other_categories_ids = 0;
        $other_categories_ids_array = [];
        $market_categories_ids = 0;
        $market_categories_ids_array = [];
        $activities_categories_ids = 0;
        $activities_categories_ids_array = [];
        $security_categories_ids = 0;
        $security_categories_ids_array = [];
        $laundry_categories_ids = 0;
        $laundry_categories_ids_array = [];
        $hairdresser_categories_ids = 0;
        $hairdresser_categories_ids_array = [];
        $animals_categories_ids = 0;    //Administration Department
        $animals_categories_ids_array = [];    //Administration Department
        $employees_purchase_from_warehouse_customer_group_ids = 0;    //Employees Purchase from General or Main Warehouses
        $employees_purchase_from_warehouse_customer_group_ids_array = [];    //Employees Purchase from General or Main Warehouses

        
        foreach ($reports_module_setting as $report_module_setting)
        {
            if($report_module_setting->item == "service_15_tax_id")
                $service_15_tax_id = $report_module_setting->value;
                
            if($report_module_setting->item == "service_25_tax_id")
                $service_25_tax_id = $report_module_setting->value;
                
            if($report_module_setting->item == "general_warehouse_location_id")
                $general_warehouse_location_ids = json_decode($report_module_setting->value);
            
            if($report_module_setting->item == "main_warehouse_location_id")
                $main_warehouse_location_ids = json_decode($report_module_setting->value);
            
            if($report_module_setting->item == "banquet_location_id")
                $banquet_location_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "FB prefix")
                $FB_prefix = $report_module_setting->value;
                
            if($report_module_setting->item == "hotel_room_customer_group_id")
                $hotel_room_customer_group_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "officer_customer_group_id")
                $officer_customer_group_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "companies_customer_group_id")
                $companies_customer_group_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "general_hospitality_customer_group_id")
                $general_hospitality_customer_group_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "hospitality_customer_group_id")
                $hospitality_customer_group_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "hotel_hospitality_customer_group_id")
                $hotel_hospitality_customer_group_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "banquet_hospitality_customer_group_id")
                $banquet_hospitality_customer_group_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "PrePaid_customer_group_id")
                $PrePaid_customer_group_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "food_categories_id")
                $food_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "beverage_categories_id")
                $beverage_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "broken_categories_id")
                $broken_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "shisha_categories_id")
                $shisha_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "other_categories_id")
                $other_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "market_categories_id")
                $market_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "activities_categories_id")
                $activities_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "security_categories_id")
                $security_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "laundry_categories_id")
                $laundry_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "hairdresser_categories_id")
                $hairdresser_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "animals_categories_id")
                $animals_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "employees_purchase_from_warehouse_customer_group_id")
                $employees_purchase_from_warehouse_customer_group_ids = json_decode($report_module_setting->value);
        }
        
        foreach($banquet_location_ids as $banquet_location_id)
        {
            array_push($banquet_location_ids_array , $banquet_location_id->id);
        }
        
        foreach($main_warehouse_location_ids as $main_warehouse_location_id)
        {
            array_push($main_warehouse_location_ids_array , $main_warehouse_location_id->id);
        }
        
        foreach($general_warehouse_location_ids as $general_warehouse_location_id)
        {
            array_push($general_warehouse_location_ids_array , $general_warehouse_location_id->id);
        }

        foreach($hotel_room_customer_group_ids as $hotel_room_customer_group_id)
        {
            array_push($hotel_room_customer_group_ids_array , $hotel_room_customer_group_id->id);
        }
        
        foreach($officer_customer_group_ids as $officer_customer_group_id)
        {
            array_push($officer_customer_group_ids_array , $officer_customer_group_id->id);
        }
        
        foreach($companies_customer_group_ids as $companies_customer_group_id)
        {
            array_push($companies_customer_group_ids_array , $companies_customer_group_id->id);
        }
        
        foreach($general_hospitality_customer_group_ids as $general_hospitality_customer_group_id)
        {
            array_push($general_hospitality_customer_group_ids_array , $general_hospitality_customer_group_id->id);
        }
        
        foreach($hospitality_customer_group_ids as $hospitality_customer_group_id)
        {
            array_push($hospitality_customer_group_ids_array , $hospitality_customer_group_id->id);
        }
        
        foreach($hotel_hospitality_customer_group_ids as $hotel_hospitality_customer_group_id)
        {
            array_push($hotel_hospitality_customer_group_ids_array , $hotel_hospitality_customer_group_id->id);
        }
        
        foreach($banquet_hospitality_customer_group_ids as $banquet_hospitality_customer_group_id)
        {
            array_push($banquet_hospitality_customer_group_ids_array , $banquet_hospitality_customer_group_id->id);
        }
        
        foreach($PrePaid_customer_group_ids as $PrePaid_customer_group_id)
        {
            array_push($PrePaid_customer_group_ids_array , $PrePaid_customer_group_id->id);
        }
        
        foreach($food_categories_ids as $food_categories_id)
        {
            array_push($food_categories_ids_array , $food_categories_id->id);
        }
        
        foreach($beverage_categories_ids as $beverage_categories_id)
        {
            array_push($beverage_categories_ids_array , $beverage_categories_id->id);
        }
        
        foreach($broken_categories_ids as $broken_categories_id)
        {
            array_push($broken_categories_ids_array , $broken_categories_id->id);
        }
        
        foreach($shisha_categories_ids as $shisha_categories_id)
        {
            array_push($shisha_categories_ids_array , $shisha_categories_id->id);
        }
        
        foreach($other_categories_ids as $other_categories_id)
        {
            array_push($other_categories_ids_array , $other_categories_id->id);
        }
        
        foreach($market_categories_ids as $market_categories_id)
        {
            array_push($market_categories_ids_array , $market_categories_id->id);
        }
        
        foreach($activities_categories_ids as $activities_categories_ids)
        {
            array_push($activities_categories_ids_array , $activities_categories_ids->id);
        }
        
        foreach($security_categories_ids as $security_categories_id)
        {
            array_push($security_categories_ids_array , $security_categories_id->id);
        }
        
        foreach($laundry_categories_ids as $laundry_categories_id)
        {
            array_push($laundry_categories_ids_array , $laundry_categories_id->id);
        }
        
        foreach($hairdresser_categories_ids as $hairdresser_categories_id)
        {
            array_push($hairdresser_categories_ids_array , $hairdresser_categories_id->id);
        }
        
        foreach($animals_categories_ids as $animals_categories_id)
        {
            array_push($animals_categories_ids_array , $animals_categories_id->id);
        }
        
        foreach($employees_purchase_from_warehouse_customer_group_ids as $employees_purchase_from_warehouse_customer_group_id)
        {
            array_push($employees_purchase_from_warehouse_customer_group_ids_array , $employees_purchase_from_warehouse_customer_group_id->id);
        }

    
    // Sending locations according to login user
    $user = Auth::user();
    $business_id = $user->business_id;
    $permitted_locations = $user->permitted_locations($business_id);
    $filters = request()->only([
            'location_id', 'location_type', 'ratio_filter', 'start_date' , 'end_date' ,
            'not_for_selling', 'is_inactive', 'search', 'managed_stock', 'per_page','page', 'category_id' , 'sub_category_id'
        ]);

    $transactions = DB::table('transactions as t')
                ->select(
                    DB::raw(' t.id as transaction_id '),
                    // DB::raw(' DATE(t.transaction_date) as transaction_date '),
                    DB::raw(' t.location_id as transaction_location_id '),
                    DB::raw(' t.invoice_no as transaction_invoice_no '),
                    DB::raw(' t.customer_group_id as transaction_customer_group_id '),
                    // DB::raw(' t.contact_id as transaction_contact_id '),
                    // DB::raw(' t.total_before_tax as transaction_total_before_tax '),
                    DB::raw(' t.tax_id as transaction_tax_id ')
                    // DB::raw(' t.tax_amount as transaction_tax_amount '),
                    // DB::raw('IF(t.discount_type = "percentage", (t.discount_amount/100)*t.total_before_tax , t.discount_amount) as transaction_discount_amount'),
                    // DB::raw(' t.final_total as transaction_final_total ')
                    )
                ->leftjoin('business_locations as bl','bl.id', '=', 't.location_id')
                ->where('t.type', '=' , 'sell')
                ->where('t.status', '=' , 'final');


                    // Filters
                if (!empty($filters['location_id']))
                    $transactions->whereIn('t.location_id', explode(',', $filters['location_id']));
                else if ($permitted_locations != 'all')
                    $transactions->whereIn('t.location_id', $permitted_locations);

                if (!empty($filters['location_type']))
                {
                    if($filters['location_type'] == 'null') {
                        $transactions->whereNull('bl.custom_field1');
                    } else {
                        $transactions->whereIn('bl.custom_field1', explode(',', $filters['location_type']));
                    }
                }

                if (!empty($filters['start_date']))
                    $transactions->whereDate('t.transaction_date', '>=', $filters['start_date']);
                if (!empty($filters['end_date']))
                    $transactions->whereDate('t.transaction_date', '<=', $filters['end_date']);

                $transactions = $transactions->get();
    // Defines
    $transactions_data = [];
    $group_a_invoices = [];
    $group_b_invoices = [];
    $group_c_invoices = [];
    $group_d_invoices = [];
    $group_e_invoices = [];
    $group_f_invoices = [];
    $group_g_invoices = [];
    $group_h_invoices = [];
    $group_i_invoices = [];
    $invoices = [];
    $obj = new stdClass;

    // End Defines
    
    /**
     * Get All Sales Transactions
     * 
     * 
     */ 
    // foreach ($transactions as $transaction)
    // {
    //     array_push($transactions_data, (object)[
    //         'transaction_location_id' => $transaction->transaction_location_id,
    //         'transaction_invoice_no' => $transaction->transaction_invoice_no,
    //         'transaction_customer_group_id' => $transaction->transaction_customer_group_id,
    //         'transaction_tax_id' => $transaction->transaction_tax_id,
    //     ]);

    // }
    
    // return($transactions_data);


    /**
     * End Get All Sales Transactions
     * 
     * Filter sales according to report groups
     */
    foreach($transactions as $transaction)
    {
        if ( in_array($transaction->transaction_location_id, $banquet_location_ids_array) )
        {
            array_push($group_g_invoices, (object)[
                'transaction_invoice_no' => $transaction->transaction_invoice_no,
                'transaction_tax_id' => $transaction->transaction_tax_id,
            ]);
        }
        
        elseif ( in_array($transaction->transaction_location_id, $main_warehouse_location_ids_array) )
        {
            array_push($group_h_invoices, (object)[
                'transaction_invoice_no' => $transaction->transaction_invoice_no,
                'transaction_tax_id' => $transaction->transaction_tax_id,
            ]);
        }
        
        elseif ( in_array($transaction->transaction_location_id, $general_warehouse_location_ids_array) )
        {
            array_push($group_i_invoices, (object)[
                'transaction_invoice_no' => $transaction->transaction_invoice_no,
                'transaction_tax_id' => $transaction->transaction_tax_id,
            ]);
        }
        
        elseif ( str_contains($transaction->transaction_invoice_no, $FB_prefix) )
        {
            array_push($group_f_invoices, (object)[
                'transaction_invoice_no' => $transaction->transaction_invoice_no,
                'transaction_tax_id' => $transaction->transaction_tax_id,
            ]);
        }
        
        elseif (!str_contains($transaction->transaction_invoice_no, $FB_prefix) 
        && !in_array( $transaction->transaction_location_id , $banquet_location_ids_array )
        && !in_array($transaction->transaction_location_id , $main_warehouse_location_ids_array )
        && !in_array($transaction->transaction_location_id , $general_warehouse_location_ids_array )
        && ( $transaction->transaction_customer_group_id == null || in_array($transaction->transaction_customer_group_id , $hotel_room_customer_group_ids_array)) ) 
        { 
            array_push($group_a_invoices, (object)[
                'transaction_invoice_no' => $transaction->transaction_invoice_no,
                'transaction_tax_id' => $transaction->transaction_tax_id,
            ]);
        }
        
        elseif ( in_array($transaction->transaction_customer_group_id , $officer_customer_group_ids_array) )
        {
            array_push($group_b_invoices, (object)[
                'transaction_invoice_no' => $transaction->transaction_invoice_no,
                'transaction_tax_id' => $transaction->transaction_tax_id,
            ]);
        }
        
        elseif ( in_array($transaction->transaction_customer_group_id , $companies_customer_group_ids_array) )
        {
            array_push($group_c_invoices, (object)[
                'transaction_invoice_no' => $transaction->transaction_invoice_no,
                'transaction_tax_id' => $transaction->transaction_tax_id,
            ]);
        }
        
        elseif ( in_array($transaction->transaction_customer_group_id , $general_hospitality_customer_group_ids_array) 
        || in_array($transaction->transaction_customer_group_id , $hospitality_customer_group_ids_array) 
        || in_array($transaction->transaction_customer_group_id , $hotel_hospitality_customer_group_ids_array) 
        || in_array($transaction->transaction_customer_group_id , $banquet_hospitality_customer_group_ids_array) )
        {
            array_push($group_d_invoices, (object)[
                'transaction_invoice_no' => $transaction->transaction_invoice_no,
                'transaction_tax_id' => $transaction->transaction_tax_id,
            ]);
        }
        
        elseif ( in_array($transaction->transaction_customer_group_id , $PrePaid_customer_group_ids_array) )
        {
            array_push($group_e_invoices, (object)[
                'transaction_invoice_no' => $transaction->transaction_invoice_no,
                'transaction_tax_id' => $transaction->transaction_tax_id,
            ]);
        }
        
        

    }
        $invoices['group_a_invoices'] = $group_a_invoices;
        $invoices['group_b_invoices'] = $group_b_invoices;
        $invoices['group_c_invoices'] = $group_c_invoices;
        $invoices['group_d_invoices'] = $group_d_invoices;
        $invoices['group_e_invoices'] = $group_e_invoices;
        $invoices['group_f_invoices'] = $group_f_invoices;
        $invoices['group_g_invoices'] = $group_g_invoices;
        $invoices['group_h_invoices'] = $group_h_invoices;
        $invoices['group_i_invoices'] = $group_i_invoices;
        
        return($invoices);


           
        $perPage = 10;
        $skip = 0;
        if(!empty($filters['per_page']))
        {
            if (($filters['per_page']) != -1)
            {
                $perPage = $filters['per_page'];
            }
            else
            {
                 $perPage = count($transactions_data);
            }
        }


        $sells = $this->paginate($transactions_data, $perPage);
        $sells->appends(Arr::except($filters, ['page']));

        $response = ((new PaginatedResourceResponse(CollectionResource::make($sells)))->toResponse(request()));
        $data = $response->getData();
        
      
        
        
        $response->setData($data);
        return $response;


    }


    /**
     * Create a new command instance.
     *
     * @return string
     */
    public function queryToSql($query)
    {
        return vsprintf(str_replace(array('?'), array('\'%s\''), $query->toSql()), $query->getBindings());
    }

    /**
     * The attributes that are mass assignable.
     *
     *
     * @param $items
     * @param int $perPage
     * @param null $page
     * @param array $options
     * @return LengthAwarePaginator
     */
    public function paginate($items, $perPage = 5, $page = null, $options = [])
    {
        $page = $page ?: (Paginator::resolveCurrentPage() ?: 1);
        $items = $items instanceof Collection ? $items : Collection::make($items);
        return new LengthAwarePaginator($items->forPage($page, $perPage), $items->count(), $perPage, $page, $options);
    }
}
