<?php
namespace Modules\ReportsModule\Http\Controllers;

use stdClass;
use App\User;
use App\Category;
use App\Product;
use Exception;
use Illuminate\Database\Query\JoinClause;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Resources\Json\PaginatedResourceResponse;
use Illuminate\Pagination\LengthAwarePaginator;
use Illuminate\Pagination\Paginator;
use Illuminate\Support\Arr;
use Illuminate\Support\Collection;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Modules\Connector\Http\Controllers\Api\ApiController;
use Modules\ReportsModule\Transformers\CollectionResource;
use Illuminate\Support\Str;

class FinanceCalculationsGroupedReportApiController extends ApiController
{
    /**
     * Display a listing of the resource.
     * @return JsonResponse
     * @throws Exception
     */
    public function index()
    {
        
        $reports_module_setting = DB::table('reports_module')
            ->get();
            // return($reports_module_setting);
        
        $service_15_tax_id = 0;
        $service_25_tax_id = 0;
        $banquet_location_ids = 0;
        $banquet_location_ids_array = [];
        $main_warehouse_location_ids = 0;
        $main_warehouse_location_ids_array = [];
        $general_warehouse_location_ids = 0;
        $general_warehouse_location_ids_array = [];
        $FB_prefix = 0;
        // $FB_prefixs_array = [];
        $hotel_room_customer_group_ids = 0;
        $hotel_room_customer_group_ids_array = [];
        $officer_customer_group_ids = 0;
        $officer_customer_group_ids_array = [];
        $companies_customer_group_ids = 0;
        $companies_customer_group_ids_array = [];
        $general_hospitality_customer_group_ids = 0;
        $general_hospitality_customer_group_ids_array = [];
        $hospitality_customer_group_ids = 0;
        $hospitality_customer_group_ids_array = [];
        $hotel_hospitality_customer_group_ids = 0;
        $hotel_hospitality_customer_group_ids_array = [];
        $banquet_hospitality_customer_group_ids = 0;
        $banquet_hospitality_customer_group_ids_array = [];
        $PrePaid_customer_group_ids = 0;
        $PrePaid_customer_group_ids_array = [];
        $food_categories_ids = 0;
        $food_categories_ids_array = [];
        $beverage_categories_ids = 0;
        $beverage_categories_ids_array = [];
        $broken_categories_ids = 0;
        $broken_categories_ids_array = [];
        $shisha_categories_ids = 0;
        $shisha_categories_ids_array = [];
        $other_categories_ids = 0;
        $other_categories_ids_array = [];
        $market_categories_ids = 0;
        $market_categories_ids_array = [];
        $activities_categories_ids = 0;
        $activities_categories_ids_array = [];
        $security_categories_ids = 0;
        $security_categories_ids_array = [];
        $laundry_categories_ids = 0;
        $laundry_categories_ids_array = [];
        $hairdresser_categories_ids = 0;
        $hairdresser_categories_ids_array = [];
        $animals_categories_ids = 0;    //Administration Department
        $animals_categories_ids_array = [];    //Administration Department
        $employees_purchase_from_warehouse_customer_group_ids = 0;    //Employees Purchase from General or Main Warehouses
        $employees_purchase_from_warehouse_customer_group_ids_array = [];    //Employees Purchase from General or Main Warehouses

        
        foreach ($reports_module_setting as $report_module_setting)
        {
            if($report_module_setting->item == "service_15_tax_id")
                $service_15_tax_id = $report_module_setting->value;
                
            if($report_module_setting->item == "service_25_tax_id")
                $service_25_tax_id = $report_module_setting->value;
                
            if($report_module_setting->item == "general_warehouse_location_id")
                $general_warehouse_location_ids = json_decode($report_module_setting->value);
            
            if($report_module_setting->item == "main_warehouse_location_id")
                $main_warehouse_location_ids = json_decode($report_module_setting->value);
            
            if($report_module_setting->item == "banquet_location_id")
                $banquet_location_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "FB prefix")
                $FB_prefix = $report_module_setting->value;
                
            if($report_module_setting->item == "hotel_room_customer_group_id")
                $hotel_room_customer_group_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "officer_customer_group_id")
                $officer_customer_group_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "companies_customer_group_id")
                $companies_customer_group_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "general_hospitality_customer_group_id")
                $general_hospitality_customer_group_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "hospitality_customer_group_id")
                $hospitality_customer_group_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "hotel_hospitality_customer_group_id")
                $hotel_hospitality_customer_group_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "banquet_hospitality_customer_group_id")
                $banquet_hospitality_customer_group_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "PrePaid_customer_group_id")
                $PrePaid_customer_group_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "food_categories_id")
                $food_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "beverage_categories_id")
                $beverage_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "broken_categories_id")
                $broken_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "shisha_categories_id")
                $shisha_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "other_categories_id")
                $other_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "market_categories_id")
                $market_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "activities_categories_id")
                $activities_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "security_categories_id")
                $security_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "laundry_categories_id")
                $laundry_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "hairdresser_categories_id")
                $hairdresser_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "animals_categories_id")
                $animals_categories_ids = json_decode($report_module_setting->value);
                
            if($report_module_setting->item == "employees_purchase_from_warehouse_customer_group_id")
                $employees_purchase_from_warehouse_customer_group_ids = json_decode($report_module_setting->value);
        }
        
        foreach($banquet_location_ids as $banquet_location_id)
        {
            array_push($banquet_location_ids_array , $banquet_location_id->id);
        }
        
        foreach($main_warehouse_location_ids as $main_warehouse_location_id)
        {
            array_push($main_warehouse_location_ids_array , $main_warehouse_location_id->id);
        }
        
        foreach($general_warehouse_location_ids as $general_warehouse_location_id)
        {
            array_push($general_warehouse_location_ids_array , $general_warehouse_location_id->id);
        }

        foreach($hotel_room_customer_group_ids as $hotel_room_customer_group_id)
        {
            array_push($hotel_room_customer_group_ids_array , $hotel_room_customer_group_id->id);
        }
        
        foreach($officer_customer_group_ids as $officer_customer_group_id)
        {
            array_push($officer_customer_group_ids_array , $officer_customer_group_id->id);
        }
        
        foreach($companies_customer_group_ids as $companies_customer_group_id)
        {
            array_push($companies_customer_group_ids_array , $companies_customer_group_id->id);
        }
        
        foreach($general_hospitality_customer_group_ids as $general_hospitality_customer_group_id)
        {
            array_push($general_hospitality_customer_group_ids_array , $general_hospitality_customer_group_id->id);
        }
        
        foreach($hospitality_customer_group_ids as $hospitality_customer_group_id)
        {
            array_push($hospitality_customer_group_ids_array , $hospitality_customer_group_id->id);
        }
        
        foreach($hotel_hospitality_customer_group_ids as $hotel_hospitality_customer_group_id)
        {
            array_push($hotel_hospitality_customer_group_ids_array , $hotel_hospitality_customer_group_id->id);
        }
        
        foreach($banquet_hospitality_customer_group_ids as $banquet_hospitality_customer_group_id)
        {
            array_push($banquet_hospitality_customer_group_ids_array , $banquet_hospitality_customer_group_id->id);
        }
        
        foreach($PrePaid_customer_group_ids as $PrePaid_customer_group_id)
        {
            array_push($PrePaid_customer_group_ids_array , $PrePaid_customer_group_id->id);
        }
        
        foreach($food_categories_ids as $food_categories_id)
        {
            array_push($food_categories_ids_array , $food_categories_id->id);
        }
        
        foreach($beverage_categories_ids as $beverage_categories_id)
        {
            array_push($beverage_categories_ids_array , $beverage_categories_id->id);
        }
        
        foreach($broken_categories_ids as $broken_categories_id)
        {
            array_push($broken_categories_ids_array , $broken_categories_id->id);
        }
        
        foreach($shisha_categories_ids as $shisha_categories_id)
        {
            array_push($shisha_categories_ids_array , $shisha_categories_id->id);
        }
        
        foreach($other_categories_ids as $other_categories_id)
        {
            array_push($other_categories_ids_array , $other_categories_id->id);
        }
        
        foreach($market_categories_ids as $market_categories_id)
        {
            array_push($market_categories_ids_array , $market_categories_id->id);
        }
        
        foreach($activities_categories_ids as $activities_categories_ids)
        {
            array_push($activities_categories_ids_array , $activities_categories_ids->id);
        }
        
        foreach($security_categories_ids as $security_categories_id)
        {
            array_push($security_categories_ids_array , $security_categories_id->id);
        }
        
        foreach($laundry_categories_ids as $laundry_categories_id)
        {
            array_push($laundry_categories_ids_array , $laundry_categories_id->id);
        }
        
        foreach($hairdresser_categories_ids as $hairdresser_categories_id)
        {
            array_push($hairdresser_categories_ids_array , $hairdresser_categories_id->id);
        }
        
        foreach($animals_categories_ids as $animals_categories_id)
        {
            array_push($animals_categories_ids_array , $animals_categories_id->id);
        }
        
        foreach($employees_purchase_from_warehouse_customer_group_ids as $employees_purchase_from_warehouse_customer_group_id)
        {
            array_push($employees_purchase_from_warehouse_customer_group_ids_array , $employees_purchase_from_warehouse_customer_group_id->id);
        }

    
    // Sending locations according to login user
    $user = Auth::user();
    $business_id = $user->business_id;
    $permitted_locations = $user->permitted_locations($business_id);
    $filters = request()->only([
            'location_id', 'location_type', 'ratio_filter', 'start_date' , 'end_date' ,
            'not_for_selling', 'is_inactive', 'search', 'managed_stock', 'per_page','page', 'category_id' , 'sub_category_id'
        ]);

    $transactions = DB::table('transactions as t')
                    ->select(
                        DB::raw(' t.id as transaction_id '),
                        DB::raw(' DATE(t.transaction_date) as transaction_date '),
                        DB::raw(' t.location_id as transaction_location_id '),
                        DB::raw(' t.invoice_no as transaction_invoice_no '),
                        DB::raw(' t.customer_group_id as transaction_customer_group_id '),
                        DB::raw(' t.contact_id as transaction_contact_id '),
                        DB::raw(' t.total_before_tax as transaction_total_before_tax '),
                        DB::raw(' t.tax_id as transaction_tax_id '),
                        DB::raw(' t.tax_amount as transaction_tax_amount '),
                        DB::raw('IF(t.discount_type = "percentage", (t.discount_amount/100)*t.total_before_tax , t.discount_amount) as transaction_discount_amount'),
                        DB::raw(' t.final_total as transaction_final_total ')
                        )
                    ->leftjoin('business_locations as bl','bl.id', '=', 't.location_id')
                    ->where('t.type', '=' , 'sell')
                    // ->where('t.id', 271221)
                    ->where('t.status', '=' , 'final');


                    // Filters
                if (!empty($filters['location_id']))
                    $transactions->whereIn('t.location_id', explode(',', $filters['location_id']));
                else if ($permitted_locations != 'all')
                    $transactions->whereIn('t.location_id', $permitted_locations);

                if (!empty($filters['location_type']))
                {
                    if($filters['location_type'] == 'null') {
                        $transactions->whereNull('bl.custom_field1');
                    } else {
                        $transactions->whereIn('bl.custom_field1', explode(',', $filters['location_type']));
                    }
                }

                if (!empty($filters['start_date']))
                    $transactions->whereDate('t.transaction_date', '>=', $filters['start_date']);
                if (!empty($filters['end_date']))
                    $transactions->whereDate('t.transaction_date', '<=', $filters['end_date']);

                $transactions = $transactions->get();
    // Defines
    $transactions_data = [];
    $group_a = [];
    // $group_a_invoices = [];
    $group_b = [];
    $group_c = [];
    $group_d = [];
    $group_e = [];
    $group_f = [];
    $group_g = [];
    $group_h = [];
    $group_i = [];
    $group_a_final_calculations = [];
    $group_b_final_calculations = [];
    $group_c_final_calculations = [];
    $group_d_final_calculations = [];
    $group_e_final_calculations = [];
    $group_f_final_calculations = [];
    $group_g_final_calculations = [];
    $group_h_final_calculations = [];
    $group_i_final_calculations = [];
    $final_totals = [];
    $finance_calculations = [];
    $final_finance_calculations_data = [];
    $final_finance_calculations = [];
    $obj = new stdClass;

    // End Defines
    
    /**
     * Get All Sales Transactions
     * 
     * 
     */ 
    foreach ($transactions as $transaction)
    {

        $transaction_sell_lines = DB::table('transaction_sell_lines as tsl')
                    ->select(
                        DB::raw(' tsl.product_id as product_id '),
                        DB::raw(' p.category_id as product_category_id '),
                        DB::raw(' p.sub_category_id as product_sub_category_id '),
                        DB::raw(' (tsl.quantity - tsl.quantity_returned) as sell_line_sold_qty '),
                        DB::raw('IF(tsl.line_discount_type = "percentage", (tsl.line_discount_amount/100)*tsl.unit_price_before_discount , tsl.line_discount_amount) as sell_line_discount_amount'),
                        DB::raw(' tsl.tax_id as sell_line_tax_id '),
                        DB::raw(' tsl.item_tax as sell_line_item_tax '),
                        DB::raw(' tsl.unit_price_before_discount as sell_line_unit_price_before_discount ')
                        )
                    ->leftjoin('products as p','p.id', '=', 'tsl.product_id')
                    ->where('tsl.transaction_id', $transaction->transaction_id)
                    ->get();
                    
        $transaction_payment_lines = DB::table('transaction_payments as tpy')
                    ->select(
                        DB::raw(' tpy.is_return as returned '),
                        // DB::raw(' tpy.amount as amount '),
                        DB::raw('IF(tpy.is_return = 1, (tpy.amount)*(-1) , tpy.amount) as amount'),
                        DB::raw(' tpy.method as method ')
                        )
                    ->where('tpy.transaction_id', $transaction->transaction_id)
                    ->get();

        array_push($transactions_data, (object)[
            'transaction_id' => $transaction->transaction_id,
            'transaction_location_id' => $transaction->transaction_location_id,
            'transaction_date' => $transaction->transaction_date,
            'transaction_invoice_no' => $transaction->transaction_invoice_no,
            'transaction_contact_id' => $transaction->transaction_contact_id,
            'transaction_customer_group_id' => $transaction->transaction_customer_group_id,
            'transaction_total_before_tax' => $transaction->transaction_total_before_tax,
            'transaction_tax_id' => $transaction->transaction_tax_id,
            'transaction_tax_amount' => $transaction->transaction_tax_amount,
            'transaction_discount_amount' => $transaction->transaction_discount_amount,
            'transaction_final_total' => $transaction->transaction_final_total,
            'sell_lines' => $transaction_sell_lines,
            'payment_lines' => $transaction_payment_lines,
            
        ]);

    }
    
    // return($transactions_data);


    /**
     * End Get All Sales Transactions
     * 
     * Filter sales according to report groups
     */
    foreach($transactions_data as $transaction_data)
    {
        if ( in_array($transaction_data->transaction_location_id, $banquet_location_ids_array) )
        {
            array_push($group_g,  $transaction_data );
            // return('group G');
        }
        
        elseif ( in_array($transaction_data->transaction_location_id, $main_warehouse_location_ids_array) )
        {
            array_push($group_h,  $transaction_data );
            // return('group H');
        }
        
        elseif ( in_array($transaction_data->transaction_location_id, $general_warehouse_location_ids_array) )
        {
            array_push($group_i,  $transaction_data );
            // return($group_i);
            // return($transaction_data);
            // return('group I');
        }
        
        elseif ( str_contains($transaction_data->transaction_invoice_no, $FB_prefix) )
        {
            array_push($group_f,  $transaction_data );
            // return('group F');
        }
        
        elseif (!str_contains($transaction_data->transaction_invoice_no, $FB_prefix) 
        && !in_array( $transaction_data->transaction_location_id , $banquet_location_ids_array )
        && !in_array($transaction_data->transaction_location_id , $main_warehouse_location_ids_array )
        && !in_array($transaction_data->transaction_location_id , $general_warehouse_location_ids_array )
        && ( $transaction_data->transaction_customer_group_id == null || in_array($transaction_data->transaction_customer_group_id , $hotel_room_customer_group_ids_array)) ) 
        { 
            array_push($group_a,  $transaction_data );
        }
        
        elseif ( in_array($transaction_data->transaction_customer_group_id , $officer_customer_group_ids_array) )
        {
            array_push($group_b,  $transaction_data );
        }
        
        elseif ( in_array($transaction_data->transaction_customer_group_id , $companies_customer_group_ids_array) )
        {
            array_push($group_c,  $transaction_data );
        }
        
        elseif ( in_array($transaction_data->transaction_customer_group_id , $general_hospitality_customer_group_ids_array) 
        || in_array($transaction_data->transaction_customer_group_id , $hospitality_customer_group_ids_array) 
        || in_array($transaction_data->transaction_customer_group_id , $hotel_hospitality_customer_group_ids_array) 
        || in_array($transaction_data->transaction_customer_group_id , $banquet_hospitality_customer_group_ids_array) )
        {
            array_push($group_d,  $transaction_data );
            // return('group D');
        }
        
        elseif ( in_array($transaction_data->transaction_customer_group_id , $PrePaid_customer_group_ids_array) )
        {
            array_push($group_e,  $transaction_data );
            // return('group E');
        }
        
        

    }
            // return($FB_prefix);
            // return($group_b);

    /**
     * End Filter sales according to report groups
     * 
     * Grouping sales in every report group by date
     */
        $group_a_grouped_by_transaction_date = collect($group_a)->groupBy('transaction_date');
        $group_b_grouped_by_transaction_date = collect($group_b)->groupBy('transaction_date');
        $group_c_grouped_by_transaction_date = collect($group_c)->groupBy('transaction_date');
        $group_d_grouped_by_transaction_date = collect($group_d)->groupBy('transaction_date');
        $group_e_grouped_by_transaction_date = collect($group_e)->groupBy('transaction_date');
        $group_f_grouped_by_transaction_date = collect($group_f)->groupBy('transaction_date');
        $group_g_grouped_by_transaction_date = collect($group_g)->groupBy('transaction_date');
        $group_h_grouped_by_transaction_date = collect($group_h)->groupBy('transaction_date');
        $group_i_grouped_by_transaction_date = collect($group_i)->groupBy('transaction_date');
        
            // return($finance_calculations);
            // return($group_a_grouped_by_transaction_date);
    
            /**
             * Define General total variables
             * 
             *
             * 
             */
                $total_food_categories_value = 0 ;
                $total_beverage_categories_value = 0 ;
                $total_broken_categories_value = 0 ;
                $total_shisha_categories_value = 0 ;
                $total_other_categories_value = 0 ;
                $total_market_categories_value = 0 ;
                $total_activities_categories_value = 0 ;
                $total_security_categories_value = 0 ;
                $total_laundry_categories_value = 0 ;
                $total_hairdresser_categories_value = 0 ;
                $total_animals_categories_value = 0 ;
                $total_service_15_tax_amount = 0 ;
                $total_service_10_tax_amount = 0 ;
                $total_transaction_inline_discount_amount = 0 ;
                // $total_sell_line_unit_price_before_discount = 0;
                $total_transaction_discount_amount = 0 ;
                $total_transaction_before_tax = 0 ;
                $total_transaction_final_total = 0 ;
                $total_cash_payment = 0 ;
                $total_card_payment = 0 ;
                $total_other_payment = 0 ;
                $total_due_amount = 0 ;
    
            /**
             * End Define General total variables
             * 
             *
             * 
             */
    
            /**
             * End Grouping sales in every report groups by date
             * 
             * Group A calculations
             *
             * Group A >> One Date
             */
            foreach($group_a_grouped_by_transaction_date as $group_a_one_transaction_date)
            {
            // return($group_a_one_transaction_date);
                $food_categories_value = 0 ;
                $beverage_categories_value = 0 ;
                $broken_categories_value = 0 ;
                $shisha_categories_value = 0 ;
                $other_categories_value = 0 ;
                $market_categories_value = 0 ;
                $activities_categories_value = 0 ;
                $security_categories_value = 0 ;
                $laundry_categories_value = 0 ;
                $hairdresser_categories_value = 0 ;
                $animals_categories_value = 0 ;
                $transaction_total_before_tax = 0 ;
                $service_15_tax_amount = 0 ;
                $service_10_tax_amount = 0 ;
                $service_25_tax_amount = 0 ;
                $transaction_inline_discount_amount = 0 ;
                // $sell_line_unit_price_before_discount = 0;
                $transaction_discount_amount = 0 ;
                // $transaction_final_total_before_tax = 0 ;
                $transaction_final_total = 0 ;
                $hotel_cash_payment = 0 ;
                $hotel_card_payment = 0 ;
                $hotel_other_payment = 0 ;
                $hotel_due_amount = 0 ;
                $cash_payment = 0 ;
                $card_payment = 0 ;
                $other_payment = 0 ;
                $due_amount = 0 ;
                $total_hotel_cash_payment = 0 ;
                $total_hotel_card_payment = 0 ;
                $total_hotel_other_payment = 0 ;
                $total_hotel_due_amount = 0 ;
                $hotel_room_customer_group_transaction_final_total = 0;
                $not_hotel_room_customer_group_transaction_final_total = 0;
                
                    // return($food_categories_id);
                    
                /**
                 * End Group A >> One Date
                 *
                 * Group A >> One Date >> Loop on this day transaction 
                 */
                foreach($group_a_one_transaction_date as $a)
                {
                    // return($a->transaction_tax_id);
                    $transaction_total_before_tax += $a->transaction_total_before_tax;
                    if($a->transaction_tax_id == $service_15_tax_id)
                        $service_15_tax_amount += $a->transaction_tax_amount ;
                    elseif($a->transaction_tax_id == $service_25_tax_id)
                        $service_25_tax_amount += $a->transaction_tax_amount ;
                        
                        // $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                        // $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                        
                    // $total_service_15_tax_amount += $service_15_tax_amount ;
                    // $total_service_10_tax_amount += $service_10_tax_amount;
                        
                    $transaction_discount_amount += $a->transaction_discount_amount ;
                    // $total_transaction_discount_amount = $transaction_discount_amount ;
                    
                    $transaction_final_total += $a->transaction_final_total ;
                    // $total_transaction_final_total = $transaction_final_total ;
                    
// return($a->sell_lines);

                    // array_push($group_a_invoices, (object)[
                    //     'transaction_invoice_no' => $a->transaction_invoice_no,
                    //     'transaction_tax_id' => $a->transaction_tax_id,
                    // ]);
                    
                    /**
                     * Group A >> One Date >> Loop on this day transaction >> loop on this transaction sell lines
                     *
                     *  
                     */
                    foreach($a->sell_lines as $a->sell_line)
                    {
                        $product_category_id = $a->sell_line->product_category_id ;
                        $product_sub_category_id = $a->sell_line->product_sub_category_id ;
                        // return($a->sell_line->product_category_id);
                        
// return($market_categories_ids_array);
                        if( (in_array($product_sub_category_id, $beverage_categories_ids_array )) || (in_array($product_category_id, $beverage_categories_ids_array)) )
                        {
                            $beverage_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                            // $total_beverage_categories_value += $beverage_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $food_categories_ids_array)) || (in_array($product_category_id, $food_categories_ids_array))  || $product_category_id == null )
                        {
                            $food_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                            // $total_food_categories_value += $food_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $broken_categories_ids_array)) || (in_array($product_category_id, $broken_categories_ids_array)) )
                        {
                            $broken_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                            // $total_broken_categories_value += $broken_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $shisha_categories_ids_array)) || (in_array($product_category_id, $shisha_categories_ids_array)) )
                        {
                            $shisha_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                            // $total_shisha_categories_value += $shisha_categories_value ;
                        }
                        
                        elseif( (in_array($product_sub_category_id, $market_categories_ids_array)) || (in_array($product_category_id, $market_categories_ids_array)) )
                        {
                            $market_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                            // $total_market_categories_value += $market_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $activities_categories_ids_array)) || (in_array($product_category_id, $activities_categories_ids_array)) )
                        {
                            $activities_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                            // $total_activities_categories_value += $activities_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $security_categories_ids_array)) || (in_array($product_category_id, $security_categories_ids_array)) )
                        {
                            $security_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                            // $total_security_categories_value += $security_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $laundry_categories_ids_array)) || (in_array($product_category_id, $laundry_categories_ids_array)) )
                        {
                            $laundry_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                            // $total_laundry_categories_value += $laundry_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $hairdresser_categories_ids_array)) || (in_array($product_category_id, $hairdresser_categories_ids_array)) )
                        {
                            $hairdresser_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                            // $total_hairdresser_categories_value += $hairdresser_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $animals_categories_ids_array)) || (in_array($product_category_id, $animals_categories_ids_array)) )
                        {
                            $animals_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                            // $total_animals_categories_value += $animals_categories_value ;
                        }
                        // elseif( (in_array($product_sub_category_id, $other_categories_ids_array)) || (in_array($product_category_id, $other_categories_ids_array)) 
                        elseif( (in_array($product_sub_category_id, $other_categories_ids_array)) || (in_array($product_category_id, $other_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $food_categories_ids_array)) || (!in_array($product_category_id, $food_categories_ids_array))
                             || (!in_array($product_sub_category_id, $beverage_categories_ids_array)) || (!in_array($product_category_id, $beverage_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $broken_categories_ids_array)) || (!in_array($product_category_id, $broken_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $shisha_categories_ids_array)) || (!in_array($product_category_id, $shisha_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $market_categories_ids_array)) || (!in_array($product_category_id, $market_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $activities_categories_ids_array)) || (!in_array($product_category_id, $activities_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $security_categories_ids_array)) || (!in_array($product_category_id, $security_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $laundry_categories_ids_array)) || (!in_array($product_category_id, $laundry_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $hairdresser_categories_ids_array)) || (!in_array($product_category_id, $hairdresser_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $animals_categories_ids_array)) || (!in_array($product_category_id, $animals_categories_ids_array)) 
                             )
                        {
                            $other_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                            // $total_other_categories_value += $other_categories_value ;
                        }
                        
                        if($a->sell_line->sell_line_tax_id == $service_15_tax_id)
                            $service_15_tax_amount += $a->sell_line->sell_line_item_tax * $a->sell_line->sell_line_sold_qty ;
                        if($a->sell_line->sell_line_tax_id == $service_25_tax_id)
                            $service_25_tax_amount += $a->sell_line->sell_line_item_tax * $a->sell_line->sell_line_sold_qty ;
                            
                            // $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                            // $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                            
                            // $total_service_15_tax_amount += $service_15_tax_amount ;
                            // $total_service_10_tax_amount += $service_10_tax_amount ;
                            
                        $transaction_inline_discount_amount += $a->sell_line->sell_line_discount_amount * $a->sell_line->sell_line_sold_qty ;
                        // $total_transaction_inline_discount_amount += $transaction_inline_discount_amount ;
                        
                        
                        // $transaction_final_total_before_tax = $transaction_final_total - ($total_service_15_tax_amount + $total_service_10_tax_amount) ;
                        // $total_transaction_final_total_before_tax = $transaction_final_total_before_tax ;
                        
                        // $total_transaction_before_tax += $transaction_total_before_tax ;
                        // $sell_line_unit_price_before_discount += $a->sell_line->sell_line_unit_price_before_discount * $a->sell_line->sell_line_sold_qty ;
                    }

                    /**
                     * End Group A Right Part Calcualtion
                     *
                     *  Calculate Group A Payments (Left Part)
                     */
            
                    // return($a->transaction_final_total);
                        if( in_array($a->transaction_customer_group_id , $hotel_room_customer_group_ids_array) )
                        {
                            // $hotel_due_amount = 0;
                            foreach($a->payment_lines as $a->payment_line)
                            {
                                if($a->payment_line->method == "cash")
                                {
                                    $hotel_cash_payment += $a->payment_line->amount ;
                                    // return($cash_payment);
                                }
                                elseif($a->payment_line->method == "card")
                                {
                                    $hotel_card_payment += $a->payment_line->amount ;
                                }
                                else
                                {
                                    $hotel_other_payment += $a->payment_line->amount ;
                                }
                            }
                                $hotel_room_customer_group_transaction_final_total += $a->transaction_final_total;
                                $hotel_due_amount = $hotel_room_customer_group_transaction_final_total - ($hotel_cash_payment + $hotel_card_payment + $hotel_other_payment);
                                
                                $total_hotel_cash_payment = $hotel_cash_payment ;
                                $total_hotel_card_payment = $hotel_card_payment ;
                                $total_hotel_other_payment = $hotel_other_payment ;
                                $total_hotel_due_amount = $hotel_due_amount ;
                        }
                        else
                        {
                            foreach($a->payment_lines as $a->payment_line)
                            {
                                if($a->payment_line->method == "cash")
                                {
                                    $cash_payment += $a->payment_line->amount ;
                                }
                                elseif($a->payment_line->method == "card")
                                {
                                    $card_payment += $a->payment_line->amount ;
                                }
                                else
                                {
                                    $other_payment += $a->payment_line->amount ;
                                }
                                
                            }
                            $not_hotel_room_customer_group_transaction_final_total += $a->transaction_final_total;
                            $due_amount = $not_hotel_room_customer_group_transaction_final_total - ($cash_payment + $card_payment + $other_payment);
                            
                        }
                }
                    
                    $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                    $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                    
                    $total_beverage_categories_value += $beverage_categories_value;
                    $total_food_categories_value += $food_categories_value;
                    $total_broken_categories_value += $broken_categories_value;
                    $total_shisha_categories_value += $shisha_categories_value ;
                    $total_market_categories_value += $market_categories_value ;
                    $total_activities_categories_value += $activities_categories_value ;
                    $total_security_categories_value += $security_categories_value ;
                    $total_laundry_categories_value += $laundry_categories_value ;
                    $total_hairdresser_categories_value += $hairdresser_categories_value ;
                    $total_animals_categories_value += $animals_categories_value ;
                    $total_other_categories_value += $other_categories_value ;
                    $total_service_15_tax_amount += $service_15_tax_amount ;
                    $total_service_10_tax_amount += $service_10_tax_amount ;
                    $total_transaction_inline_discount_amount += $transaction_inline_discount_amount ;
                    $total_transaction_before_tax += $transaction_total_before_tax ;
                    $total_transaction_discount_amount += $transaction_discount_amount ;
                    $total_transaction_final_total += $transaction_final_total ;
                    $total_cash_payment += ( $cash_payment + $total_hotel_cash_payment ) ;
                    $total_card_payment += ( $card_payment + $total_hotel_card_payment ) ;
                    $total_other_payment += ( $other_payment + $total_hotel_other_payment ) ;
                    $total_due_amount += ( $due_amount + $total_hotel_due_amount ) ;
                
                /**
                 * End Calculate Group A Payments (Left Part)
                 *
                 * Group A Final Calculation Array
                 */
                // return($service_15_tax_amount);
                // return($group_a_one_transaction_date[0]->transaction_date);
                array_push($group_a_final_calculations, (object)[
                    'transaction_date' => $group_a_one_transaction_date[0]->transaction_date,
                    'food_categories_value' => $food_categories_value,
                    'beverage_categories_value' => round($beverage_categories_value,2),
                    'broken_categories_value' => $broken_categories_value,
                    'shisha_categories_value' => $shisha_categories_value,
                    'other_categories_value' => $other_categories_value,
                    'market_categories_value' => $market_categories_value,
                    'activities_categories_value' => $activities_categories_value,
                    'security_categories_value' => $security_categories_value,
                    'laundry_categories_value' => $laundry_categories_value,
                    'hairdresser_categories_value' => $hairdresser_categories_value,
                    'animals_categories_value' => $animals_categories_value,
                    'transaction_total_before_tax' => $transaction_total_before_tax,
                    'service_15_tax_amount' => $service_15_tax_amount,
                    'service_10_tax_amount' => $service_10_tax_amount,
                    'transaction_inline_discount_amount' => $transaction_inline_discount_amount,
                    'transaction_discount_amount' => $transaction_discount_amount,
                    'transaction_final_total' => $transaction_final_total,
                    'hotel_payments' => [
                        'hotel_cash_payment' => $hotel_cash_payment,
                        'hotel_card_payment' => $hotel_card_payment,
                        'hotel_other_payment' => $hotel_other_payment,
                        'hotel_due_amount' => $hotel_due_amount,
                        ],
                    'other_payments' => [
                        'cash_payment' => $cash_payment,
                        'card_payment' => $card_payment,
                        'other_payment' => $other_payment,
                        'due_amount' => $due_amount,
                        ],
                ]);
            }
            // return($group_a_final_calculations);

            /**
             * End Group A
             *
             * 
             */
    
            /**
             * Group B calculations
             *
             * Group B >> One Date
             */
            foreach($group_b_grouped_by_transaction_date as $group_b_one_transaction_date)
            {
                $food_categories_value = 0 ;
                $beverage_categories_value = 0 ;
                $broken_categories_value = 0 ;
                $shisha_categories_value = 0 ;
                $other_categories_value = 0 ;
                $market_categories_value = 0 ;
                $activities_categories_value = 0 ;
                $security_categories_value = 0 ;
                $laundry_categories_value = 0 ;
                $hairdresser_categories_value = 0 ;
                $animals_categories_value = 0 ;
                $transaction_total_before_tax = 0 ;
                $service_15_tax_amount = 0 ;                 
                $service_10_tax_amount = 0 ;
                $service_25_tax_amount = 0 ;
                $transaction_inline_discount_amount = 0 ;
                // $sell_line_unit_price_before_discount = 0;
                $transaction_discount_amount = 0 ;
                // $transaction_final_total_before_tax = 0 ;
                $transaction_final_total = 0 ;
                $cash_payment = 0 ;
                $card_payment = 0 ;
                $other_payment = 0 ;
                $due_amount = 0 ;

                /**
                 * End Group B >> One Date
                 *
                 * Group B >> One Date >> Loop on this day transaction 
                 */
                foreach($group_b_one_transaction_date as $b)
                {
                    $transaction_total_before_tax += $b->transaction_total_before_tax;
                    if($b->transaction_tax_id == $service_15_tax_id)
                        $service_15_tax_amount += $b->transaction_tax_amount ;
                    elseif($b->transaction_tax_id == $service_25_tax_id)
                        $service_25_tax_amount += $b->transaction_tax_amount ;
// return($service_15_tax_amount);
                        // $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                        // $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                        
                    // $total_service_15_tax_amount += $service_15_tax_amount ;
                    // $total_service_10_tax_amount += $service_10_tax_amount;
                        
                        
                    $transaction_discount_amount += $b->transaction_discount_amount ;
                    // $total_transaction_discount_amount = $transaction_discount_amount ;
                    
                    $transaction_final_total += $b->transaction_final_total ;
                    // $total_transaction_final_total = $transaction_final_total ;
                    
                    
                    /**
                     * Group B >> One Date >> Loop on this day transaction >> loop on this transaction sell lines
                     *
                     *  
                     */
                    foreach($b->sell_lines as $b->sell_line)
                    {
                        $product_category_id = $b->sell_line->product_category_id ;
                        $product_sub_category_id = $b->sell_line->product_sub_category_id ;

                        if( (in_array($product_sub_category_id, $beverage_categories_ids_array )) || (in_array($product_category_id, $beverage_categories_ids_array)) )
                        {
                            $beverage_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                            // $total_beverage_categories_value += $beverage_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $food_categories_ids_array)) || (in_array($product_category_id, $food_categories_ids_array))  || $product_category_id == null )
                        {
                            $food_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                            // $total_food_categories_value += $food_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $broken_categories_ids_array)) || (in_array($product_category_id, $broken_categories_ids_array)) )
                        {
                            $broken_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                            // $total_broken_categories_value += $broken_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $shisha_categories_ids_array)) || (in_array($product_category_id, $shisha_categories_ids_array)) )
                        {
                            $shisha_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                            // $total_shisha_categories_value += $shisha_categories_value ;
                        }
                        
                        elseif( (in_array($product_sub_category_id, $market_categories_ids_array)) || (in_array($product_category_id, $market_categories_ids_array)) )
                        {
                            $market_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                            // $total_market_categories_value += $market_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $activities_categories_ids_array)) || (in_array($product_category_id, $activities_categories_ids_array)) )
                        {
                            $activities_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                            // $total_activities_categories_value += $activities_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $security_categories_ids_array)) || (in_array($product_category_id, $security_categories_ids_array)) )
                        {
                            $security_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                            // $total_security_categories_value += $security_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $laundry_categories_ids_array)) || (in_array($product_category_id, $laundry_categories_ids_array)) )
                        {
                            $laundry_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                            // $total_laundry_categories_value += $laundry_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $hairdresser_categories_ids_array)) || (in_array($product_category_id, $hairdresser_categories_ids_array)) )
                        {
                            $hairdresser_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                            // $total_hairdresser_categories_value += $hairdresser_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $animals_categories_ids_array)) || (in_array($product_category_id, $animals_categories_ids_array)) )
                        {
                            $animals_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                            // $total_animals_categories_value += $animals_categories_value ;
                        }
                        // elseif( (in_array($product_sub_category_id, $other_categories_ids_array)) || (in_array($product_category_id, $other_categories_ids_array)) 
                        elseif( (in_array($product_sub_category_id, $other_categories_ids_array)) || (in_array($product_category_id, $other_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $food_categories_ids_array)) || (!in_array($product_category_id, $food_categories_ids_array))
                             || (!in_array($product_sub_category_id, $beverage_categories_ids_array)) || (!in_array($product_category_id, $beverage_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $broken_categories_ids_array)) || (!in_array($product_category_id, $broken_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $shisha_categories_ids_array)) || (!in_array($product_category_id, $shisha_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $market_categories_ids_array)) || (!in_array($product_category_id, $market_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $activities_categories_ids_array)) || (!in_array($product_category_id, $activities_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $security_categories_ids_array)) || (!in_array($product_category_id, $security_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $laundry_categories_ids_array)) || (!in_array($product_category_id, $laundry_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $hairdresser_categories_ids_array)) || (!in_array($product_category_id, $hairdresser_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $animals_categories_ids_array)) || (!in_array($product_category_id, $animals_categories_ids_array)) 
                             )
                        {
                            $other_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                            // $total_other_categories_value += $other_categories_value ;
                        }
                        if($b->sell_line->sell_line_tax_id == $service_15_tax_id)
                            $service_15_tax_amount += $b->sell_line->sell_line_item_tax * $b->sell_line->sell_line_sold_qty ;
							
                        if($b->sell_line->sell_line_tax_id == $service_25_tax_id)
                            $service_25_tax_amount += $b->sell_line->sell_line_item_tax * $b->sell_line->sell_line_sold_qty ;
                            
                            // $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                            // $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                            
                            // $total_service_15_tax_amount += $service_15_tax_amount ;
                            // $total_service_10_tax_amount += $service_10_tax_amount ;
                            
                        $transaction_inline_discount_amount += $b->sell_line->sell_line_discount_amount * $b->sell_line->sell_line_sold_qty ;
                        // $total_transaction_inline_discount_amount += $transaction_inline_discount_amount ;
                        
                        // $transaction_final_total_before_tax = $transaction_final_total - ($total_service_15_tax_amount + $total_service_10_tax_amount) ;
                        // $total_transaction_final_total_before_tax = $transaction_final_total_before_tax ;
                        
                        // $total_transaction_before_tax += $transaction_total_before_tax ;
                        // $sell_line_unit_price_before_discount += $b->sell_line->sell_line_unit_price_before_discount * $b->sell_line->sell_line_sold_qty ;
                    }
                    
                    /**
                     * End Group B Right Part Calcualtion
                     *
                     *  Calculate Group B Payments (Left Part)
                     */
                    foreach($b->payment_lines as $b->payment_line)
                    {
                        if($b->payment_line->method == "cash")
                        {
                            $cash_payment += $b->payment_line->amount ;
                        }
                        elseif($b->payment_line->method == "card")
                        {
                            $card_payment += $b->payment_line->amount ;
                        }
                        else
                        {
                            $other_payment += $b->payment_line->amount ;
                        }
                        
                    }
                    $due_amount = $transaction_final_total - ($cash_payment + $card_payment + $other_payment);
                    

                }
                    
                    $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                    $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                    
                    $total_beverage_categories_value += $beverage_categories_value;
                    $total_food_categories_value += $food_categories_value;
                    $total_broken_categories_value += $broken_categories_value;
                    $total_shisha_categories_value += $shisha_categories_value ;
                    $total_market_categories_value += $market_categories_value ;
                    $total_activities_categories_value += $activities_categories_value ;
                    $total_security_categories_value += $security_categories_value ;
                    $total_laundry_categories_value += $laundry_categories_value ;
                    $total_hairdresser_categories_value += $hairdresser_categories_value ;
                    $total_animals_categories_value += $animals_categories_value ;
                    $total_other_categories_value += $other_categories_value ;
                    $total_service_15_tax_amount += $service_15_tax_amount ;
                    $total_service_10_tax_amount += $service_10_tax_amount ;
                    $total_transaction_inline_discount_amount += $transaction_inline_discount_amount ;
                    $total_transaction_before_tax += $transaction_total_before_tax ;
                    $total_transaction_discount_amount += $transaction_discount_amount ;
                    $total_transaction_final_total += $transaction_final_total ;
                    $total_cash_payment += $cash_payment ;
                    $total_card_payment += $card_payment ;
                    $total_other_payment += $other_payment ;
                    $total_due_amount += $due_amount ;
                
                /**
                 * End Calculate Group B Payments (Left Part)
                 *
                 * Group B Final Calculation Array
                 */
                array_push($group_b_final_calculations, (object)[
                    'transaction_date' => $group_b_one_transaction_date[0]->transaction_date,
                    'food_categories_value' => $food_categories_value,
                    'beverage_categories_value' => $beverage_categories_value,
                    'broken_categories_value' => $broken_categories_value,
                    'shisha_categories_value' => $shisha_categories_value,
                    'other_categories_value' => $other_categories_value,
                    'market_categories_value' => $market_categories_value,
                    'activities_categories_value' => $activities_categories_value,
                    'security_categories_value' => $security_categories_value,
                    'laundry_categories_value' => $laundry_categories_value,
                    'hairdresser_categories_value' => $hairdresser_categories_value,
                    'animals_categories_value' => $animals_categories_value,
                    'transaction_total_before_tax' => $transaction_total_before_tax,
                    'service_15_tax_amount' => $service_15_tax_amount,
                    'service_10_tax_amount' => $service_10_tax_amount,
                    'transaction_inline_discount_amount' => $transaction_inline_discount_amount,
                    'transaction_discount_amount' => $transaction_discount_amount,
                    'transaction_final_total' => $transaction_final_total,
                    'other_payments' => [
                        'cash_payment' => $cash_payment,
                        'card_payment' => $card_payment,
                        'other_payment' => $other_payment,
                        'due_amount' => $due_amount,
                        ],
                ]);
            }
            // return($group_b_final_calculations);

            /**
             * End Group B
             *
             * 
             */
    
            /**
             * Group C calculations
             *
             * Group C >> One Date
             */
            foreach($group_c_grouped_by_transaction_date as $group_c_one_transaction_date)
            {
                $food_categories_value = 0 ;
                $beverage_categories_value = 0 ;
                $broken_categories_value = 0 ;
                $shisha_categories_value = 0 ;
                $other_categories_value = 0 ;
                $market_categories_value = 0 ;
                $activities_categories_value = 0 ;
                $security_categories_value = 0 ;
                $laundry_categories_value = 0 ;
                $hairdresser_categories_value = 0 ;
                $animals_categories_value = 0 ;
                $transaction_total_before_tax = 0 ;
                $service_15_tax_amount = 0 ;                 
                $service_10_tax_amount = 0 ;
                $service_25_tax_amount = 0 ;
                $transaction_inline_discount_amount = 0 ;
                // $sell_line_unit_price_before_discount = 0;
                $transaction_discount_amount = 0 ;
                // $transaction_final_total_before_tax = 0 ;
                $transaction_final_total = 0 ;
                $cash_payment = 0 ;
                $card_payment = 0 ;
                $other_payment = 0 ;
                $due_amount = 0 ;

                /**
                 * End Group C >> One Date
                 *
                 * Group C >> One Date >> Loop on this day transaction 
                 */
                foreach($group_c_one_transaction_date as $c)
                {
                    $transaction_total_before_tax += $c->transaction_total_before_tax;
                    if($c->transaction_tax_id == $service_15_tax_id)
                        $service_15_tax_amount += $c->transaction_tax_amount ;
                    elseif($c->transaction_tax_id == $service_25_tax_id)
                        $service_25_tax_amount += $c->transaction_tax_amount ;
						
                        // $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                        // $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                        
                    // $total_service_15_tax_amount += $service_15_tax_amount ;
                    // $total_service_10_tax_amount += $service_10_tax_amount;
                    
                    
                    $transaction_discount_amount += $c->transaction_discount_amount ;
                    // $total_transaction_discount_amount = $transaction_discount_amount ;
                    
                    $transaction_final_total += $c->transaction_final_total ;
                    // $total_transaction_final_total = $transaction_final_total ;
                    
                    /**
                     * Group C >> One Date >> Loop on this day transaction >> loop on this transaction sell lines
                     *
                     *  
                     */
                    foreach($c->sell_lines as $c->sell_line)
                    {
                        $product_category_id = $c->sell_line->product_category_id ;
                        $product_sub_category_id = $c->sell_line->product_sub_category_id ;

                        if( (in_array($product_sub_category_id, $beverage_categories_ids_array )) || (in_array($product_category_id, $beverage_categories_ids_array)) )
                        {
                            $beverage_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                            // $total_beverage_categories_value += $beverage_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $food_categories_ids_array)) || (in_array($product_category_id, $food_categories_ids_array))  || $product_category_id == null )
                        {
                            $food_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                            // $total_food_categories_value += $food_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $broken_categories_ids_array)) || (in_array($product_category_id, $broken_categories_ids_array)) )
                        {
                            $broken_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                            // $total_broken_categories_value += $broken_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $shisha_categories_ids_array)) || (in_array($product_category_id, $shisha_categories_ids_array)) )
                        {
                            $shisha_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                            // $total_shisha_categories_value += $shisha_categories_value ;
                        }
                        
                        elseif( (in_array($product_sub_category_id, $market_categories_ids_array)) || (in_array($product_category_id, $market_categories_ids_array)) )
                        {
                            $market_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                            // $total_market_categories_value += $market_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $activities_categories_ids_array)) || (in_array($product_category_id, $activities_categories_ids_array)) )
                        {
                            $activities_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                            // $total_activities_categories_value += $activities_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $security_categories_ids_array)) || (in_array($product_category_id, $security_categories_ids_array)) )
                        {
                            $security_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                            // $total_security_categories_value += $security_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $laundry_categories_ids_array)) || (in_array($product_category_id, $laundry_categories_ids_array)) )
                        {
                            $laundry_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                            // $total_laundry_categories_value += $laundry_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $hairdresser_categories_ids_array)) || (in_array($product_category_id, $hairdresser_categories_ids_array)) )
                        {
                            $hairdresser_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                            // $total_hairdresser_categories_value += $hairdresser_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $animals_categories_ids_array)) || (in_array($product_category_id, $animals_categories_ids_array)) )
                        {
                            $animals_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                            // $total_animals_categories_value += $animals_categories_value ;
                        }
                        // elseif( (in_array($product_sub_category_id, $other_categories_ids_array)) || (in_array($product_category_id, $other_categories_ids_array)) 
                        elseif( (in_array($product_sub_category_id, $other_categories_ids_array)) || (in_array($product_category_id, $other_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $food_categories_ids_array)) || (!in_array($product_category_id, $food_categories_ids_array))
                             || (!in_array($product_sub_category_id, $beverage_categories_ids_array)) || (!in_array($product_category_id, $beverage_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $broken_categories_ids_array)) || (!in_array($product_category_id, $broken_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $shisha_categories_ids_array)) || (!in_array($product_category_id, $shisha_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $market_categories_ids_array)) || (!in_array($product_category_id, $market_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $activities_categories_ids_array)) || (!in_array($product_category_id, $activities_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $security_categories_ids_array)) || (!in_array($product_category_id, $security_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $laundry_categories_ids_array)) || (!in_array($product_category_id, $laundry_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $hairdresser_categories_ids_array)) || (!in_array($product_category_id, $hairdresser_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $animals_categories_ids_array)) || (!in_array($product_category_id, $animals_categories_ids_array)) 
                             )
                        {
                            $other_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                            // $total_other_categories_value += $other_categories_value ;
                        }
                        if($c->sell_line->sell_line_tax_id == $service_15_tax_id)
                            $service_15_tax_amount += $c->sell_line->sell_line_item_tax * $c->sell_line->sell_line_sold_qty ;
							
                        if($c->sell_line->sell_line_tax_id == $service_25_tax_id)
                            $service_25_tax_amount += $c->sell_line->sell_line_item_tax * $c->sell_line->sell_line_sold_qty ;
                            
                            // $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                            // $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                            
                            // $total_service_15_tax_amount += $service_15_tax_amount ;
                            // $total_service_10_tax_amount += $service_10_tax_amount ;
                    
                        $transaction_inline_discount_amount += $c->sell_line->sell_line_discount_amount * $c->sell_line->sell_line_sold_qty ;
                        // $total_transaction_inline_discount_amount += $transaction_inline_discount_amount ;
                        
                        // $transaction_final_total_before_tax = $transaction_final_total - ($total_service_15_tax_amount + $total_service_10_tax_amount) ;
                        // $total_transaction_final_total_before_tax = $transaction_final_total_before_tax ;
                        
                        // $total_transaction_before_tax += $transaction_total_before_tax ;
                        // $sell_line_unit_price_before_discount += $c->sell_line->sell_line_unit_price_before_discount * $c->sell_line->sell_line_sold_qty ;
                    }

                    /**
                     * End Group C Right Part Calcualtion
                     *
                     *  Calculate Group C Payments (Left Part)
                     */
            
                    foreach($c->payment_lines as $c->payment_line)
                    {
                        if($c->payment_line->method == "cash")
                        {
                            $cash_payment += $c->payment_line->amount ;
                        }
                        elseif($c->payment_line->method == "card")
                        {
                            $card_payment += $c->payment_line->amount ;
                        }
                        else
                        {
                            $other_payment += $c->payment_line->amount ;
                        }
                        
                    }
                    $due_amount = $transaction_final_total - ($cash_payment + $card_payment + $other_payment);
                    

                }
                    
                    $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                    $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                    
                    $total_beverage_categories_value += $beverage_categories_value;
                    $total_food_categories_value += $food_categories_value;
                    $total_broken_categories_value += $broken_categories_value;
                    $total_shisha_categories_value += $shisha_categories_value ;
                    $total_market_categories_value += $market_categories_value ;
                    $total_activities_categories_value += $activities_categories_value ;
                    $total_security_categories_value += $security_categories_value ;
                    $total_laundry_categories_value += $laundry_categories_value ;
                    $total_hairdresser_categories_value += $hairdresser_categories_value ;
                    $total_animals_categories_value += $animals_categories_value ;
                    $total_other_categories_value += $other_categories_value ;
                    $total_service_15_tax_amount += $service_15_tax_amount ;
                    $total_service_10_tax_amount += $service_10_tax_amount ;
                    $total_transaction_inline_discount_amount += $transaction_inline_discount_amount ;
                    $total_transaction_before_tax += $transaction_total_before_tax ;
                    $total_transaction_discount_amount += $transaction_discount_amount ;
                    $total_transaction_final_total += $transaction_final_total ;
                    $total_cash_payment += $cash_payment ;
                    $total_card_payment += $card_payment ;
                    $total_other_payment += $other_payment ;
                    $total_due_amount += $due_amount ;
                
                /**
                 * End Calculate Group C Payments (Left Part)
                 *
                 * Group C Final Calculation Array
                 */
                array_push($group_c_final_calculations, (object)[
                    'transaction_date' => $group_c_one_transaction_date[0]->transaction_date,
                    'food_categories_value' => $food_categories_value,
                    'beverage_categories_value' => $beverage_categories_value,
                    'broken_categories_value' => $broken_categories_value,
                    'shisha_categories_value' => $shisha_categories_value,
                    'other_categories_value' => $other_categories_value,
                    'market_categories_value' => $market_categories_value,
                    'activities_categories_value' => $activities_categories_value,
                    'security_categories_value' => $security_categories_value,
                    'laundry_categories_value' => $laundry_categories_value,
                    'hairdresser_categories_value' => $hairdresser_categories_value,
                    'animals_categories_value' => $animals_categories_value,
                    'transaction_total_before_tax' => $transaction_total_before_tax,
                    'service_15_tax_amount' => $service_15_tax_amount,
                    'service_10_tax_amount' => $service_10_tax_amount,
                    'transaction_inline_discount_amount' => $transaction_inline_discount_amount,
                    'transaction_discount_amount' => $transaction_discount_amount,
                    'transaction_final_total' => $transaction_final_total,
                    'other_payments' => [
                        'cash_payment' => $cash_payment,
                        'card_payment' => $card_payment,
                        'other_payment' => $other_payment,
                        'due_amount' => $due_amount,
                        ],
                ]);
            }
            // return($group_c_final_calculations);

            /**
             * End Group C
             *
             * 
             */
    
            /**
             * Group D calculations
             *
             * Group D >> One Date
             */
            foreach($group_d_grouped_by_transaction_date as $group_d_one_transaction_date)
            {
                $food_categories_value = 0 ;
                $beverage_categories_value = 0 ;
                $broken_categories_value = 0 ;
                $shisha_categories_value = 0 ;
                $other_categories_value = 0 ;
                $market_categories_value = 0 ;
                $activities_categories_value = 0 ;
                $security_categories_value = 0 ;
                $laundry_categories_value = 0 ;
                $hairdresser_categories_value = 0 ;
                $animals_categories_value = 0 ;
                $transaction_total_before_tax = 0 ;
                $service_15_tax_amount = 0 ;                 
                $service_10_tax_amount = 0 ;
                $service_25_tax_amount = 0 ;
                $transaction_inline_discount_amount = 0 ;
                // $sell_line_unit_price_before_discount = 0;
                $transaction_discount_amount = 0 ;
                // $transaction_final_total_before_tax = 0 ;
                $transaction_final_total = 0 ;
                $general_hospitality_transaction_final_total = 0 ;
                $hospitality_transaction_final_total = 0 ;
                $hotel_hospitality_transaction_final_total = 0 ;
                $banquet_hospitality_transaction_final_total = 0 ;
                $general_hospitality_cash_payment = 0 ;
                $general_hospitality_card_payment = 0 ;
                $general_hospitality_other_payment = 0 ;
                $general_hospitality = 0 ;
                $hospitality_cash_payment = 0 ;
                $hospitality_card_payment = 0 ;
                $hospitality_other_payment = 0 ;
                $hospitality = 0 ;
                $hotel_hospitality_cash_payment = 0 ;
                $hotel_hospitality_card_payment = 0 ;
                $hotel_hospitality_other_payment = 0 ;
                $hotel_hospitality = 0 ;
                $banquet_hospitality_cash_payment = 0 ;
                $banquet_hospitality_card_payment = 0 ;
                $banquet_hospitality_other_payment = 0 ;
                $banquet_hospitality = 0 ;
                $paid_hospitality = 0 ;
                $total_general_hospitality_card_payment = 0 ;
                $total_general_hospitality_other_payment = 0 ;
                $total_general_hospitality_due_amount = 0 ;
                $total_hospitality_cash_payment = 0 ;
                $total_hospitality_card_payment = 0 ;
                $total_hospitality_other_payment = 0 ;
                $total_hospitality_due_amount = 0 ;
                $total_hotel_hospitality_cash_payment = 0 ;
                $total_hotel_hospitality_card_payment = 0 ;
                $total_hotel_hospitality_other_payment = 0 ;
                $total_hotel_hospitality_due_amount = 0 ;
                $total_banquet_hospitality_cash_payment = 0 ;
                $total_banquet_hospitality_card_payment = 0 ;
                $total_banquet_hospitality_other_payment = 0 ;
                $total_banquet_hospitality_due_amount = 0;
                
                $total_general_hospitality_cash_payment = 0 ;
                $total_general_hospitality_card_payment = 0 ;
                $total_general_hospitality_other_payment = 0 ;
                $total_general_hospitality_due_amount = 0 ;

                /**
                 * End Group D >> One Date
                 *
                 * Group D >> One Date >> Loop on this day transaction 
                 */
                foreach($group_d_one_transaction_date as $d)
                {
                    $transaction_total_before_tax += $d->transaction_total_before_tax;
                    if($d->transaction_tax_id == $service_15_tax_id)
                        $service_15_tax_amount += $d->transaction_tax_amount ;
                    elseif($d->transaction_tax_id == $service_25_tax_id)
                        $service_25_tax_amount += $d->transaction_tax_amount ;
						
                        // $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                        // $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                        
                    // $total_service_15_tax_amount += $service_15_tax_amount ;
                    // $total_service_10_tax_amount += $service_10_tax_amount;
                    
                    
                    $transaction_discount_amount += $d->transaction_discount_amount ;
                    // $total_transaction_discount_amount = $transaction_discount_amount ;
                    
                    $transaction_final_total += $d->transaction_final_total ;
                    // $total_transaction_final_total = $transaction_final_total ;
                    
                    /**
                     * Group D >> One Date >> Loop on this day transaction >> loop on this transaction sell lines
                     *
                     *  
                     */
                    foreach($d->sell_lines as $d->sell_line)
                    {
                        $product_category_id = $d->sell_line->product_category_id ;
                        $product_sub_category_id = $d->sell_line->product_sub_category_id ;

                        if( (in_array($product_sub_category_id, $beverage_categories_ids_array )) || (in_array($product_category_id, $beverage_categories_ids_array)) )
                        {
                            $beverage_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                            // $total_beverage_categories_value += $beverage_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $food_categories_ids_array)) || (in_array($product_category_id, $food_categories_ids_array))  || $product_category_id == null )
                        {
                            $food_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                            // $total_food_categories_value += $food_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $broken_categories_ids_array)) || (in_array($product_category_id, $broken_categories_ids_array)) )
                        {
                            $broken_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                            // $total_broken_categories_value += $broken_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $shisha_categories_ids_array)) || (in_array($product_category_id, $shisha_categories_ids_array)) )
                        {
                            $shisha_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                            // $total_shisha_categories_value += $shisha_categories_value ;
                        }
                        
                        elseif( (in_array($product_sub_category_id, $market_categories_ids_array)) || (in_array($product_category_id, $market_categories_ids_array)) )
                        {
                            $market_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                            // $total_market_categories_value += $market_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $activities_categories_ids_array)) || (in_array($product_category_id, $activities_categories_ids_array)) )
                        {
                            $activities_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                            // $total_activities_categories_value += $activities_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $security_categories_ids_array)) || (in_array($product_category_id, $security_categories_ids_array)) )
                        {
                            $security_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                            // $total_security_categories_value += $security_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $laundry_categories_ids_array)) || (in_array($product_category_id, $laundry_categories_ids_array)) )
                        {
                            $laundry_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                            // $total_laundry_categories_value += $laundry_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $hairdresser_categories_ids_array)) || (in_array($product_category_id, $hairdresser_categories_ids_array)) )
                        {
                            $hairdresser_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                            // $total_hairdresser_categories_value += $hairdresser_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $animals_categories_ids_array)) || (in_array($product_category_id, $animals_categories_ids_array)) )
                        {
                            $animals_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                            // $total_animals_categories_value += $animals_categories_value ;
                        }
                        // elseif( (in_array($product_sub_category_id, $other_categories_ids_array)) || (in_array($product_category_id, $other_categories_ids_array)) 
                        elseif( (in_array($product_sub_category_id, $other_categories_ids_array)) || (in_array($product_category_id, $other_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $food_categories_ids_array)) || (!in_array($product_category_id, $food_categories_ids_array))
                             || (!in_array($product_sub_category_id, $beverage_categories_ids_array)) || (!in_array($product_category_id, $beverage_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $broken_categories_ids_array)) || (!in_array($product_category_id, $broken_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $shisha_categories_ids_array)) || (!in_array($product_category_id, $shisha_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $market_categories_ids_array)) || (!in_array($product_category_id, $market_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $activities_categories_ids_array)) || (!in_array($product_category_id, $activities_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $security_categories_ids_array)) || (!in_array($product_category_id, $security_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $laundry_categories_ids_array)) || (!in_array($product_category_id, $laundry_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $hairdresser_categories_ids_array)) || (!in_array($product_category_id, $hairdresser_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $animals_categories_ids_array)) || (!in_array($product_category_id, $animals_categories_ids_array)) 
                             )
                        {
                            $other_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                            // $total_other_categories_value += $other_categories_value ;
                        }
                        if($d->sell_line->sell_line_tax_id == $service_15_tax_id)
                            $service_15_tax_amount += $d->sell_line->sell_line_item_tax * $d->sell_line->sell_line_sold_qty ;
							
                        if($d->sell_line->sell_line_tax_id == $service_25_tax_id)
                            $service_25_tax_amount += $d->sell_line->sell_line_item_tax * $d->sell_line->sell_line_sold_qty ;
                            
                            // $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                            // $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                            
                            // $total_service_15_tax_amount += $service_15_tax_amount ;
                            // $total_service_10_tax_amount += $service_10_tax_amount ;
                    
                        $transaction_inline_discount_amount += $d->sell_line->sell_line_discount_amount * $d->sell_line->sell_line_sold_qty ;
                        // $total_transaction_inline_discount_amount += $transaction_inline_discount_amount ;
                        
                        // $transaction_final_total_before_tax = $transaction_final_total - ($total_service_15_tax_amount + $total_service_10_tax_amount) ;
                        // $total_transaction_final_total_before_tax = $transaction_final_total_before_tax ;
                        
                        // $total_transaction_before_tax += $transaction_total_before_tax ;
                        // $sell_line_unit_price_before_discount += $d->sell_line->sell_line_unit_price_before_discount * $d->sell_line->sell_line_sold_qty ;
                    }
                    
                    /**
                     * End Group D Right Part Calcualtion
                     *
                     *  Calculate Group D Payments (Left Part)
                     */
            
                    if( in_array( $d->transaction_customer_group_id , $general_hospitality_customer_group_ids_array) )
                        {
                            $general_hospitality_transaction_final_total += $d->transaction_final_total ;
                            foreach($d->payment_lines as $d->payment_line)
                            {
                                if($d->payment_line->method == "cash")
                                {
                                    $general_hospitality_cash_payment += $d->payment_line->amount ;
                                }
                                elseif($d->payment_line->method == "card")
                                {
                                    $general_hospitality_card_payment += $d->payment_line->amount ;
                                }
                                else
                                {
                                    $general_hospitality_other_payment += $d->payment_line->amount ;
                                }
                            }
                                // $paid_hospitality = $general_hospitality_cash_payment + $general_hospitality_card_payment + $general_hospitality_other_payment;
                                $general_hospitality = $general_hospitality_transaction_final_total - ($general_hospitality_cash_payment + $general_hospitality_card_payment + $general_hospitality_other_payment);
                            
                            $total_general_hospitality_cash_payment = $general_hospitality_cash_payment ;
                            $total_general_hospitality_card_payment = $general_hospitality_card_payment ;
                            $total_general_hospitality_other_payment = $general_hospitality_other_payment ;
                            $total_general_hospitality_due_amount = $general_hospitality ;
                        }
                    elseif( in_array( $d->transaction_customer_group_id , $hospitality_customer_group_ids_array) )
                        {
                            $hospitality_transaction_final_total += $d->transaction_final_total ;
                            foreach($d->payment_lines as $d->payment_line)
                            {
                                if($d->payment_line->method == "cash")
                                {
                                    $hospitality_cash_payment += $d->payment_line->amount ;
                                }
                                elseif($d->payment_line->method == "card")
                                {
                                    $hospitality_card_payment += $d->payment_line->amount ;
                                }
                                else
                                {
                                    $hospitality_other_payment += $d->payment_line->amount ;
                                }
                            }
                                // $paid_hospitality += $hospitality_cash_payment + $hospitality_card_payment + $hospitality_other_payment;
                                $hospitality = $hospitality_transaction_final_total - ($hospitality_cash_payment + $hospitality_card_payment + $hospitality_other_payment);
                                    
                            $total_hospitality_cash_payment = $hospitality_cash_payment ;
                            $total_hospitality_card_payment = $hospitality_card_payment ;
                            $total_hospitality_other_payment = $hospitality_other_payment ;
                            $total_hospitality_due_amount = $hospitality ;
                        }
                    elseif( in_array( $d->transaction_customer_group_id , $hotel_hospitality_customer_group_ids_array) )
                        {
                            $hotel_hospitality_transaction_final_total += $d->transaction_final_total ;
                            foreach($d->payment_lines as $d->payment_line)
                            {
                                if($d->payment_line->method == "cash")
                                {
                                    $hotel_hospitality_cash_payment += $d->payment_line->amount ;
                                }
                                elseif($d->payment_line->method == "card")
                                {
                                    $hotel_hospitality_card_payment += $d->payment_line->amount ;
                                }
                                else
                                {
                                    $hotel_hospitality_other_payment += $d->payment_line->amount ;
                                }
                            }
                                // $paid_hospitality += $hotel_hospitality_cash_payment + $hotel_hospitality_card_payment + $hotel_hospitality_other_payment;
                                $hotel_hospitality = $hotel_hospitality_transaction_final_total - ($hotel_hospitality_cash_payment + $hotel_hospitality_card_payment + $hotel_hospitality_other_payment);
                                    
                            $total_hotel_hospitality_cash_payment = $hotel_hospitality_cash_payment ;
                            $total_hotel_hospitality_card_payment = $hotel_hospitality_card_payment ;
                            $total_hotel_hospitality_other_payment = $hotel_hospitality_other_payment ;
                            $total_hotel_hospitality_due_amount = $hotel_hospitality ;
                        }
                    elseif( in_array( $d->transaction_customer_group_id , $banquet_hospitality_customer_group_ids_array) )
                        {
                            $banquet_hospitality_transaction_final_total += $d->transaction_final_total ;
                            foreach($d->payment_lines as $d->payment_line)
                            {
                                if($d->payment_line->method == "cash")
                                {
                                    $banquet_hospitality_cash_payment += $d->payment_line->amount ;
                                }
                                elseif($d->payment_line->method == "card")
                                {
                                    $banquet_hospitality_card_payment += $d->payment_line->amount ;
                                }
                                else
                                {
                                    $banquet_hospitality_other_payment += $d->payment_line->amount ;
                                }
                            }
                                // $paid_hospitality += $banquet_hospitality_cash_payment + $banquet_hospitality_card_payment + $banquet_hospitality_other_payment;
                                $banquet_hospitality = $banquet_hospitality_transaction_final_total - ($banquet_hospitality_cash_payment + $banquet_hospitality_card_payment + $banquet_hospitality_other_payment);

                            $total_banquet_hospitality_cash_payment = $banquet_hospitality_cash_payment ;
                            $total_banquet_hospitality_card_payment = $banquet_hospitality_card_payment ;
                            $total_banquet_hospitality_other_payment = $banquet_hospitality_other_payment ;
                            $total_banquet_hospitality_due_amount = $banquet_hospitality;
                        }
                        
                    $paid_hospitality = ($general_hospitality_cash_payment + $general_hospitality_card_payment + $general_hospitality_other_payment) + ($hospitality_cash_payment + $hospitality_card_payment + $hospitality_other_payment) + ($hotel_hospitality_cash_payment + $hotel_hospitality_card_payment + $hotel_hospitality_other_payment) + ($banquet_hospitality_cash_payment + $banquet_hospitality_card_payment + $banquet_hospitality_other_payment);

                }
                    
                    $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                    $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                    
                    $total_beverage_categories_value += $beverage_categories_value;
                    $total_food_categories_value += $food_categories_value;
                    $total_broken_categories_value += $broken_categories_value;
                    $total_shisha_categories_value += $shisha_categories_value ;
                    $total_market_categories_value += $market_categories_value ;
                    $total_activities_categories_value += $activities_categories_value ;
                    $total_security_categories_value += $security_categories_value ;
                    $total_laundry_categories_value += $laundry_categories_value ;
                    $total_hairdresser_categories_value += $hairdresser_categories_value ;
                    $total_animals_categories_value += $animals_categories_value ;
                    $total_other_categories_value += $other_categories_value ;
                    $total_service_15_tax_amount += $service_15_tax_amount ;
                    $total_service_10_tax_amount += $service_10_tax_amount ;
                    $total_transaction_inline_discount_amount += $transaction_inline_discount_amount ;
                    $total_transaction_before_tax += $transaction_total_before_tax ;
                    $total_transaction_discount_amount += $transaction_discount_amount ;
                    $total_transaction_final_total += $transaction_final_total ;
                    $total_cash_payment += ($total_general_hospitality_cash_payment + $total_hospitality_cash_payment + $total_hotel_hospitality_cash_payment + $total_banquet_hospitality_cash_payment);
                    $total_card_payment += ($total_general_hospitality_card_payment + $total_hospitality_card_payment + $total_hotel_hospitality_card_payment + $total_banquet_hospitality_card_payment);
                    $total_other_payment += ($total_general_hospitality_other_payment + $total_hospitality_other_payment + $total_hotel_hospitality_other_payment + $total_banquet_hospitality_other_payment);
                    $total_due_amount += ($total_general_hospitality_due_amount + $total_hospitality_due_amount + $total_hotel_hospitality_due_amount + $total_banquet_hospitality_due_amount);
                
                /**
                 * End Calculate Group D Payments (Left Part)
                 *
                 * Group D Final Calculation Array
                 */
                array_push($group_d_final_calculations, (object)[
                    'transaction_date' => $group_d_one_transaction_date[0]->transaction_date,
                    'food_categories_value' => $food_categories_value,
                    'beverage_categories_value' => $beverage_categories_value,
                    'broken_categories_value' => $broken_categories_value,
                    'shisha_categories_value' => $shisha_categories_value,
                    'other_categories_value' => $other_categories_value,
                    'market_categories_value' => $market_categories_value,
                    'activities_categories_value' => $activities_categories_value,
                    'security_categories_value' => $security_categories_value,
                    'laundry_categories_value' => $laundry_categories_value,
                    'hairdresser_categories_value' => $hairdresser_categories_value,
                    'animals_categories_value' => $animals_categories_value,
                    'transaction_total_before_tax' => $transaction_total_before_tax,
                    'service_15_tax_amount' => $service_15_tax_amount,
                    'service_10_tax_amount' => $service_10_tax_amount,
                    'transaction_inline_discount_amount' => $transaction_inline_discount_amount,
                    'transaction_discount_amount' => $transaction_discount_amount,
                    'transaction_final_total' => $transaction_final_total,
                    'other_payments' => [
                        'general_hospitality' => $general_hospitality ,
                        'hospitality' => $hospitality,
                        'hotel_hospitality' => $hotel_hospitality,
                        'banquet_hospitality' => $banquet_hospitality,
                        'paid_hospitality' => $paid_hospitality,
                        ],
                ]);
            }
            // return($group_d_final_calculations);

            /**
             * End Group D
             *
             * 
             */
    
            /**
             * Group E calculations
             *
             * Group E >> One Date
             */
            foreach($group_e_grouped_by_transaction_date as $group_e_one_transaction_date)
            {
                $food_categories_value = 0 ;
                $beverage_categories_value = 0 ;
                $broken_categories_value = 0 ;
                $shisha_categories_value = 0 ;
                $other_categories_value = 0 ;
                $market_categories_value = 0 ;
                $activities_categories_value = 0 ;
                $security_categories_value = 0 ;
                $laundry_categories_value = 0 ;
                $hairdresser_categories_value = 0 ;
                $animals_categories_value = 0 ;
                $transaction_total_before_tax = 0 ;
                $service_15_tax_amount = 0 ;                 
                $service_10_tax_amount = 0 ;
                $service_25_tax_amount = 0 ;
                $transaction_inline_discount_amount = 0 ;
                // $sell_line_unit_price_before_discount = 0;
                $transaction_discount_amount = 0 ;
                // $transaction_final_total_before_tax = 0 ;
                $transaction_final_total = 0 ;
                $prepaid_transaction_final_total = 0 ;
                $prepaid = 0 ;
                $paid_prepaid = 0 ;

                /**
                 * End Group D >> One Date
                 *
                 * Group D >> One Date >> Loop on this day transaction 
                 */
                foreach($group_e_one_transaction_date as $e)
                {
                    $transaction_total_before_tax += $e->transaction_total_before_tax;
                    if($e->transaction_tax_id == $service_15_tax_id)
                        $service_15_tax_amount += $e->transaction_tax_amount ;
                    elseif($e->transaction_tax_id == $service_25_tax_id)
                        $service_25_tax_amount += $e->transaction_tax_amount ;
						
                        // $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                        // $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                        
                    // $total_service_15_tax_amount += $service_15_tax_amount ;
                    // $total_service_10_tax_amount += $service_10_tax_amount;
                    
                    
                    $transaction_discount_amount += $e->transaction_discount_amount ;
                    // $total_transaction_discount_amount = $transaction_discount_amount ;

                    $transaction_final_total += $e->transaction_final_total ;
                    // $total_transaction_final_total = $transaction_final_total ;
                    
                    /**
                     * Group D >> One Date >> Loop on this day transaction >> loop on this transaction sell lines
                     *
                     *  
                     */
                    foreach($e->sell_lines as $e->sell_line)
                    {
                        $product_category_id = $e->sell_line->product_category_id ;
                        $product_sub_category_id = $e->sell_line->product_sub_category_id ;

                        if( (in_array($product_sub_category_id, $beverage_categories_ids_array )) || (in_array($product_category_id, $beverage_categories_ids_array)) )
                        {
                            $beverage_categories_value += ( $e->sell_line->sell_line_unit_price_before_discount - $e->sell_line->sell_line_discount_amount ) * ($e->sell_line->sell_line_sold_qty)  ;
                            // $total_beverage_categories_value += $beverage_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $food_categories_ids_array)) || (in_array($product_category_id, $food_categories_ids_array))  || $product_category_id == null )
                        {
                            $food_categories_value += ( $e->sell_line->sell_line_unit_price_before_discount - $e->sell_line->sell_line_discount_amount ) * ($e->sell_line->sell_line_sold_qty)  ;
                            // $total_food_categories_value += $food_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $broken_categories_ids_array)) || (in_array($product_category_id, $broken_categories_ids_array)) )
                        {
                            $broken_categories_value += ( $e->sell_line->sell_line_unit_price_before_discount - $e->sell_line->sell_line_discount_amount ) * ($e->sell_line->sell_line_sold_qty)  ;
                            // $total_broken_categories_value += $broken_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $shisha_categories_ids_array)) || (in_array($product_category_id, $shisha_categories_ids_array)) )
                        {
                            $shisha_categories_value += ( $e->sell_line->sell_line_unit_price_before_discount - $e->sell_line->sell_line_discount_amount ) * ($e->sell_line->sell_line_sold_qty)  ;
                            // $total_shisha_categories_value += $shisha_categories_value ;
                        }
                        
                        elseif( (in_array($product_sub_category_id, $market_categories_ids_array)) || (in_array($product_category_id, $market_categories_ids_array)) )
                        {
                            $market_categories_value += ( $e->sell_line->sell_line_unit_price_before_discount - $e->sell_line->sell_line_discount_amount ) * ($e->sell_line->sell_line_sold_qty)  ;
                            // $total_market_categories_value += $market_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $activities_categories_ids_array)) || (in_array($product_category_id, $activities_categories_ids_array)) )
                        {
                            $activities_categories_value += ( $e->sell_line->sell_line_unit_price_before_discount - $e->sell_line->sell_line_discount_amount ) * ($e->sell_line->sell_line_sold_qty)  ;
                            // $total_activities_categories_value += $activities_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $security_categories_ids_array)) || (in_array($product_category_id, $security_categories_ids_array)) )
                        {
                            $security_categories_value += ( $e->sell_line->sell_line_unit_price_before_discount - $e->sell_line->sell_line_discount_amount ) * ($e->sell_line->sell_line_sold_qty)  ;
                            // $total_security_categories_value += $security_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $laundry_categories_ids_array)) || (in_array($product_category_id, $laundry_categories_ids_array)) )
                        {
                            $laundry_categories_value += ( $e->sell_line->sell_line_unit_price_before_discount - $e->sell_line->sell_line_discount_amount ) * ($e->sell_line->sell_line_sold_qty)  ;
                            // $total_laundry_categories_value += $laundry_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $hairdresser_categories_ids_array)) || (in_array($product_category_id, $hairdresser_categories_ids_array)) )
                        {
                            $hairdresser_categories_value += ( $e->sell_line->sell_line_unit_price_before_discount - $e->sell_line->sell_line_discount_amount ) * ($e->sell_line->sell_line_sold_qty)  ;
                            // $total_hairdresser_categories_value += $hairdresser_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $animals_categories_ids_array)) || (in_array($product_category_id, $animals_categories_ids_array)) )
                        {
                            $animals_categories_value += ( $e->sell_line->sell_line_unit_price_before_discount - $e->sell_line->sell_line_discount_amount ) * ($e->sell_line->sell_line_sold_qty)  ;
                            // $total_animals_categories_value += $animals_categories_value ;
                        }
                        // elseif( (in_array($product_sub_category_id, $other_categories_ids_array)) || (in_array($product_category_id, $other_categories_ids_array)) 
                        elseif( (in_array($product_sub_category_id, $other_categories_ids_array)) || (in_array($product_category_id, $other_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $food_categories_ids_array)) || (!in_array($product_category_id, $food_categories_ids_array))
                             || (!in_array($product_sub_category_id, $beverage_categories_ids_array)) || (!in_array($product_category_id, $beverage_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $broken_categories_ids_array)) || (!in_array($product_category_id, $broken_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $shisha_categories_ids_array)) || (!in_array($product_category_id, $shisha_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $market_categories_ids_array)) || (!in_array($product_category_id, $market_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $activities_categories_ids_array)) || (!in_array($product_category_id, $activities_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $security_categories_ids_array)) || (!in_array($product_category_id, $security_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $laundry_categories_ids_array)) || (!in_array($product_category_id, $laundry_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $hairdresser_categories_ids_array)) || (!in_array($product_category_id, $hairdresser_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $animals_categories_ids_array)) || (!in_array($product_category_id, $animals_categories_ids_array)) 
                             )
                        {
                            $other_categories_value += ( $e->sell_line->sell_line_unit_price_before_discount - $e->sell_line->sell_line_discount_amount ) * ($e->sell_line->sell_line_sold_qty)  ;
                            // $total_other_categories_value += $other_categories_value ;
                        }
                        if($e->sell_line->sell_line_tax_id == $service_15_tax_id)
                            $service_15_tax_amount += $e->sell_line->sell_line_item_tax * $e->sell_line->sell_line_sold_qty ;
							
                        if($e->sell_line->sell_line_tax_id == $service_25_tax_id)
                            $service_25_tax_amount += $e->sell_line->sell_line_item_tax * $e->sell_line->sell_line_sold_qty ;
                            
                            // $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                            // $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                            
                            // $total_service_15_tax_amount += $service_15_tax_amount ;
                            // $total_service_10_tax_amount += $service_10_tax_amount ;
                    
                        $transaction_inline_discount_amount += $e->sell_line->sell_line_discount_amount * $e->sell_line->sell_line_sold_qty ;
                        // $total_transaction_inline_discount_amount += $transaction_inline_discount_amount ;
                        
                        // $transaction_final_total_before_tax = $transaction_final_total - ($total_service_15_tax_amount + $total_service_10_tax_amount) ;
                        // $total_transaction_final_total_before_tax = $transaction_final_total_before_tax ;
                        
                        // $total_transaction_before_tax += $transaction_total_before_tax ;
                        // $sell_line_unit_price_before_discount += $e->sell_line->sell_line_unit_price_before_discount * $e->sell_line->sell_line_sold_qty ;
                    }
            
                    /**
                     * End Group D Right Part Calcualtion
                     *
                     *  Calculate Group D Payments (Left Part)
                     */
            
                    $prepaid_transaction_final_total += $e->transaction_final_total ;
                    foreach($e->payment_lines as $e->payment_line)
                    {
                        if($e->payment_line->method == "cash")
                        {
                            $cash_payment += $e->payment_line->amount ;
                        }
                        elseif($e->payment_line->method == "card")
                        {
                            $card_payment += $e->payment_line->amount ;
                        }
                        else
                        {
                            $other_payment += $e->payment_line->amount ;
                        }
                    }
                    $paid_prepaid = $cash_payment + $card_payment + $other_payment ;
                    $due_prepaid = $prepaid_transaction_final_total - ($paid_prepaid);
                    
                }
                    
                    $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                    $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                    
                    $total_beverage_categories_value += $beverage_categories_value;
                    $total_food_categories_value += $food_categories_value;
                    $total_broken_categories_value += $broken_categories_value;
                    $total_shisha_categories_value += $shisha_categories_value ;
                    $total_market_categories_value += $market_categories_value ;
                    $total_activities_categories_value += $activities_categories_value ;
                    $total_security_categories_value += $security_categories_value ;
                    $total_laundry_categories_value += $laundry_categories_value ;
                    $total_hairdresser_categories_value += $hairdresser_categories_value ;
                    $total_animals_categories_value += $animals_categories_value ;
                    $total_other_categories_value += $other_categories_value ;
                    $total_service_15_tax_amount += $service_15_tax_amount ;
                    $total_service_10_tax_amount += $service_10_tax_amount ;
                    $total_transaction_inline_discount_amount += $transaction_inline_discount_amount ;
                    $total_transaction_before_tax += $transaction_total_before_tax ;
                    $total_transaction_discount_amount += $transaction_discount_amount ;
                    $total_transaction_final_total += $transaction_final_total ;
                    $total_cash_payment += $cash_payment ;
                    $total_card_payment += $card_payment ;
                    $total_other_payment += $other_payment ;
                    $total_due_amount += $due_prepaid ;
                
                /**
                 * End Calculate Group E Payments (Left Part)
                 *
                 * Group E Final Calculation Array
                 */
                array_push($group_e_final_calculations, (object)[
                    'transaction_date' => $group_e_one_transaction_date[0]->transaction_date,
                    'food_categories_value' => $food_categories_value,
                    'beverage_categories_value' => $beverage_categories_value,
                    'broken_categories_value' => $broken_categories_value,
                    'shisha_categories_value' => $shisha_categories_value,
                    'other_categories_value' => $other_categories_value,
                    'market_categories_value' => $market_categories_value,
                    'activities_categories_value' => $activities_categories_value,
                    'security_categories_value' => $security_categories_value,
                    'laundry_categories_value' => $laundry_categories_value,
                    'hairdresser_categories_value' => $hairdresser_categories_value,
                    'animals_categories_value' => $animals_categories_value,
                    'transaction_total_before_tax' => $transaction_total_before_tax,
                    'service_15_tax_amount' => $service_15_tax_amount,
                    'service_10_tax_amount' => $service_10_tax_amount,
                    'transaction_inline_discount_amount' => $transaction_inline_discount_amount,
                    'transaction_discount_amount' => $transaction_discount_amount,
                    'transaction_final_total' => $transaction_final_total,
                    'other_payments' => [
                        'due_prepaid' => $due_prepaid ,
                        'paid_prepaid' => $paid_prepaid,
                        ],
                ]);
            }
            // return($group_e_final_calculations);

            /**
             * End Group E
             *
             * 
             */
    
            /**
             * Group F calculations
             *
             * Group F >> One Date
             */
            foreach($group_f_grouped_by_transaction_date as $group_f_one_transaction_date)
            {
                $food_categories_value = 0 ;
                $beverage_categories_value = 0 ;
                $broken_categories_value = 0 ;
                $shisha_categories_value = 0 ;
                $other_categories_value = 0 ;
                $market_categories_value = 0 ;
                $activities_categories_value = 0 ;
                $security_categories_value = 0 ;
                $laundry_categories_value = 0 ;
                $hairdresser_categories_value = 0 ;
                $animals_categories_value = 0 ;
                $transaction_total_before_tax = 0 ;
                $service_15_tax_amount = 0 ;                 
                $service_10_tax_amount = 0 ;
                $service_25_tax_amount = 0 ;
                $transaction_inline_discount_amount = 0 ;
                // $sell_line_unit_price_before_discount = 0;
                $transaction_discount_amount = 0 ;
                // $transaction_final_total_before_tax = 0 ;
                $transaction_final_total = 0 ;
                $cash_payment = 0 ;
                $card_payment = 0 ;
                $other_payment = 0 ;
                $due_amount = 0 ;

                /**
                 * End Group F >> One Date
                 *
                 * Group F >> One Date >> Loop on this day transaction 
                 */
                foreach($group_f_one_transaction_date as $f)
                {
                    $transaction_total_before_tax += $f->transaction_total_before_tax;
                    if($f->transaction_tax_id == $service_15_tax_id)
                        $service_15_tax_amount += $f->transaction_tax_amount ;
                    elseif($f->transaction_tax_id == $service_25_tax_id)
                        $service_25_tax_amount += $f->transaction_tax_amount ;
						
                        // $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                        // $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                        
                    // $total_service_15_tax_amount += $service_15_tax_amount ;
                    // $total_service_10_tax_amount += $service_10_tax_amount;
                    
                    
                    $transaction_discount_amount += $f->transaction_discount_amount ;
                    // $total_transaction_discount_amount = $transaction_discount_amount ;

                    $transaction_final_total += $f->transaction_final_total ;
                    // $total_transaction_final_total = $transaction_final_total ;
                    
                    /**
                     * Group F >> One Date >> Loop on this day transaction >> loop on this transaction sell lines
                     *
                     *  
                     */
                    foreach($f->sell_lines as $f->sell_line)
                    {
                        $product_category_id = $f->sell_line->product_category_id ;
                        $product_sub_category_id = $f->sell_line->product_sub_category_id ;

                        if( (in_array($product_sub_category_id, $beverage_categories_ids_array )) || (in_array($product_category_id, $beverage_categories_ids_array)) )
                        {
                            $beverage_categories_value += ( $f->sell_line->sell_line_unit_price_before_discount - $f->sell_line->sell_line_discount_amount ) * ($f->sell_line->sell_line_sold_qty)  ;
                            // $total_beverage_categories_value += $beverage_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $food_categories_ids_array)) || (in_array($product_category_id, $food_categories_ids_array))  || $product_category_id == null )
                        {
                            $food_categories_value += ( $f->sell_line->sell_line_unit_price_before_discount - $f->sell_line->sell_line_discount_amount ) * ($f->sell_line->sell_line_sold_qty)  ;
                            // $total_food_categories_value += $food_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $broken_categories_ids_array)) || (in_array($product_category_id, $broken_categories_ids_array)) )
                        {
                            $broken_categories_value += ( $f->sell_line->sell_line_unit_price_before_discount - $f->sell_line->sell_line_discount_amount ) * ($f->sell_line->sell_line_sold_qty)  ;
                            // $total_broken_categories_value += $broken_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $shisha_categories_ids_array)) || (in_array($product_category_id, $shisha_categories_ids_array)) )
                        {
                            $shisha_categories_value += ( $f->sell_line->sell_line_unit_price_before_discount - $f->sell_line->sell_line_discount_amount ) * ($f->sell_line->sell_line_sold_qty)  ;
                            // $total_shisha_categories_value += $shisha_categories_value ;
                        }
                        
                        elseif( (in_array($product_sub_category_id, $market_categories_ids_array)) || (in_array($product_category_id, $market_categories_ids_array)) )
                        {
                            $market_categories_value += ( $f->sell_line->sell_line_unit_price_before_discount - $f->sell_line->sell_line_discount_amount ) * ($f->sell_line->sell_line_sold_qty)  ;
                            // $total_market_categories_value += $market_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $activities_categories_ids_array)) || (in_array($product_category_id, $activities_categories_ids_array)) )
                        {
                            $activities_categories_value += ( $f->sell_line->sell_line_unit_price_before_discount - $f->sell_line->sell_line_discount_amount ) * ($f->sell_line->sell_line_sold_qty)  ;
                            // $total_activities_categories_value += $activities_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $security_categories_ids_array)) || (in_array($product_category_id, $security_categories_ids_array)) )
                        {
                            $security_categories_value += ( $f->sell_line->sell_line_unit_price_before_discount - $f->sell_line->sell_line_discount_amount ) * ($f->sell_line->sell_line_sold_qty)  ;
                            // $total_security_categories_value += $security_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $laundry_categories_ids_array)) || (in_array($product_category_id, $laundry_categories_ids_array)) )
                        {
                            $laundry_categories_value += ( $f->sell_line->sell_line_unit_price_before_discount - $f->sell_line->sell_line_discount_amount ) * ($f->sell_line->sell_line_sold_qty)  ;
                            // $total_laundry_categories_value += $laundry_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $hairdresser_categories_ids_array)) || (in_array($product_category_id, $hairdresser_categories_ids_array)) )
                        {
                            $hairdresser_categories_value += ( $f->sell_line->sell_line_unit_price_before_discount - $f->sell_line->sell_line_discount_amount ) * ($f->sell_line->sell_line_sold_qty)  ;
                            // $total_hairdresser_categories_value += $hairdresser_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $animals_categories_ids_array)) || (in_array($product_category_id, $animals_categories_ids_array)) )
                        {
                            $animals_categories_value += ( $f->sell_line->sell_line_unit_price_before_discount - $f->sell_line->sell_line_discount_amount ) * ($f->sell_line->sell_line_sold_qty)  ;
                            // $total_animals_categories_value += $animals_categories_value ;
                        }
                        // elseif( (in_array($product_sub_category_id, $other_categories_ids_array)) || (in_array($product_category_id, $other_categories_ids_array)) 
                        elseif( (in_array($product_sub_category_id, $other_categories_ids_array)) || (in_array($product_category_id, $other_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $food_categories_ids_array)) || (!in_array($product_category_id, $food_categories_ids_array))
                             || (!in_array($product_sub_category_id, $beverage_categories_ids_array)) || (!in_array($product_category_id, $beverage_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $broken_categories_ids_array)) || (!in_array($product_category_id, $broken_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $shisha_categories_ids_array)) || (!in_array($product_category_id, $shisha_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $market_categories_ids_array)) || (!in_array($product_category_id, $market_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $activities_categories_ids_array)) || (!in_array($product_category_id, $activities_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $security_categories_ids_array)) || (!in_array($product_category_id, $security_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $laundry_categories_ids_array)) || (!in_array($product_category_id, $laundry_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $hairdresser_categories_ids_array)) || (!in_array($product_category_id, $hairdresser_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $animals_categories_ids_array)) || (!in_array($product_category_id, $animals_categories_ids_array)) 
                             )
                        {
                            $other_categories_value += ( $f->sell_line->sell_line_unit_price_before_discount - $f->sell_line->sell_line_discount_amount ) * ($f->sell_line->sell_line_sold_qty)  ;
                            // $total_other_categories_value += $other_categories_value ;
                        }
                        if($f->sell_line->sell_line_tax_id == $service_15_tax_id)
                            $service_15_tax_amount += $f->sell_line->sell_line_item_tax * $f->sell_line->sell_line_sold_qty ;
							
                        if($f->sell_line->sell_line_tax_id == $service_25_tax_id)
                            $service_25_tax_amount += $f->sell_line->sell_line_item_tax * $f->sell_line->sell_line_sold_qty ;
                            
                            // $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                            // $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                            
                            // $total_service_15_tax_amount += $service_15_tax_amount ;
                            // $total_service_10_tax_amount += $service_10_tax_amount ;
                    
                        $transaction_inline_discount_amount += $f->sell_line->sell_line_discount_amount * $f->sell_line->sell_line_sold_qty ;
                        // $total_transaction_inline_discount_amount += $transaction_inline_discount_amount ;
                        
                        // $transaction_final_total_before_tax = $transaction_final_total - ($total_service_15_tax_amount + $total_service_10_tax_amount) ;
                        // $total_transaction_final_total_before_tax = $transaction_final_total_before_tax ;
                        
                        // $total_transaction_before_tax += $transaction_total_before_tax ;
                        // $sell_line_unit_price_before_discount += $f->sell_line->sell_line_unit_price_before_discount * $f->sell_line->sell_line_sold_qty ;
                    }
                    
                    /**
                     * End Group F Right Part Calcualtion
                     *
                     *  Calculate Group F Payments (Left Part)
                     */
                    foreach($f->payment_lines as $f->payment_line)
                    {
                        if($f->payment_line->method == "cash")
                        {
                            $cash_payment += $f->payment_line->amount ;
                        }
                        elseif($f->payment_line->method == "card")
                        {
                            $card_payment += $f->payment_line->amount ;
                        }
                        else
                        {
                            $other_payment += $f->payment_line->amount ;
                        }
                        
                    }
                    $due_amount = $transaction_final_total - ($cash_payment + $card_payment + $other_payment);

                }
                    
                    $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                    $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                    
                    $total_beverage_categories_value += $beverage_categories_value;
                    $total_food_categories_value += $food_categories_value;
                    $total_broken_categories_value += $broken_categories_value;
                    $total_shisha_categories_value += $shisha_categories_value ;
                    $total_market_categories_value += $market_categories_value ;
                    $total_activities_categories_value += $activities_categories_value ;
                    $total_security_categories_value += $security_categories_value ;
                    $total_laundry_categories_value += $laundry_categories_value ;
                    $total_hairdresser_categories_value += $hairdresser_categories_value ;
                    $total_animals_categories_value += $animals_categories_value ;
                    $total_other_categories_value += $other_categories_value ;
                    $total_service_15_tax_amount += $service_15_tax_amount ;
                    $total_service_10_tax_amount += $service_10_tax_amount ;
                    $total_transaction_inline_discount_amount += $transaction_inline_discount_amount ;
                    $total_transaction_before_tax += $transaction_total_before_tax ;
                    $total_transaction_discount_amount += $transaction_discount_amount ;
                    $total_transaction_final_total += $transaction_final_total ;
                    $total_cash_payment += $cash_payment ;
                    $total_card_payment += $card_payment ;
                    $total_other_payment += $other_payment ;
                    $total_due_amount += $due_amount ;
                
                /**
                 * End Calculate Group F Payments (Left Part)
                 *
                 * Group F Final Calculation Array
                 */
                array_push($group_f_final_calculations, (object)[
                    'transaction_date' => $group_f_one_transaction_date[0]->transaction_date,
                    'food_categories_value' => $food_categories_value,
                    'beverage_categories_value' => $beverage_categories_value,
                    'broken_categories_value' => $broken_categories_value,
                    'shisha_categories_value' => $shisha_categories_value,
                    'other_categories_value' => $other_categories_value,
                    'market_categories_value' => $market_categories_value,
                    'activities_categories_value' => $activities_categories_value,
                    'security_categories_value' => $security_categories_value,
                    'laundry_categories_value' => $laundry_categories_value,
                    'hairdresser_categories_value' => $hairdresser_categories_value,
                    'animals_categories_value' => $animals_categories_value,
                    'transaction_total_before_tax' => $transaction_total_before_tax,
                    'service_15_tax_amount' => $service_15_tax_amount,
                    'service_10_tax_amount' => $service_10_tax_amount,
                    'transaction_inline_discount_amount' => $transaction_inline_discount_amount,
                    'transaction_discount_amount' => $transaction_discount_amount,
                    'transaction_final_total' => $transaction_final_total,
                    'other_payments' => [
                        'cash_payment' => $cash_payment,
                        'card_payment' => $card_payment,
                        'other_payment' => $other_payment,
                        'due_amount' => $due_amount,
                        ],
                ]);
            }
            // return($group_f_final_calculations);

            /**
             * End Group F
             *
             * 
             */    
    
            /**
             * Group G calculations
             *
             * Group G >> One Date
             */
            foreach($group_g_grouped_by_transaction_date as $group_g_one_transaction_date)
            {
                $food_categories_value = 0 ;
                $beverage_categories_value = 0 ;
                $broken_categories_value = 0 ;
                $shisha_categories_value = 0 ;
                $other_categories_value = 0 ;
                $market_categories_value = 0 ;
                $activities_categories_value = 0 ;
                $security_categories_value = 0 ;
                $laundry_categories_value = 0 ;
                $hairdresser_categories_value = 0 ;
                $animals_categories_value = 0 ;
                $transaction_total_before_tax = 0 ;
                $service_15_tax_amount = 0 ;                 
                $service_10_tax_amount = 0 ;
                $service_25_tax_amount = 0 ;
                $transaction_inline_discount_amount = 0 ;
                // $sell_line_unit_price_before_discount = 0;
                $transaction_discount_amount = 0 ;
                // $transaction_final_total_before_tax = 0 ;
                $transaction_final_total = 0 ;
                $cash_payment = 0 ;
                $card_payment = 0 ;
                $other_payment = 0 ;
                $due_amount = 0 ;

                /**
                 * End Group G >> One Date
                 *
                 * Group G >> One Date >> Loop on this day transaction 
                 */
                foreach($group_g_one_transaction_date as $g)
                {
                    $transaction_total_before_tax += $g->transaction_total_before_tax;
                    if($g->transaction_tax_id == $service_15_tax_id)
                        $service_15_tax_amount += $g->transaction_tax_amount ;
                    elseif($g->transaction_tax_id == $service_25_tax_id)
                        $service_25_tax_amount += $g->transaction_tax_amount ;
						
                        // $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                        // $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                        
                    // $total_service_15_tax_amount += $service_15_tax_amount ;
                    // $total_service_10_tax_amount += $service_10_tax_amount;
                    
                    
                    $transaction_discount_amount += $g->transaction_discount_amount ;
                    // $total_transaction_discount_amount = $transaction_discount_amount ;
                    
                    $transaction_final_total += $g->transaction_final_total ;
                    // $total_transaction_final_total = $transaction_final_total ;
                    
                    /**
                     * Group G >> One Date >> Loop on this day transaction >> loop on this transaction sell lines
                     *
                     *  
                     */
                    foreach($g->sell_lines as $g->sell_line)
                    {
                        $product_category_id = $g->sell_line->product_category_id ;
                        $product_sub_category_id = $g->sell_line->product_sub_category_id ;

                        if( (in_array($product_sub_category_id, $beverage_categories_ids_array )) || (in_array($product_category_id, $beverage_categories_ids_array)) )
                        {
                            $beverage_categories_value += ( $g->sell_line->sell_line_unit_price_before_discount - $g->sell_line->sell_line_discount_amount ) * ($g->sell_line->sell_line_sold_qty)  ;
                            // $total_beverage_categories_value += $beverage_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $food_categories_ids_array)) || (in_array($product_category_id, $food_categories_ids_array))  || $product_category_id == null )
                        {
                            $food_categories_value += ( $g->sell_line->sell_line_unit_price_before_discount - $g->sell_line->sell_line_discount_amount ) * ($g->sell_line->sell_line_sold_qty)  ;
                            // $total_food_categories_value += $food_categories_value;

                        }
                        elseif( (in_array($product_sub_category_id, $broken_categories_ids_array)) || (in_array($product_category_id, $broken_categories_ids_array)) )
                        {
                            $broken_categories_value += ( $g->sell_line->sell_line_unit_price_before_discount - $g->sell_line->sell_line_discount_amount ) * ($g->sell_line->sell_line_sold_qty)  ;
                            // $total_broken_categories_value += $broken_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $shisha_categories_ids_array)) || (in_array($product_category_id, $shisha_categories_ids_array)) )
                        {
                            $shisha_categories_value += ( $g->sell_line->sell_line_unit_price_before_discount - $g->sell_line->sell_line_discount_amount ) * ($g->sell_line->sell_line_sold_qty)  ;
                            // $total_shisha_categories_value += $shisha_categories_value ;
                        }
                        
                        elseif( (in_array($product_sub_category_id, $market_categories_ids_array)) || (in_array($product_category_id, $market_categories_ids_array)) )
                        {
                            $market_categories_value += ( $g->sell_line->sell_line_unit_price_before_discount - $g->sell_line->sell_line_discount_amount ) * ($g->sell_line->sell_line_sold_qty)  ;
                            // $total_market_categories_value += $market_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $activities_categories_ids_array)) || (in_array($product_category_id, $activities_categories_ids_array)) )
                        {
                            $activities_categories_value += ( $g->sell_line->sell_line_unit_price_before_discount - $g->sell_line->sell_line_discount_amount ) * ($g->sell_line->sell_line_sold_qty)  ;
                            // $total_activities_categories_value += $activities_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $security_categories_ids_array)) || (in_array($product_category_id, $security_categories_ids_array)) )
                        {
                            $security_categories_value += ( $g->sell_line->sell_line_unit_price_before_discount - $g->sell_line->sell_line_discount_amount ) * ($g->sell_line->sell_line_sold_qty)  ;
                            // $total_security_categories_value += $security_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $laundry_categories_ids_array)) || (in_array($product_category_id, $laundry_categories_ids_array)) )
                        {
                            $laundry_categories_value += ( $g->sell_line->sell_line_unit_price_before_discount - $g->sell_line->sell_line_discount_amount ) * ($g->sell_line->sell_line_sold_qty)  ;
                            // $total_laundry_categories_value += $laundry_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $hairdresser_categories_ids_array)) || (in_array($product_category_id, $hairdresser_categories_ids_array)) )
                        {
                            $hairdresser_categories_value += ( $g->sell_line->sell_line_unit_price_before_discount - $g->sell_line->sell_line_discount_amount ) * ($g->sell_line->sell_line_sold_qty)  ;
                            // $total_hairdresser_categories_value += $hairdresser_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $animals_categories_ids_array)) || (in_array($product_category_id, $animals_categories_ids_array)) )
                        {
                            $animals_categories_value += ( $g->sell_line->sell_line_unit_price_before_discount - $g->sell_line->sell_line_discount_amount ) * ($g->sell_line->sell_line_sold_qty)  ;
                            // $total_animals_categories_value += $animals_categories_value ;
                        }
                        // elseif( (in_array($product_sub_category_id, $other_categories_ids_array)) || (in_array($product_category_id, $other_categories_ids_array)) 
                        elseif( (in_array($product_sub_category_id, $other_categories_ids_array)) || (in_array($product_category_id, $other_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $food_categories_ids_array)) || (!in_array($product_category_id, $food_categories_ids_array))
                             || (!in_array($product_sub_category_id, $beverage_categories_ids_array)) || (!in_array($product_category_id, $beverage_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $broken_categories_ids_array)) || (!in_array($product_category_id, $broken_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $shisha_categories_ids_array)) || (!in_array($product_category_id, $shisha_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $market_categories_ids_array)) || (!in_array($product_category_id, $market_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $activities_categories_ids_array)) || (!in_array($product_category_id, $activities_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $security_categories_ids_array)) || (!in_array($product_category_id, $security_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $laundry_categories_ids_array)) || (!in_array($product_category_id, $laundry_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $hairdresser_categories_ids_array)) || (!in_array($product_category_id, $hairdresser_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $animals_categories_ids_array)) || (!in_array($product_category_id, $animals_categories_ids_array)) 
                             )
                        {
                            $other_categories_value += ( $g->sell_line->sell_line_unit_price_before_discount - $g->sell_line->sell_line_discount_amount ) * ($g->sell_line->sell_line_sold_qty)  ;
                            // $total_other_categories_value += $other_categories_value ;
                        }
                        if($g->sell_line->sell_line_tax_id == $service_15_tax_id)
                            $service_15_tax_amount += $g->sell_line->sell_line_item_tax * $g->sell_line->sell_line_sold_qty ;
							
                        if($g->sell_line->sell_line_tax_id == $service_25_tax_id)
                            $service_25_tax_amount += $g->sell_line->sell_line_item_tax * $g->sell_line->sell_line_sold_qty ;
                            
                            // $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                            // $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                            
                            // $total_service_15_tax_amount += $service_15_tax_amount ;
                            // $total_service_10_tax_amount += $service_10_tax_amount ;
                            
                        $transaction_inline_discount_amount += $g->sell_line->sell_line_discount_amount * $g->sell_line->sell_line_sold_qty ;
                        // $total_transaction_inline_discount_amount += $transaction_inline_discount_amount ;
                        
                        // $transaction_final_total_before_tax = $transaction_final_total - ($total_service_15_tax_amount + $total_service_10_tax_amount) ;
                        // $total_transaction_final_total_before_tax = $transaction_final_total_before_tax ;
                        
                        // $total_transaction_before_tax += $transaction_total_before_tax ;
                        // $sell_line_unit_price_before_discount += $g->sell_line->sell_line_unit_price_before_discount * $g->sell_line->sell_line_sold_qty ;
                    }
                    
                    /**
                     * End Group G Right Part Calcualtion
                     *
                     *  Calculate Group G Payments (Left Part)
                     */
                    foreach($g->payment_lines as $g->payment_line)
                    {
                        if($g->payment_line->method == "cash")
                        {
                            $cash_payment += $g->payment_line->amount ;
                        }
                        elseif($g->payment_line->method == "card")
                        {
                            $card_payment += $g->payment_line->amount ;
                        }
                        else
                        {
                            $other_payment += $g->payment_line->amount ;
                        }
                        
                    }
                    $due_amount = $transaction_final_total - ($cash_payment + $card_payment + $other_payment);

                }
                    
                    $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                    $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                    
                    $total_beverage_categories_value += $beverage_categories_value;
                    $total_food_categories_value += $food_categories_value;
                    $total_broken_categories_value += $broken_categories_value;
                    $total_shisha_categories_value += $shisha_categories_value ;
                    $total_market_categories_value += $market_categories_value ;
                    $total_activities_categories_value += $activities_categories_value ;
                    $total_security_categories_value += $security_categories_value ;
                    $total_laundry_categories_value += $laundry_categories_value ;
                    $total_hairdresser_categories_value += $hairdresser_categories_value ;
                    $total_animals_categories_value += $animals_categories_value ;
                    $total_other_categories_value += $other_categories_value ;
                    $total_service_15_tax_amount += $service_15_tax_amount ;
                    $total_service_10_tax_amount += $service_10_tax_amount ;
                    $total_transaction_inline_discount_amount += $transaction_inline_discount_amount ;
                    $total_transaction_before_tax += $transaction_total_before_tax ;
                    $total_transaction_discount_amount += $transaction_discount_amount ;
                    $total_transaction_final_total += $transaction_final_total ;
                    $total_cash_payment += $cash_payment ;
                    $total_card_payment += $card_payment ;
                    $total_other_payment += $other_payment ;
                    $total_due_amount += $due_amount ;
                
                /**
                 * End Calculate Group G Payments (Left Part)
                 *
                 * Group G Final Calculation Array
                 */
                array_push($group_g_final_calculations, (object)[
                    'transaction_date' => $group_g_one_transaction_date[0]->transaction_date,
                    'food_categories_value' => $food_categories_value,
                    'beverage_categories_value' => $beverage_categories_value,
                    'broken_categories_value' => $broken_categories_value,
                    'shisha_categories_value' => $shisha_categories_value,
                    'other_categories_value' => $other_categories_value,
                    'market_categories_value' => $market_categories_value,
                    'activities_categories_value' => $activities_categories_value,
                    'security_categories_value' => $security_categories_value,
                    'laundry_categories_value' => $laundry_categories_value,
                    'hairdresser_categories_value' => $hairdresser_categories_value,
                    'animals_categories_value' => $animals_categories_value,
                    'transaction_total_before_tax' => $transaction_total_before_tax,
                    'service_15_tax_amount' => $service_15_tax_amount,
                    'service_10_tax_amount' => $service_10_tax_amount,
                    'transaction_inline_discount_amount' => $transaction_inline_discount_amount,
                    'transaction_discount_amount' => $transaction_discount_amount,
                    'transaction_final_total' => $transaction_final_total,
                    'other_payments' => [
                        'cash_payment' => $cash_payment,
                        'card_payment' => $card_payment,
                        'other_payment' => $other_payment,
                        'due_amount' => $due_amount,
                        ],
                ]);
            }
            // return($group_g_final_calculations);

            /**
             * End Group G
             *
             * 
             */    
    
            /**
             * Group H calculations
             *
             * Group H >> One Date
             */
            foreach($group_h_grouped_by_transaction_date as $group_h_one_transaction_date)
            {
                $food_categories_value = 0 ;
                $beverage_categories_value = 0 ;
                $broken_categories_value = 0 ;
                $shisha_categories_value = 0 ;
                $other_categories_value = 0 ;
                $market_categories_value = 0 ;
                $activities_categories_value = 0 ;
                $security_categories_value = 0 ;
                $laundry_categories_value = 0 ;
                $hairdresser_categories_value = 0 ;
                $animals_categories_value = 0 ;
                $transaction_total_before_tax = 0 ;
                $service_15_tax_amount = 0 ;                 
                $service_10_tax_amount = 0 ;
                $service_25_tax_amount = 0 ;
                $transaction_inline_discount_amount = 0 ;
                // $sell_line_unit_price_before_discount = 0;
                $transaction_discount_amount = 0 ;
                // $transaction_final_total_before_tax = 0 ;
                $transaction_final_total = 0 ;
                $employees_cash_payment = 0 ;
                $employees_card_payment = 0 ;
                $employees_other_payment = 0 ;
                $employees_due_amount = 0 ;
                $department_cost_cash_payment = 0 ;
                $department_cost_card_payment = 0 ;
                $department_cost_other_payment = 0 ;
                $department_cost_due_amount = 0 ;
                
                $employees_purchase_from_warehouse_customer_group_transaction_final_total = 0 ;
                $not_employees_purchase_from_warehouse_customer_group_transaction_final_total = 0 ;

                /**
                 * End Group H >> One Date
                 *
                 * Group H >> One Date >> Loop on this day transaction 
                 */
                foreach($group_h_one_transaction_date as $h)
                {
                    $transaction_total_before_tax += $h->transaction_total_before_tax;
                    if($h->transaction_tax_id == $service_15_tax_id)
                        $service_15_tax_amount += $h->transaction_tax_amount ;
                    elseif($h->transaction_tax_id == $service_25_tax_id)
                        $service_25_tax_amount += $h->transaction_tax_amount ;
						
                        // $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                        // $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                        
                    // $total_service_15_tax_amount += $service_15_tax_amount ;
                    // $total_service_10_tax_amount += $service_10_tax_amount;
                    
                    
                    $transaction_discount_amount += $h->transaction_discount_amount ;
                    // $total_transaction_discount_amount = $transaction_discount_amount ;
                    
                    $transaction_final_total += $h->transaction_final_total ;
                    // $total_transaction_final_total = $transaction_final_total ;
                    
                    /**
                     * Group H >> One Date >> Loop on this day transaction >> loop on this transaction sell lines
                     *
                     *  
                     */
                    foreach($h->sell_lines as $h->sell_line)
                    {
                        $product_category_id = $h->sell_line->product_category_id ;
                        $product_sub_category_id = $h->sell_line->product_sub_category_id ;

                        if( (in_array($product_sub_category_id, $beverage_categories_ids_array )) || (in_array($product_category_id, $beverage_categories_ids_array)) )
                        {
                            $beverage_categories_value += ( $h->sell_line->sell_line_unit_price_before_discount - $h->sell_line->sell_line_discount_amount ) * ($h->sell_line->sell_line_sold_qty)  ;
                            // $total_beverage_categories_value += $beverage_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $food_categories_ids_array)) || (in_array($product_category_id, $food_categories_ids_array))  || $product_category_id == null )
                        {
                            $food_categories_value += ( $h->sell_line->sell_line_unit_price_before_discount - $h->sell_line->sell_line_discount_amount ) * ($h->sell_line->sell_line_sold_qty)  ;
                            // $total_food_categories_value += $food_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $broken_categories_ids_array)) || (in_array($product_category_id, $broken_categories_ids_array)) )
                        {
                            $broken_categories_value += ( $h->sell_line->sell_line_unit_price_before_discount - $h->sell_line->sell_line_discount_amount ) * ($h->sell_line->sell_line_sold_qty)  ;
                            // $total_broken_categories_value += $broken_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $shisha_categories_ids_array)) || (in_array($product_category_id, $shisha_categories_ids_array)) )
                        {
                            $shisha_categories_value += ( $h->sell_line->sell_line_unit_price_before_discount - $h->sell_line->sell_line_discount_amount ) * ($h->sell_line->sell_line_sold_qty)  ;
                            // $total_shisha_categories_value += $shisha_categories_value ;
                        }
                        
                        elseif( (in_array($product_sub_category_id, $market_categories_ids_array)) || (in_array($product_category_id, $market_categories_ids_array)) )
                        {
                            $market_categories_value += ( $h->sell_line->sell_line_unit_price_before_discount - $h->sell_line->sell_line_discount_amount ) * ($h->sell_line->sell_line_sold_qty)  ;
                            // $total_market_categories_value += $market_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $activities_categories_ids_array)) || (in_array($product_category_id, $activities_categories_ids_array)) )
                        {
                            $activities_categories_value += ( $h->sell_line->sell_line_unit_price_before_discount - $h->sell_line->sell_line_discount_amount ) * ($h->sell_line->sell_line_sold_qty)  ;
                            // $total_activities_categories_value += $activities_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $security_categories_ids_array)) || (in_array($product_category_id, $security_categories_ids_array)) )
                        {
                            $security_categories_value += ( $h->sell_line->sell_line_unit_price_before_discount - $h->sell_line->sell_line_discount_amount ) * ($h->sell_line->sell_line_sold_qty)  ;
                            // $total_security_categories_value += $security_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $laundry_categories_ids_array)) || (in_array($product_category_id, $laundry_categories_ids_array)) )
                        {
                            $laundry_categories_value += ( $h->sell_line->sell_line_unit_price_before_discount - $h->sell_line->sell_line_discount_amount ) * ($h->sell_line->sell_line_sold_qty)  ;
                            // $total_laundry_categories_value += $laundry_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $hairdresser_categories_ids_array)) || (in_array($product_category_id, $hairdresser_categories_ids_array)) )
                        {
                            $hairdresser_categories_value += ( $h->sell_line->sell_line_unit_price_before_discount - $h->sell_line->sell_line_discount_amount ) * ($h->sell_line->sell_line_sold_qty)  ;
                            // $total_hairdresser_categories_value += $hairdresser_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $animals_categories_ids_array)) || (in_array($product_category_id, $animals_categories_ids_array)) )
                        {
                            $animals_categories_value += ( $h->sell_line->sell_line_unit_price_before_discount - $h->sell_line->sell_line_discount_amount ) * ($h->sell_line->sell_line_sold_qty)  ;
                            // $total_animals_categories_value += $animals_categories_value ;
                        }
                        // elseif( (in_array($product_sub_category_id, $other_categories_ids_array)) || (in_array($product_category_id, $other_categories_ids_array)) 
                        elseif( (in_array($product_sub_category_id, $other_categories_ids_array)) || (in_array($product_category_id, $other_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $food_categories_ids_array)) || (!in_array($product_category_id, $food_categories_ids_array))
                             || (!in_array($product_sub_category_id, $beverage_categories_ids_array)) || (!in_array($product_category_id, $beverage_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $broken_categories_ids_array)) || (!in_array($product_category_id, $broken_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $shisha_categories_ids_array)) || (!in_array($product_category_id, $shisha_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $market_categories_ids_array)) || (!in_array($product_category_id, $market_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $activities_categories_ids_array)) || (!in_array($product_category_id, $activities_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $security_categories_ids_array)) || (!in_array($product_category_id, $security_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $laundry_categories_ids_array)) || (!in_array($product_category_id, $laundry_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $hairdresser_categories_ids_array)) || (!in_array($product_category_id, $hairdresser_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $animals_categories_ids_array)) || (!in_array($product_category_id, $animals_categories_ids_array)) 
                             )
                        {
                            $other_categories_value += ( $h->sell_line->sell_line_unit_price_before_discount - $h->sell_line->sell_line_discount_amount ) * ($h->sell_line->sell_line_sold_qty)  ;
                            // $total_other_categories_value += $other_categories_value ;
                        }
                        if($h->sell_line->sell_line_tax_id == $service_15_tax_id)
                            $service_15_tax_amount += $h->sell_line->sell_line_item_tax * $h->sell_line->sell_line_sold_qty ;
							
                        if($h->sell_line->sell_line_tax_id == $service_25_tax_id)
                            $service_25_tax_amount += $h->sell_line->sell_line_item_tax * $h->sell_line->sell_line_sold_qty ;
                            
                            // $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                            // $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                            
                            // $total_service_15_tax_amount += $service_15_tax_amount ;
                            // $total_service_10_tax_amount += $service_10_tax_amount ;
                    
                        $transaction_inline_discount_amount += $h->sell_line->sell_line_discount_amount * $h->sell_line->sell_line_sold_qty ;
                        // $total_transaction_inline_discount_amount += $transaction_inline_discount_amount ;
                        
                        // $transaction_final_total_before_tax = $transaction_final_total - ($total_service_15_tax_amount + $total_service_10_tax_amount) ;
                        // $total_transaction_final_total_before_tax = $transaction_final_total_before_tax ;

                        // $total_transaction_before_tax += $transaction_total_before_tax ;
                        // $sell_line_unit_price_before_discount += $h->sell_line->sell_line_unit_price_before_discount * $h->sell_line->sell_line_sold_qty ;
                    }
                    
                    /**
                     * End Group H Right Part Calcualtion
                     *
                     *  Calculate Group H Payments (Left Part)
                     */
                    if( in_array($h->transaction_customer_group_id , $employees_purchase_from_warehouse_customer_group_ids_array) )
                        {
                            foreach($h->payment_lines as $h->payment_line)
                            {
                                if($h->payment_line->method == "cash")
                                {
                                    $employees_cash_payment += $h->payment_line->amount ;
                                    // return($cash_payment);
                                }
                                elseif($h->payment_line->method == "card")
                                {
                                    $employees_card_payment += $h->payment_line->amount ;
                                }
                                else
                                {
                                    $employees_other_payment += $h->payment_line->amount ;
                                }
                            }
                                $employees_purchase_from_warehouse_customer_group_transaction_final_total += $h->transaction_final_total;
                                $employees_due_amount = $employees_purchase_from_warehouse_customer_group_transaction_final_total - ($employees_cash_payment + $employees_card_payment + $employees_other_payment);
                        }
                        else
                        {
                            foreach($h->payment_lines as $h->payment_line)
                            {
                                if($h->payment_line->method == "cash")
                                {
                                    $department_cost_cash_payment += $h->payment_line->amount ;
                                }
                                elseif($h->payment_line->method == "card")
                                {
                                    $department_cost_card_payment += $h->payment_line->amount ;
                                }
                                else
                                {
                                    $department_cost_other_payment += $h->payment_line->amount ;
                                }
                                
                            }
                            $not_employees_purchase_from_warehouse_customer_group_transaction_final_total += $h->transaction_final_total;
                            $department_cost_due_amount = $not_employees_purchase_from_warehouse_customer_group_transaction_final_total - ($department_cost_cash_payment + $department_cost_card_payment + $department_cost_other_payment);
                        }

                }
                    
                    $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                    $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                    
                    $total_beverage_categories_value += $beverage_categories_value;
                    $total_food_categories_value += $food_categories_value;
                    $total_broken_categories_value += $broken_categories_value;
                    $total_shisha_categories_value += $shisha_categories_value ;
                    $total_market_categories_value += $market_categories_value ;
                    $total_activities_categories_value += $activities_categories_value ;
                    $total_security_categories_value += $security_categories_value ;
                    $total_laundry_categories_value += $laundry_categories_value ;
                    $total_hairdresser_categories_value += $hairdresser_categories_value ;
                    $total_animals_categories_value += $animals_categories_value ;
                    $total_other_categories_value += $other_categories_value ;
                    $total_service_15_tax_amount += $service_15_tax_amount ;
                    $total_service_10_tax_amount += $service_10_tax_amount ;
                    $total_transaction_inline_discount_amount += $transaction_inline_discount_amount ;
                    $total_transaction_before_tax += $transaction_total_before_tax ;
                    $total_transaction_discount_amount += $transaction_discount_amount ;
                    $total_transaction_final_total += $transaction_final_total ;
                    $total_cash_payment += ( $employees_cash_payment + $department_cost_cash_payment ) ;
                    $total_card_payment += ( $employees_card_payment + $department_cost_card_payment ) ;
                    $total_other_payment += ( $employees_other_payment + $department_cost_other_payment ) ;
                    $total_due_amount += ( $employees_due_amount + $department_cost_due_amount );

                /**
                 * End Calculate Group H Payments (Left Part)
                 *
                 * Group H Final Calculation Array
                 */
                array_push($group_h_final_calculations, (object)[
                    'transaction_date' => $group_h_one_transaction_date[0]->transaction_date,
                    'food_categories_value' => $food_categories_value,
                    'beverage_categories_value' => $beverage_categories_value,
                    'broken_categories_value' => $broken_categories_value,
                    'shisha_categories_value' => $shisha_categories_value,
                    'other_categories_value' => $other_categories_value,
                    'market_categories_value' => $market_categories_value,
                    'activities_categories_value' => $activities_categories_value,
                    'security_categories_value' => $security_categories_value,
                    'laundry_categories_value' => $laundry_categories_value,
                    'hairdresser_categories_value' => $hairdresser_categories_value,
                    'animals_categories_value' => $animals_categories_value,
                    'transaction_total_before_tax' => $transaction_total_before_tax,
                    'service_15_tax_amount' => $service_15_tax_amount,
                    'service_10_tax_amount' => $service_10_tax_amount,
                    'transaction_inline_discount_amount' => $transaction_inline_discount_amount,
                    'transaction_discount_amount' => $transaction_discount_amount,
                    'transaction_final_total' => $transaction_final_total,
                    'employees_payments' => [
                        'employees_cash_payment' => $employees_cash_payment,
                        'employees_card_payment' => $employees_card_payment,
                        'employees_other_payment' => $employees_other_payment,
                        'employees_due_amount' => $employees_due_amount,
                        ],
                    'department_cost_payments' => [
                        'department_cost_cash_payment' => $department_cost_cash_payment,
                        'department_cost_card_payment' => $department_cost_card_payment,
                        'department_cost_other_payment' => $department_cost_other_payment,
                        'department_cost_due_amount' => $department_cost_due_amount,
                        ],
                ]);
            }
            // return($group_h_final_calculations);

            /**
             * End Group H
             *
             * 
             */    
    
            /**
             * Group I calculations
             *
             * Group I >> One Date
             */
            foreach($group_i_grouped_by_transaction_date as $group_i_one_transaction_date)
            {
                $food_categories_value = 0 ;
                $beverage_categories_value = 0 ;
                $broken_categories_value = 0 ;
                $shisha_categories_value = 0 ;
                $other_categories_value = 0 ;
                $market_categories_value = 0 ;
                $activities_categories_value = 0 ;
                $security_categories_value = 0 ;
                $laundry_categories_value = 0 ;
                $hairdresser_categories_value = 0 ;
                $animals_categories_value = 0 ;
                $transaction_total_before_tax = 0 ;
                $service_15_tax_amount = 0 ;                 
                $service_10_tax_amount = 0 ;
                $service_25_tax_amount = 0 ;
                $transaction_inline_discount_amount = 0 ;
                // $sell_line_unit_price_before_discount = 0;
                $transaction_discount_amount = 0 ;
                // $transaction_final_total_before_tax = 0 ;
                $transaction_final_total = 0 ;
                $employees_cash_payment = 0 ;
                $employees_card_payment = 0 ;
                $employees_other_payment = 0 ;
                $employees_due_amount = 0 ;
                $department_cost_cash_payment = 0 ;
                $department_cost_card_payment = 0 ;
                $department_cost_other_payment = 0 ;
                $department_cost_due_amount = 0 ;
                
                $employees_purchase_from_warehouse_customer_group_transaction_final_total = 0 ;
                $not_employees_purchase_from_warehouse_customer_group_transaction_final_total = 0 ;

                /**
                 * End Group I >> One Date
                 *
                 * Group I >> One Date >> Loop on this day transaction 
                 */
                foreach($group_i_one_transaction_date as $i)
                {
                    $transaction_total_before_tax += $i->transaction_total_before_tax;
                    if($i->transaction_tax_id == $service_15_tax_id)
                        $service_15_tax_amount += $i->transaction_tax_amount ;
                    elseif($i->transaction_tax_id == $service_25_tax_id)
                        $service_25_tax_amount += $i->transaction_tax_amount ;
						
                        // $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                        // $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                        
                    // $total_service_15_tax_amount += $service_15_tax_amount ;
                    // $total_service_10_tax_amount += $service_10_tax_amount;
                    
                    
                    $transaction_discount_amount += $i->transaction_discount_amount ;
                    // $total_transaction_discount_amount = $transaction_discount_amount ;
                    
                    $transaction_final_total += $i->transaction_final_total ;
                    // $total_transaction_final_total = $transaction_final_total ;
                    
                    /**
                     * Group I >> One Date >> Loop on this day transaction >> loop on this transaction sell lines
                     *
                     *  
                     */
                    foreach($i->sell_lines as $i->sell_line)
                    {
                        $product_category_id = $i->sell_line->product_category_id ;
                        $product_sub_category_id = $i->sell_line->product_sub_category_id ;

                        if( (in_array($product_sub_category_id, $beverage_categories_ids_array )) || (in_array($product_category_id, $beverage_categories_ids_array)) )
                        {
                            $beverage_categories_value += ( $i->sell_line->sell_line_unit_price_before_discount - $i->sell_line->sell_line_discount_amount ) * ($i->sell_line->sell_line_sold_qty)  ;
                            // $total_beverage_categories_value += $beverage_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $food_categories_ids_array)) || (in_array($product_category_id, $food_categories_ids_array))  || $product_category_id == null )
                        {
                            $food_categories_value += ( $i->sell_line->sell_line_unit_price_before_discount - $i->sell_line->sell_line_discount_amount ) * ($i->sell_line->sell_line_sold_qty)  ;
                            // $total_food_categories_value += $food_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $broken_categories_ids_array)) || (in_array($product_category_id, $broken_categories_ids_array)) )
                        {
                            $broken_categories_value += ( $i->sell_line->sell_line_unit_price_before_discount - $i->sell_line->sell_line_discount_amount ) * ($i->sell_line->sell_line_sold_qty)  ;
                            // $total_broken_categories_value += $broken_categories_value;
                        }
                        elseif( (in_array($product_sub_category_id, $shisha_categories_ids_array)) || (in_array($product_category_id, $shisha_categories_ids_array)) )
                        {
                            $shisha_categories_value += ( $i->sell_line->sell_line_unit_price_before_discount - $i->sell_line->sell_line_discount_amount ) * ($i->sell_line->sell_line_sold_qty)  ;
                            // $total_shisha_categories_value += $shisha_categories_value ;
                        }
                        
                        elseif( (in_array($product_sub_category_id, $market_categories_ids_array)) || (in_array($product_category_id, $market_categories_ids_array)) )
                        {
                            $market_categories_value += ( $i->sell_line->sell_line_unit_price_before_discount - $i->sell_line->sell_line_discount_amount ) * ($i->sell_line->sell_line_sold_qty)  ;
                            // $total_market_categories_value += $market_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $activities_categories_ids_array)) || (in_array($product_category_id, $activities_categories_ids_array)) )
                        {
                            $activities_categories_value += ( $i->sell_line->sell_line_unit_price_before_discount - $i->sell_line->sell_line_discount_amount ) * ($i->sell_line->sell_line_sold_qty)  ;
                            // $total_activities_categories_value += $activities_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $security_categories_ids_array)) || (in_array($product_category_id, $security_categories_ids_array)) )
                        {
                            $security_categories_value += ( $i->sell_line->sell_line_unit_price_before_discount - $i->sell_line->sell_line_discount_amount ) * ($i->sell_line->sell_line_sold_qty)  ;
                            // $total_security_categories_value += $security_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $laundry_categories_ids_array)) || (in_array($product_category_id, $laundry_categories_ids_array)) )
                        {
                            $laundry_categories_value += ( $i->sell_line->sell_line_unit_price_before_discount - $i->sell_line->sell_line_discount_amount ) * ($i->sell_line->sell_line_sold_qty)  ;
                            // $total_laundry_categories_value += $laundry_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $hairdresser_categories_ids_array)) || (in_array($product_category_id, $hairdresser_categories_ids_array)) )
                        {
                            $hairdresser_categories_value += ( $i->sell_line->sell_line_unit_price_before_discount - $i->sell_line->sell_line_discount_amount ) * ($i->sell_line->sell_line_sold_qty)  ;
                            // $total_hairdresser_categories_value += $hairdresser_categories_value ;
                        }
                        elseif( (in_array($product_sub_category_id, $animals_categories_ids_array)) || (in_array($product_category_id, $animals_categories_ids_array)) )
                        {
                            $animals_categories_value += ( $i->sell_line->sell_line_unit_price_before_discount - $i->sell_line->sell_line_discount_amount ) * ($i->sell_line->sell_line_sold_qty)  ;
                            // $total_animals_categories_value += $animals_categories_value ;
                        }
                        // elseif( (in_array($product_sub_category_id, $other_categories_ids_array)) || (in_array($product_category_id, $other_categories_ids_array)) 
                        elseif( (in_array($product_sub_category_id, $other_categories_ids_array)) || (in_array($product_category_id, $other_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $food_categories_ids_array)) || (!in_array($product_category_id, $food_categories_ids_array))
                             || (!in_array($product_sub_category_id, $beverage_categories_ids_array)) || (!in_array($product_category_id, $beverage_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $broken_categories_ids_array)) || (!in_array($product_category_id, $broken_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $shisha_categories_ids_array)) || (!in_array($product_category_id, $shisha_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $market_categories_ids_array)) || (!in_array($product_category_id, $market_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $activities_categories_ids_array)) || (!in_array($product_category_id, $activities_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $security_categories_ids_array)) || (!in_array($product_category_id, $security_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $laundry_categories_ids_array)) || (!in_array($product_category_id, $laundry_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $hairdresser_categories_ids_array)) || (!in_array($product_category_id, $hairdresser_categories_ids_array)) 
                             || (!in_array($product_sub_category_id, $animals_categories_ids_array)) || (!in_array($product_category_id, $animals_categories_ids_array)) 
                             )
                        {
                            $other_categories_value += ( $i->sell_line->sell_line_unit_price_before_discount - $i->sell_line->sell_line_discount_amount ) * ($i->sell_line->sell_line_sold_qty)  ;
                            // $total_other_categories_value += $other_categories_value ;
                        }
                        if($i->sell_line->sell_line_tax_id == $service_15_tax_id)
                            $service_15_tax_amount += $i->sell_line->sell_line_item_tax * $i->sell_line->sell_line_sold_qty ;
							
                        if($i->sell_line->sell_line_tax_id == $service_25_tax_id)
                            $service_25_tax_amount += $i->sell_line->sell_line_item_tax * $i->sell_line->sell_line_sold_qty ;
                            
                            // $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                            // $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                            
                            // $total_service_15_tax_amount += $service_15_tax_amount ;
                            // $total_service_10_tax_amount += $service_10_tax_amount ;
                            
                        $transaction_inline_discount_amount += $i->sell_line->sell_line_discount_amount * $i->sell_line->sell_line_sold_qty ;
                        // $total_transaction_inline_discount_amount += $transaction_inline_discount_amount ;
                        
                        // $transaction_final_total_before_tax = $transaction_final_total - ($total_service_15_tax_amount + $total_service_10_tax_amount) ;
                        // $total_transaction_final_total_before_tax = $transaction_final_total_before_tax ;
                        
                        // $total_transaction_before_tax += $transaction_total_before_tax ;
                        // $sell_line_unit_price_before_discount += $i->sell_line->sell_line_unit_price_before_discount * $i->sell_line->sell_line_sold_qty ;
                    }
                    
                    /**
                     * End Group I Right Part Calcualtion
                     *
                     *  Calculate Group I Payments (Left Part)
                     */
                    if( in_array($i->transaction_customer_group_id , $employees_purchase_from_warehouse_customer_group_ids_array) )
                        {
                            foreach($i->payment_lines as $i->payment_line)
                            {
                                if($i->payment_line->method == "cash")
                                {
                                    $employees_cash_payment += $i->payment_line->amount ;
                                    // return($cash_payment);
                                }
                                elseif($i->payment_line->method == "card")
                                {
                                    $employees_card_payment += $i->payment_line->amount ;
                                }
                                else
                                {
                                    $employees_other_payment += $i->payment_line->amount ;
                                }
                            }
                                $employees_purchase_from_warehouse_customer_group_transaction_final_total += $i->transaction_final_total;
                                $employees_due_amount = $employees_purchase_from_warehouse_customer_group_transaction_final_total - ($employees_cash_payment + $employees_card_payment + $employees_other_payment);
                        }
                        else
                        {
                            foreach($i->payment_lines as $i->payment_line)
                            {
                                if($i->payment_line->method == "cash")
                                {
                                    $department_cost_cash_payment += $i->payment_line->amount ;
                                }
                                elseif($i->payment_line->method == "card")
                                {
                                    $department_cost_card_payment += $i->payment_line->amount ;
                                }
                                else
                                {
                                    $department_cost_other_payment += $i->payment_line->amount ;
                                }
                                
                            }
                                $not_employees_purchase_from_warehouse_customer_group_transaction_final_total += $i->transaction_final_total;
                                $department_cost_due_amount = $not_employees_purchase_from_warehouse_customer_group_transaction_final_total - ($department_cost_cash_payment + $department_cost_card_payment + $department_cost_other_payment);
                        }

                }
                    
                    $service_15_tax_amount += ( $service_25_tax_amount * 0.15 ) / 0.25 ;
                    $service_10_tax_amount += ( $service_25_tax_amount * 0.1 ) / 0.25 ;
                    
                    $total_beverage_categories_value += $beverage_categories_value;
                    $total_food_categories_value += $food_categories_value;
                    $total_broken_categories_value += $broken_categories_value;
                    $total_shisha_categories_value += $shisha_categories_value ;
                    $total_market_categories_value += $market_categories_value ;
                    $total_activities_categories_value += $activities_categories_value ;
                    $total_security_categories_value += $security_categories_value ;
                    $total_laundry_categories_value += $laundry_categories_value ;
                    $total_hairdresser_categories_value += $hairdresser_categories_value ;
                    $total_animals_categories_value += $animals_categories_value ;
                    $total_other_categories_value += $other_categories_value ;
                    $total_service_15_tax_amount += $service_15_tax_amount ;
                    $total_service_10_tax_amount += $service_10_tax_amount ;
                    $total_transaction_inline_discount_amount += $transaction_inline_discount_amount ;
                    $total_transaction_before_tax += $transaction_total_before_tax ;
                    $total_transaction_discount_amount += $transaction_discount_amount ;
                    $total_transaction_final_total += $transaction_final_total ;
                    $total_cash_payment += ( $employees_cash_payment + $department_cost_cash_payment ) ;
                    $total_card_payment += ( $employees_card_payment + $department_cost_card_payment ) ;
                    $total_other_payment += ( $employees_other_payment + $department_cost_other_payment ) ;
                    $total_due_amount += ( $employees_due_amount + $department_cost_due_amount ) ;
                
                /**
                 * End Calculate Group I Payments (Left Part)
                 *
                 * Group I Final Calculation Array
                 */
                array_push($group_i_final_calculations, (object)[
                    'transaction_date' => $group_i_one_transaction_date[0]->transaction_date,
                    'food_categories_value' => $food_categories_value,
                    'beverage_categories_value' => $beverage_categories_value,
                    'broken_categories_value' => $broken_categories_value,
                    'shisha_categories_value' => $shisha_categories_value,
                    'other_categories_value' => $other_categories_value,
                    'market_categories_value' => $market_categories_value,
                    'activities_categories_value' => $activities_categories_value,
                    'security_categories_value' => $security_categories_value,
                    'laundry_categories_value' => $laundry_categories_value,
                    'hairdresser_categories_value' => $hairdresser_categories_value,
                    'animals_categories_value' => $animals_categories_value,
                    'transaction_total_before_tax' => $transaction_total_before_tax,
                    'service_15_tax_amount' => $service_15_tax_amount,
                    'service_10_tax_amount' => $service_10_tax_amount,
                    'transaction_inline_discount_amount' => $transaction_inline_discount_amount,
                    'transaction_discount_amount' => $transaction_discount_amount,
                    'transaction_final_total' => $transaction_final_total,
                    'employees_payments' => [
                        'employees_cash_payment' => $employees_cash_payment,
                        'employees_card_payment' => $employees_card_payment,
                        'employees_other_payment' => $employees_other_payment,
                        'employees_due_amount' => $employees_due_amount,
                        ],
                    'department_cost_payments' => [
                        'department_cost_cash_payment' => $department_cost_cash_payment,
                        'department_cost_card_payment' => $department_cost_card_payment,
                        'department_cost_other_payment' => $department_cost_other_payment,
                        'department_cost_due_amount' => $department_cost_due_amount,
                        ],
                ]);
                
                
            }
            // return($group_i_final_calculations);

            /**
             * End Group I
             *
             * 
             */    

            /**
             * Final Totals
             *
             * 
             */    
             
            array_push($final_totals, (object)[
                    'total_food_categories_value' => $total_food_categories_value,
                    'total_beverage_categories_value' => $total_beverage_categories_value,
                    'total_broken_categories_value' => $total_broken_categories_value,
                    'total_shisha_categories_value' => $total_shisha_categories_value,
                    'total_other_categories_value' => $total_other_categories_value,
                    'total_market_categories_value' => $total_market_categories_value,
                    'total_activities_categories_value' => $total_activities_categories_value,
                    'total_security_categories_value' => $total_security_categories_value,
                    'total_laundry_categories_value' => $total_laundry_categories_value,
                    'total_hairdresser_categories_value' => $total_hairdresser_categories_value,
                    'total_animals_categories_value' => $total_animals_categories_value,
                    'total_transaction_before_tax' => $total_transaction_before_tax,
                    'total_service_15_tax_amount' => $total_service_15_tax_amount,
                    'total_service_10_tax_amount' => $total_service_10_tax_amount,
                    'total_transaction_inline_discount_amount' => $total_transaction_inline_discount_amount,
                    'total_transaction_discount_amount' => $total_transaction_discount_amount,
                    'total_transaction_final_total' => $total_transaction_final_total,
                    'other_payments' => [
                        'total_cash_payment' => $total_cash_payment,
                        'total_card_payment' => $total_card_payment,
                        'total_other_payment' => $total_other_payment,
                        'total_due_amount' => $total_due_amount,
                        ],
                ]);

            /**
             * End Final Totals
             *
             * 
             */    
             
             
            /**
             * Final Finance Calculation Array
             *
             * 
             */ 
             
             array_push($final_finance_calculations_data, (object)[
                    'group_a' => $group_a_final_calculations,
                    'group_b' => $group_b_final_calculations,
                    'group_c' => $group_c_final_calculations,
                    'group_d' => $group_d_final_calculations,
                    'group_e' => $group_e_final_calculations,
                    'group_f' => $group_f_final_calculations,
                    'group_g' => $group_g_final_calculations,
                    'group_h' => $group_h_final_calculations,
                    'group_i' => $group_i_final_calculations,
                ]);
            $final_finance_calculations['data'] = $final_finance_calculations_data;
            $final_finance_calculations['totals'] = $final_totals;
            return($final_finance_calculations);
             

             
           
        $perPage = 10;
        $skip = 0;
        if(!empty($filters['per_page']))
        {
            if (($filters['per_page']) != -1)
            {
                $perPage = $filters['per_page'];
            }
            else
            {
                 $perPage = count($transactions_data);
            }
        }


        $sells = $this->paginate($transactions_data, $perPage);
        $sells->appends(Arr::except($filters, ['page']));

        $response = ((new PaginatedResourceResponse(CollectionResource::make($sells)))->toResponse(request()));
        $data = $response->getData();
        
      
        
        
        $response->setData($data);
        return $response;


    }


    /**
     * Create a new command instance.
     *
     * @return string
     */
    public function queryToSql($query)
    {
        return vsprintf(str_replace(array('?'), array('\'%s\''), $query->toSql()), $query->getBindings());
    }

    /**
     * The attributes that are mass assignable.
     *
     *
     * @param $items
     * @param int $perPage
     * @param null $page
     * @param array $options
     * @return LengthAwarePaginator
     */
    public function paginate($items, $perPage = 5, $page = null, $options = [])
    {
        $page = $page ?: (Paginator::resolveCurrentPage() ?: 1);
        $items = $items instanceof Collection ? $items : Collection::make($items);
        return new LengthAwarePaginator($items->forPage($page, $perPage), $items->count(), $perPage, $page, $options);
    }
}
