<?php

namespace Modules\ReportsModule\Http\Controllers;

use stdClass;
use App\User;
use App\Category;
use App\Product;
use Exception;
use Illuminate\Database\Query\JoinClause;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Resources\Json\PaginatedResourceResponse;
use Illuminate\Pagination\LengthAwarePaginator;
use Illuminate\Pagination\Paginator;
use Illuminate\Support\Arr;
use Illuminate\Support\Collection;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Modules\Connector\Http\Controllers\Api\ApiController;
use Modules\ReportsModule\Transformers\CollectionResource;
use Illuminate\Support\Str;

class FinanceCalculationsGroupedReportApiController extends ApiController
{
    /**
     * Display a listing of the resource.
     * @return JsonResponse
     * @throws Exception
     */
    public function index()
    {
        
        $reports_module_setting = DB::table('reports_module')
                    ->get();
                    // return($reports_module_setting);
        
        $service_15_tax_id = 0;
        $service_25_tax_id = 0;
        $banquet_location_id = 0;
        $main_warehouse_location_id = 0;
        $general_warehouse_location_id = 0;
        $FB_prefix = 0;
        $hotel_room_customer_group_id = 0;
        $officer_customer_group_id = 0;
        $companies_customer_group_id = 0;
        $general_hospitality_customer_group_id = 0;
        $hospitality_customer_group_id = 0;
        $hotel_hospitality_customer_group_id = 0;
        $banquet_hospitality_customer_group_id = 0;
        $PrePaid_customer_group_id = 0;
        $food_categories_id = 0;
        $beverage_categories_id = 0;
        $broken_categories_id = 0;
        $shisha_categories_id = 0;
        $other_categories_id = 0;
        $market_categories_id = 0;
        $activities_categories_id = 0;
        $security_categories_id = 0;
        $laundry_categories_id = 0;
        $hairdresser_categories_id = 0;
        $animals_categories_id = 0;    //Administration Department	
        foreach ($reports_module_setting as $report_module_setting)
        {
            if($report_module_setting->item == "service_15_tax_id")
                $service_15_tax_id = $report_module_setting->value;
                
            if($report_module_setting->item == "service_25_tax_id")
                $service_25_tax_id = $report_module_setting->value;
                
            if($report_module_setting->item == "general_warehouse_location_id")
                $general_warehouse_location_id = $report_module_setting->value;
            
            if($report_module_setting->item == "main_warehouse_location_id")
                $main_warehouse_location_id = $report_module_setting->value;
            
            if($report_module_setting->item == "banquet_location_id")
                $banquet_location_id = $report_module_setting->value;
                
            if($report_module_setting->item == "FB prefix")
                $FB_prefix = $report_module_setting->value;
                
            if($report_module_setting->item == "hotel_room_customer_group_id")
                $hotel_room_customer_group_id = $report_module_setting->value;
                
            if($report_module_setting->item == "officer_customer_group_id")
                $officer_customer_group_id = $report_module_setting->value;
                
            if($report_module_setting->item == "companies_customer_group_id")
                $companies_customer_group_id = $report_module_setting->value;
                
            if($report_module_setting->item == "general_hospitality_customer_group_id")
                $general_hospitality_customer_group_id = $report_module_setting->value;
                
            if($report_module_setting->item == "hospitality_customer_group_id")
                $hospitality_customer_group_id = $report_module_setting->value;
                
            if($report_module_setting->item == "hotel_hospitality_customer_group_id")
                $hotel_hospitality_customer_group_id = $report_module_setting->value;
                
            if($report_module_setting->item == "banquet_hospitality_customer_group_id")
                $banquet_hospitality_customer_group_id = $report_module_setting->value;
                
            if($report_module_setting->item == "PrePaid_customer_group_id")
                $PrePaid_customer_group_id = $report_module_setting->value;
                
            if($report_module_setting->item == "food_categories_id")
                $food_categories_id = $report_module_setting->value;
                
            if($report_module_setting->item == "beverage_categories_id")
                $beverage_categories_id = $report_module_setting->value;
                
            if($report_module_setting->item == "broken_categories_id")
                $broken_categories_id = $report_module_setting->value;
                
            if($report_module_setting->item == "shisha_categories_id")
                $shisha_categories_id = $report_module_setting->value;
                
            if($report_module_setting->item == "other_categories_id")
                $other_categories_id = $report_module_setting->value;
                
            if($report_module_setting->item == "market_categories_id")
                $market_categories_id = $report_module_setting->value;
                
            if($report_module_setting->item == "activities_categories_id")
                $activities_categories_id = $report_module_setting->value;
                
            if($report_module_setting->item == "security_categories_id")
                $security_categories_id = $report_module_setting->value;
                
            if($report_module_setting->item == "laundry_categories_id")
                $laundry_categories_id = $report_module_setting->value;
                
            if($report_module_setting->item == "hairdresser_categories_id")
                $hairdresser_categories_id = $report_module_setting->value;
                
            if($report_module_setting->item == "animals_categories_id")
                $animals_categories_id = $report_module_setting->value;
        }
        

    // Sending locations according to login user
    $user = Auth::user();
    $business_id = $user->business_id;
    $permitted_locations = $user->permitted_locations($business_id);
    $filters = request()->only([
            'location_id', 'location_type', 'ratio_filter', 'start_date' , 'end_date' ,
            'not_for_selling', 'is_inactive', 'search', 'managed_stock', 'per_page','page', 'category_id' , 'sub_category_id'
        ]);

    $transactions = DB::table('transactions as t')
                    ->select(
                        DB::raw(' t.id as transaction_id '),
                        DB::raw(' DATE(t.transaction_date) as transaction_date '),
                        DB::raw(' t.location_id as transaction_location_id '),
                        DB::raw(' t.invoice_no as transaction_invoice_no '),
                        DB::raw(' t.customer_group_id as transaction_customer_group_id '),
                        DB::raw(' t.contact_id as transaction_contact_id '),
                        DB::raw(' t.total_before_tax as transaction_total_before_tax '),
                        DB::raw(' t.tax_id as transaction_tax_id '),
                        DB::raw(' t.tax_amount as transaction_tax_amount '),
                        DB::raw('IF(t.discount_type = "percentage", (t.discount_amount/100)*t.total_before_tax , t.discount_amount) as transaction_discount_amount'),
                        DB::raw(' t.final_total as transaction_final_total ')
                        )
                    ->leftjoin('business_locations as bl','bl.id', '=', 't.location_id')
                    ->where('t.type', '=' , 'sell')
                    // ->where('t.id', 271221)
                    ->where('t.status', '=' , 'final');


                    // Filters
                if (!empty($filters['location_id']))
                    $transactions->whereIn('t.location_id', explode(',', $filters['location_id']));
                else if ($permitted_locations != 'all')
                    $transactions->whereIn('t.location_id', $permitted_locations);

                if (!empty($filters['location_type']))
                {
                    if($filters['location_type'] == 'null') {
                        $transactions->whereNull('bl.custom_field1');
                    } else {
                        $transactions->whereIn('bl.custom_field1', explode(',', $filters['location_type']));
                    }
                }

                if (!empty($filters['start_date']))
                    $transactions->whereDate('t.transaction_date', '>=', $filters['start_date']);
                if (!empty($filters['end_date']))
                    $transactions->whereDate('t.transaction_date', '<=', $filters['end_date']);

                $transactions = $transactions->get();
    // Defines
    $transactions_data = [];
    $group_a = [];
    $group_b = [];
    $group_c = [];
    $group_d = [];
    $group_e = [];
    $group_f = [];
    $group_g = [];
    $group_h = [];
    $group_i = [];
    $group_a_final_calculations = [];
    $group_b_final_calculations = [];
    $group_c_final_calculations = [];
    $group_d_final_calculations = [];
    $finance_calculations = [];
    $final_finance_calculations = [];
    $obj = new stdClass;

    // End Defines
    foreach ($transactions as $transaction)
    {

        $transaction_sell_lines = DB::table('transaction_sell_lines as tsl')
                    ->select(
                        DB::raw(' tsl.product_id as product_id '),
                        DB::raw(' p.category_id as product_category_id '),
                        DB::raw(' p.sub_category_id as product_sub_category_id '),
                        DB::raw(' (tsl.quantity - tsl.quantity_returned) as sell_line_sold_qty '),
                        DB::raw('IF(tsl.line_discount_type = "percentage", (tsl.line_discount_amount/100)*tsl.unit_price_before_discount , tsl.line_discount_amount) as sell_line_discount_amount'),
                        DB::raw(' tsl.tax_id as sell_line_tax_id '),
                        DB::raw(' tsl.item_tax as sell_line_item_tax '),
                        DB::raw(' tsl.unit_price_before_discount as sell_line_unit_price_before_discount ')
                        )
                    ->leftjoin('products as p','p.id', '=', 'tsl.product_id')
                    ->where('tsl.transaction_id', $transaction->transaction_id)
                    ->get();
                    
        $transaction_payment_lines = DB::table('transaction_payments as tpy')
                    ->select(
                        DB::raw(' tpy.is_return as returned '),
                        // DB::raw(' tpy.amount as amount '),
                        DB::raw('IF(tpy.is_return = 1, (tpy.amount)*(-1) , tpy.amount) as amount'),
                        DB::raw(' tpy.method as method ')
                        )
                    ->where('tpy.transaction_id', $transaction->transaction_id)
                    ->get();

        array_push($transactions_data, (object)[
            'transaction_id' => $transaction->transaction_id,
            'transaction_location_id' => $transaction->transaction_location_id,
            'transaction_date' => $transaction->transaction_date,
            'transaction_invoice_no' => $transaction->transaction_invoice_no,
            'transaction_contact_id' => $transaction->transaction_contact_id,
            'transaction_customer_group_id' => $transaction->transaction_customer_group_id,
            'transaction_total_before_tax' => $transaction->transaction_total_before_tax,
            'transaction_tax_id' => $transaction->transaction_tax_id,
            'transaction_tax_amount' => $transaction->transaction_tax_amount,
            'transaction_discount_amount' => $transaction->transaction_discount_amount,
            'transaction_final_total' => $transaction->transaction_final_total,
            'sell_lines' => $transaction_sell_lines,
            'payment_lines' => $transaction_payment_lines,
            
        ]);

    }
    // return($transactions_data);
    foreach($transactions_data as $transaction_data)
    {
        // return($transaction_data);
        // return($companies_customer_group_id);
        if (!str_contains($transaction_data->transaction_invoice_no, $FB_prefix) 
        && $transaction_data->transaction_location_id != $banquet_location_id 
        && $transaction_data->transaction_location_id != $main_warehouse_location_id 
        && $transaction_data->transaction_location_id != $general_warehouse_location_id
        && ( $transaction_data->transaction_customer_group_id == null || $transaction_data->transaction_customer_group_id == $hotel_room_customer_group_id) ) 
        { 
            // array_push($group_a, (object)[
            // 'transacation' => $transaction_data,
            // ]);
            array_push($group_a,  $transaction_data );
            // return('group A');
        }
        elseif ( $transaction_data->transaction_customer_group_id == $officer_customer_group_id )
        {
            array_push($group_b,  $transaction_data );
            // return('group B');
        }
        elseif ( $transaction_data->transaction_customer_group_id == $companies_customer_group_id )
        {
            array_push($group_c,  $transaction_data );
            // return('group C');
        }
        elseif ( $transaction_data->transaction_customer_group_id == $general_hospitality_customer_group_id 
        || $transaction_data->transaction_customer_group_id == $hospitality_customer_group_id 
        || $transaction_data->transaction_customer_group_id == $hotel_hospitality_customer_group_id 
        || $transaction_data->transaction_customer_group_id == $banquet_hospitality_customer_group_id )
        {
            array_push($group_d,  $transaction_data );
            // return('group D');
        }
        elseif ( $transaction_data->transaction_customer_group_id == $PrePaid_customer_group_id )
        {
            array_push($group_e,  $transaction_data );
            // return('group E');
        }
        elseif ( str_contains($transaction_data->transaction_invoice_no, $FB_prefix) )
        {
            array_push($group_f,  $transaction_data );
            // return('group F');
        }
        elseif ( str_contains($transaction_data->transaction_location_id, $banquet_location_id) )
        {
            array_push($group_g,  $transaction_data );
            // return('group G');
        }
        elseif ( str_contains($transaction_data->transaction_location_id, $main_warehouse_location_id) )
        {
            array_push($group_h,  $transaction_data );
            // return('group H');
        }
        elseif ( str_contains($transaction_data->transaction_location_id, $general_warehouse_location_id) )
        {
            array_push($group_i,  $transaction_data );
            // return($group_i);
            // return($transaction_data);
            // return('group I');
        }
        
    }
        
            // return($group_a);
        $group_a_grouped_by_transaction_date = collect($group_a)->groupBy('transaction_date');
        $group_b_grouped_by_transaction_date = collect($group_b)->groupBy('transaction_date');
        $group_c_grouped_by_transaction_date = collect($group_c)->groupBy('transaction_date');
        $group_d_grouped_by_transaction_date = collect($group_d)->groupBy('transaction_date');
        $group_e_grouped_by_transaction_date = collect($group_e)->groupBy('transaction_date');
        $group_f_grouped_by_transaction_date = collect($group_f)->groupBy('transaction_date');
        $group_g_grouped_by_transaction_date = collect($group_g)->groupBy('transaction_date');
        $group_h_grouped_by_transaction_date = collect($group_h)->groupBy('transaction_date');
        $group_i_grouped_by_transaction_date = collect($group_i)->groupBy('transaction_date');
        
        array_push($finance_calculations, (object)[
            'group_a' => $group_a_grouped_by_transaction_date,
            'group_b' => $group_b_grouped_by_transaction_date,
            'group_c' => $group_c_grouped_by_transaction_date,
            'group_d' => $group_d_grouped_by_transaction_date,
            'group_e' => $group_e_grouped_by_transaction_date,
            'group_f' => $group_f_grouped_by_transaction_date,
            'group_g' => $group_g_grouped_by_transaction_date,
            'group_h' => $group_h_grouped_by_transaction_date,
            'group_i' => $group_i_grouped_by_transaction_date,
        ]);
        
            return($finance_calculations);
            // return($group_a_grouped_by_transaction_date);

            
            foreach($group_a_grouped_by_transaction_date as $group_a_one_transaction_date)
            {
                $food_categories_value = 0 ;
                $beverage_categories_value = 0 ;
                $broken_categories_value = 0 ;
                $shisha_categories_value = 0 ;
                $other_categories_value = 0 ;
                $market_categories_value = 0 ;
                $activities_categories_value = 0 ;
                $security_categories_value = 0 ;
                $laundry_categories_value = 0 ;
                $hairdresser_categories_value = 0 ;
                $animals_categories_value = 0 ;
                $transaction_total_before_tax = 0 ;
                $service_15_tax_amount = 0 ;
                $service_25_tax_amount = 0 ;
                $transaction_inline_discount_amount = 0 ;
                $transaction_discount_amount = 0 ;
                $transaction_final_total = 0 ;
                $hotel_cash_payment = 0 ;
                $hotel_card_payment = 0 ;
                $hotel_other_payment = 0 ;
                $hotel_due_amount = 0 ;
                $cash_payment = 0 ;
                $card_payment = 0 ;
                $other_payment = 0 ;
                $due_amount = 0 ;
                    // return($food_categories_id);
                foreach($group_a_one_transaction_date as $a)
                {
                    // return($a->transaction_tax_id);
                    $transaction_total_before_tax += $a->transaction_total_before_tax;
                    if($a->transaction_tax_id = $service_15_tax_id)
                        $service_15_tax_amount += $a->transaction_tax_amount ;
                    elseif($a->transaction_tax_id = $service_25_tax_id)
                        $service_25_tax_amount += $a->transaction_tax_amount ;
                    $transaction_discount_amount += $a->transaction_discount_amount ;
                    $transaction_final_total += $a->transaction_final_total ;
                    
                    foreach($a->sell_lines as $a->sell_line)
                    {

                        $product_category_id = $a->sell_line->product_category_id ;
                        $product_sub_category_id = $a->sell_line->product_sub_category_id ;
                        // return($a->sell_line->product_category_id);
                        if( (in_array($product_sub_category_id, explode(',', $beverage_categories_id))) || (in_array($product_category_id, explode(',', $beverage_categories_id))) )
                        {
                            $beverage_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                            // return($beverage_categories_value);
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $food_categories_id))) || (in_array($product_category_id, explode(',', $food_categories_id))) )
                        {
                            $food_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $broken_categories_id))) || (in_array($product_category_id, explode(',', $broken_categories_id))) )
                        {
                            $broken_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $shisha_categories_id))) || (in_array($product_category_id, explode(',', $shisha_categories_id))) )
                        {
                            $shisha_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                        }
                        // elseif( (in_array($product_sub_category_id, explode(',', $other_categories_id))) || (in_array($product_category_id, explode(',', $other_categories_id))) )
                        elseif( (in_array($product_sub_category_id, explode(',', $other_categories_id))) || (in_array($product_category_id, explode(',', $other_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $food_categories_id))) || (!in_array($product_category_id, explode(',', $food_categories_id)))
                             || (!in_array($product_sub_category_id, explode(',', $beverage_categories_id))) || (!in_array($product_category_id, explode(',', $beverage_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $broken_categories_id))) || (!in_array($product_category_id, explode(',', $broken_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $shisha_categories_id))) || (!in_array($product_category_id, explode(',', $shisha_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $market_categories_id))) || (!in_array($product_category_id, explode(',', $market_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $activities_categories_id))) || (!in_array($product_category_id, explode(',', $activities_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $security_categories_id))) || (!in_array($product_category_id, explode(',', $security_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $laundry_categories_id))) || (!in_array($product_category_id, explode(',', $laundry_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $hairdresser_categories_id))) || (!in_array($product_category_id, explode(',', $hairdresser_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $animals_categories_id))) || (!in_array($product_category_id, explode(',', $animals_categories_id))) 
                             )
                        {
                            $other_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $market_categories_id))) || (in_array($product_category_id, explode(',', $market_categories_id))) )
                        {
                            $market_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $activities_categories_id))) || (in_array($product_category_id, explode(',', $activities_categories_id))) )
                        {
                            $activities_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $security_categories_id))) || (in_array($product_category_id, explode(',', $security_categories_id))) )
                        {
                            $security_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $laundry_categories_id))) || (in_array($product_category_id, explode(',', $laundry_categories_id))) )
                        {
                            $laundry_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $hairdresser_categories_id))) || (in_array($product_category_id, explode(',', $hairdresser_categories_id))) )
                        {
                            $hairdresser_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $animals_categories_id))) || (in_array($product_category_id, explode(',', $animals_categories_id))) )
                        {
                            $animals_categories_value += ( $a->sell_line->sell_line_unit_price_before_discount - $a->sell_line->sell_line_discount_amount ) * ($a->sell_line->sell_line_sold_qty)  ;
                        }
                        if($a->sell_line->sell_line_tax_id = $service_15_tax_id)
                            $service_15_tax_amount += $a->sell_line->sell_line_item_tax * $a->sell_line->sell_line_sold_qty ;
                        if($a->sell_line->sell_line_tax_id = $service_25_tax_id)
                            $service_25_tax_amount += $a->sell_line->sell_line_item_tax * $a->sell_line->sell_line_sold_qty ;
                        $transaction_inline_discount_amount += $a->sell_line->sell_line_discount_amount * $a->sell_line->sell_line_sold_qty ;
                        $sell_line_unit_price_before_discount += $a->sell_line->sell_line_unit_price_before_discount * $a->sell_line->sell_line_sold_qty ;
                    }
                    // return($a->transaction_final_total);
                        if($a->transaction_customer_group_id == $hotel_room_customer_group_id )
                        {
                            // $hotel_due_amount = 0;
                            foreach($a->payment_lines as $a->payment_line)
                            {
                                if($a->payment_line->method == "cash")
                                {
                                    $hotel_cash_payment += $a->payment_line->amount ;
                                    // return($cash_payment);
                                }
                                elseif($a->payment_line->method == "card")
                                {
                                    $hotel_card_payment += $a->payment_line->amount ;
                                }
                                else
                                {
                                    $hotel_other_payment += $a->payment_line->amount ;
                                }
                            }
                                $hotel_due_amount = $transaction_final_total - ($hotel_cash_payment + $hotel_card_payment + $hotel_other_payment);
                        }
                        else
                        {
                            foreach($a->payment_lines as $a->payment_line)
                            {
                                if($a->payment_line->method == "cash")
                                {
                                    $cash_payment += $a->payment_line->amount ;
                                }
                                elseif($a->payment_line->method == "card")
                                {
                                    $card_payment += $a->payment_line->amount ;
                                }
                                else
                                {
                                    $other_payment += $a->payment_line->amount ;
                                }
                                
                            }
                            $due_amount = $transaction_final_total - ($cash_payment + $card_payment + $other_payment);
                        }
                }
                // return($transaction_total_before_tax);
                // return($group_a_one_transaction_date[0]->transaction_date);
                array_push($group_a_final_calculations, (object)[
                    'transaction_date' => $group_a_one_transaction_date[0]->transaction_date,
                    'food_categories_value' => (string)$food_categories_value,
                    'beverage_categories_value' => (string)$beverage_categories_value,
                    'broken_categories_value' => (string)$broken_categories_value,
                    'shisha_categories_value' => (string)$shisha_categories_value,
                    'other_categories_value' => (string)$other_categories_value,
                    'market_categories_value' => (string)$market_categories_value,
                    'activities_categories_value' => (string)$activities_categories_value,
                    'security_categories_value' => (string)$security_categories_value,
                    'laundry_categories_value' => (string)$laundry_categories_value,
                    'hairdresser_categories_value' => (string)$hairdresser_categories_value,
                    'animals_categories_value' => (string)$animals_categories_value,
                    'transaction_total_before_tax' => (string)$transaction_total_before_tax,
                    'service_15_tax_amount' => (string)$service_15_tax_amount,
                    'service_25_tax_amount' => (string)$service_25_tax_amount,
                    'transaction_inline_discount_amount' => (string)$transaction_inline_discount_amount,
                    'transaction_discount_amount' => (string)$transaction_discount_amount,
                    'transaction_final_total' => (string)$transaction_final_total,
                    'hotel_payments' => [
                        'hotel_cash_payment' => (string)$hotel_cash_payment,
                        'hotel_card_payment' => (string)$hotel_card_payment,
                        'hotel_other_payment' => (string)$hotel_other_payment,
                        'hotel_due_amount' => (string)$hotel_due_amount,
                        ],
                    'other_payments' => [
                        'cash_payment' => number_format($cash_payment , 2),
                        'card_payment' => (string)$card_payment,
                        'other_payment' => (string)$other_payment,
                        'due_amount' => (string)$due_amount,
                        ],
                ]);
            }
            // return($group_a_final_calculations);

            
            foreach($group_b_grouped_by_transaction_date as $group_b_one_transaction_date)
            {
                $food_categories_value = 0 ;
                $beverage_categories_value = 0 ;
                $broken_categories_value = 0 ;
                $shisha_categories_value = 0 ;
                $other_categories_value = 0 ;
                $market_categories_value = 0 ;
                $activities_categories_value = 0 ;
                $security_categories_value = 0 ;
                $laundry_categories_value = 0 ;
                $hairdresser_categories_value = 0 ;
                $animals_categories_value = 0 ;
                $transaction_total_before_tax = 0 ;
                $service_15_tax_amount = 0 ;
                $service_25_tax_amount = 0 ;
                $transaction_inline_discount_amount = 0 ;
                $transaction_discount_amount = 0 ;
                $transaction_final_total = 0 ;
                $hotel_cash_payment = 0 ;
                $hotel_card_payment = 0 ;
                $hotel_other_payment = 0 ;
                $hotel_due_amount = 0 ;
                $cash_payment = 0 ;
                $card_payment = 0 ;
                $other_payment = 0 ;
                $due_amount = 0 ;
                
                foreach($group_b_one_transaction_date as $b)
                {
                    $transaction_total_before_tax += $b->transaction_total_before_tax;
                    if($b->transaction_tax_id = $service_15_tax_id)
                        $service_15_tax_amount += $b->transaction_tax_amount ;
                    elseif($b->transaction_tax_id = $service_25_tax_id)
                        $service_25_tax_amount += $b->transaction_tax_amount ;
                    $transaction_discount_amount += $b->transaction_discount_amount ;
                    $transaction_final_total += $b->transaction_final_total ;
                    
                    foreach($b->sell_lines as $b->sell_line)
                    {

                        $product_category_id = $b->sell_line->product_category_id ;
                        $product_sub_category_id = $b->sell_line->product_sub_category_id ;
                        if( (in_array($product_sub_category_id, explode(',', $beverage_categories_id))) || (in_array($product_category_id, explode(',', $beverage_categories_id))) )
                        {
                            $beverage_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $food_categories_id))) || (in_array($product_category_id, explode(',', $food_categories_id))) )
                        {
                            $food_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $broken_categories_id))) || (in_array($product_category_id, explode(',', $broken_categories_id))) )
                        {
                            $broken_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $shisha_categories_id))) || (in_array($product_category_id, explode(',', $shisha_categories_id))) )
                        {
                            $shisha_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $other_categories_id))) || (in_array($product_category_id, explode(',', $other_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $food_categories_id))) || (!in_array($product_category_id, explode(',', $food_categories_id)))
                             || (!in_array($product_sub_category_id, explode(',', $beverage_categories_id))) || (!in_array($product_category_id, explode(',', $beverage_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $broken_categories_id))) || (!in_array($product_category_id, explode(',', $broken_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $shisha_categories_id))) || (!in_array($product_category_id, explode(',', $shisha_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $market_categories_id))) || (!in_array($product_category_id, explode(',', $market_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $activities_categories_id))) || (!in_array($product_category_id, explode(',', $activities_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $security_categories_id))) || (!in_array($product_category_id, explode(',', $security_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $laundry_categories_id))) || (!in_array($product_category_id, explode(',', $laundry_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $hairdresser_categories_id))) || (!in_array($product_category_id, explode(',', $hairdresser_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $animals_categories_id))) || (!in_array($product_category_id, explode(',', $animals_categories_id))) 
                             )
                        {
                            $other_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $market_categories_id))) || (in_array($product_category_id, explode(',', $market_categories_id))) )
                        {
                            $market_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $activities_categories_id))) || (in_array($product_category_id, explode(',', $activities_categories_id))) )
                        {
                            $activities_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $security_categories_id))) || (in_array($product_category_id, explode(',', $security_categories_id))) )
                        {
                            $security_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $laundry_categories_id))) || (in_array($product_category_id, explode(',', $laundry_categories_id))) )
                        {
                            $laundry_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $hairdresser_categories_id))) || (in_array($product_category_id, explode(',', $hairdresser_categories_id))) )
                        {
                            $hairdresser_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $animals_categories_id))) || (in_array($product_category_id, explode(',', $animals_categories_id))) )
                        {
                            $animals_categories_value += ( $b->sell_line->sell_line_unit_price_before_discount - $b->sell_line->sell_line_discount_amount ) * ($b->sell_line->sell_line_sold_qty)  ;
                        }
                        if($b->sell_line->sell_line_tax_id = $service_15_tax_id)
                            $service_15_tax_amount += $b->sell_line->sell_line_item_tax * $b->sell_line->sell_line_sold_qty ;
                        if($b->sell_line->sell_line_tax_id = $service_25_tax_id)
                            $service_25_tax_amount += $b->sell_line->sell_line_item_tax * $b->sell_line->sell_line_sold_qty ;
                        $transaction_inline_discount_amount += $b->sell_line->sell_line_discount_amount * $b->sell_line->sell_line_sold_qty ;
                        $sell_line_unit_price_before_discount += $b->sell_line->sell_line_unit_price_before_discount * $b->sell_line->sell_line_sold_qty ;
                    }
                    
                    foreach($b->payment_lines as $b->payment_line)
                    {
                        if($b->payment_line->method == "cash")
                        {
                            $cash_payment += $b->payment_line->amount ;
                        }
                        elseif($b->payment_line->method == "card")
                        {
                            $card_payment += $b->payment_line->amount ;
                        }
                        else
                        {
                            $other_payment += $b->payment_line->amount ;
                        }
                        
                    }
                    $due_amount = $transaction_final_total - ($cash_payment + $card_payment + $other_payment);
                }
                // return($transaction_total_before_tax);
                // return($group_b_one_transaction_date[0]->transaction_date);
                array_push($group_b_final_calculations, (object)[
                    'transaction_date' => $group_b_one_transaction_date[0]->transaction_date,
                    'food_categories_value' => (string)$food_categories_value,
                    'beverage_categories_value' => (string)$beverage_categories_value,
                    'broken_categories_value' => (string)$broken_categories_value,
                    'shisha_categories_value' => (string)$shisha_categories_value,
                    'other_categories_value' => (string)$other_categories_value,
                    'market_categories_value' => (string)$market_categories_value,
                    'activities_categories_value' => (string)$activities_categories_value,
                    'security_categories_value' => (string)$security_categories_value,
                    'laundry_categories_value' => (string)$laundry_categories_value,
                    'hairdresser_categories_value' => (string)$hairdresser_categories_value,
                    'animals_categories_value' => (string)$animals_categories_value,
                    'transaction_total_before_tax' => (string)$transaction_total_before_tax,
                    'service_15_tax_amount' => (string)$service_15_tax_amount,
                    'service_25_tax_amount' => (string)$service_25_tax_amount,
                    'transaction_inline_discount_amount' => (string)$transaction_inline_discount_amount,
                    'transaction_discount_amount' => (string)$transaction_discount_amount,
                    'transaction_final_total' => (string)$transaction_final_total,
                    'other_payments' => [
                        'cash_payment' => number_format($cash_payment , 2),
                        'card_payment' => (string)$card_payment,
                        'other_payment' => (string)$other_payment,
                        'due_amount' => (string)$due_amount,
                        ],
                ]);
            }
            // return($group_b_final_calculations);

            
            foreach($group_c_grouped_by_transaction_date as $group_c_one_transaction_date)
            {
                $food_categories_value = 0 ;
                $beverage_categories_value = 0 ;
                $broken_categories_value = 0 ;
                $shisha_categories_value = 0 ;
                $other_categories_value = 0 ;
                $market_categories_value = 0 ;
                $activities_categories_value = 0 ;
                $security_categories_value = 0 ;
                $laundry_categories_value = 0 ;
                $hairdresser_categories_value = 0 ;
                $animals_categories_value = 0 ;
                $transaction_total_before_tax = 0 ;
                $service_15_tax_amount = 0 ;
                $service_25_tax_amount = 0 ;
                $transaction_inline_discount_amount = 0 ;
                $transaction_discount_amount = 0 ;
                $transaction_final_total = 0 ;
                $hotel_cash_payment = 0 ;
                $hotel_card_payment = 0 ;
                $hotel_other_payment = 0 ;
                $hotel_due_amount = 0 ;
                $cash_payment = 0 ;
                $card_payment = 0 ;
                $other_payment = 0 ;
                $due_amount = 0 ;
                
                foreach($group_c_one_transaction_date as $c)
                {
                    $transaction_total_before_tax += $c->transaction_total_before_tax;
                    if($c->transaction_tax_id = $service_15_tax_id)
                        $service_15_tax_amount += $c->transaction_tax_amount ;
                    elseif($c->transaction_tax_id = $service_25_tax_id)
                        $service_25_tax_amount += $c->transaction_tax_amount ;
                    $transaction_discount_amount += $c->transaction_discount_amount ;
                    $transaction_final_total += $c->transaction_final_total ;
                    
                    foreach($c->sell_lines as $c->sell_line)
                    {

                        $product_category_id = $c->sell_line->product_category_id ;
                        $product_sub_category_id = $c->sell_line->product_sub_category_id ;
                        if( (in_array($product_sub_category_id, explode(',', $beverage_categories_id))) || (in_array($product_category_id, explode(',', $beverage_categories_id))) )
                        {
                            $beverage_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $food_categories_id))) || (in_array($product_category_id, explode(',', $food_categories_id))) )
                        {
                            $food_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $broken_categories_id))) || (in_array($product_category_id, explode(',', $broken_categories_id))) )
                        {
                            $broken_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $shisha_categories_id))) || (in_array($product_category_id, explode(',', $shisha_categories_id))) )
                        {
                            $shisha_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $other_categories_id))) || (in_array($product_category_id, explode(',', $other_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $food_categories_id))) || (!in_array($product_category_id, explode(',', $food_categories_id)))
                             || (!in_array($product_sub_category_id, explode(',', $beverage_categories_id))) || (!in_array($product_category_id, explode(',', $beverage_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $broken_categories_id))) || (!in_array($product_category_id, explode(',', $broken_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $shisha_categories_id))) || (!in_array($product_category_id, explode(',', $shisha_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $market_categories_id))) || (!in_array($product_category_id, explode(',', $market_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $activities_categories_id))) || (!in_array($product_category_id, explode(',', $activities_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $security_categories_id))) || (!in_array($product_category_id, explode(',', $security_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $laundry_categories_id))) || (!in_array($product_category_id, explode(',', $laundry_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $hairdresser_categories_id))) || (!in_array($product_category_id, explode(',', $hairdresser_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $animals_categories_id))) || (!in_array($product_category_id, explode(',', $animals_categories_id))) 
                             )
                        {
                            $other_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $market_categories_id))) || (in_array($product_category_id, explode(',', $market_categories_id))) )
                        {
                            $market_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $activities_categories_id))) || (in_array($product_category_id, explode(',', $activities_categories_id))) )
                        {
                            $activities_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $security_categories_id))) || (in_array($product_category_id, explode(',', $security_categories_id))) )
                        {
                            $security_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $laundry_categories_id))) || (in_array($product_category_id, explode(',', $laundry_categories_id))) )
                        {
                            $laundry_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $hairdresser_categories_id))) || (in_array($product_category_id, explode(',', $hairdresser_categories_id))) )
                        {
                            $hairdresser_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $animals_categories_id))) || (in_array($product_category_id, explode(',', $animals_categories_id))) )
                        {
                            $animals_categories_value += ( $c->sell_line->sell_line_unit_price_before_discount - $c->sell_line->sell_line_discount_amount ) * ($c->sell_line->sell_line_sold_qty)  ;
                        }
                        if($c->sell_line->sell_line_tax_id = $service_15_tax_id)
                            $service_15_tax_amount += $c->sell_line->sell_line_item_tax * $c->sell_line->sell_line_sold_qty ;
                        if($c->sell_line->sell_line_tax_id = $service_25_tax_id)
                            $service_25_tax_amount += $c->sell_line->sell_line_item_tax * $c->sell_line->sell_line_sold_qty ;
                        $transaction_inline_discount_amount += $c->sell_line->sell_line_discount_amount * $c->sell_line->sell_line_sold_qty ;
                        $sell_line_unit_price_before_discount += $c->sell_line->sell_line_unit_price_before_discount * $c->sell_line->sell_line_sold_qty ;
                    }
                    
                    foreach($c->payment_lines as $c->payment_line)
                    {
                        if($c->payment_line->method == "cash")
                        {
                            $cash_payment += $c->payment_line->amount ;
                        }
                        elseif($c->payment_line->method == "card")
                        {
                            $card_payment += $c->payment_line->amount ;
                        }
                        else
                        {
                            $other_payment += $c->payment_line->amount ;
                        }
                        
                    }
                    $due_amount = $transaction_final_total - ($cash_payment + $card_payment + $other_payment);
                }

                array_push($group_c_final_calculations, (object)[
                    'transaction_date' => $group_c_one_transaction_date[0]->transaction_date,
                    'food_categories_value' => (string)$food_categories_value,
                    'beverage_categories_value' => (string)$beverage_categories_value,
                    'broken_categories_value' => (string)$broken_categories_value,
                    'shisha_categories_value' => (string)$shisha_categories_value,
                    'other_categories_value' => (string)$other_categories_value,
                    'market_categories_value' => (string)$market_categories_value,
                    'activities_categories_value' => (string)$activities_categories_value,
                    'security_categories_value' => (string)$security_categories_value,
                    'laundry_categories_value' => (string)$laundry_categories_value,
                    'hairdresser_categories_value' => (string)$hairdresser_categories_value,
                    'animals_categories_value' => (string)$animals_categories_value,
                    'transaction_total_before_tax' => (string)$transaction_total_before_tax,
                    'service_15_tax_amount' => (string)$service_15_tax_amount,
                    'service_25_tax_amount' => (string)$service_25_tax_amount,
                    'transaction_inline_discount_amount' => (string)$transaction_inline_discount_amount,
                    'transaction_discount_amount' => (string)$transaction_discount_amount,
                    'transaction_final_total' => (string)$transaction_final_total,
                    'other_payments' => [
                        'cash_payment' => number_format($cash_payment , 2),
                        'card_payment' => (string)$card_payment,
                        'other_payment' => (string)$other_payment,
                        'due_amount' => (string)$due_amount,
                        ],
                ]);
            }
            // return($group_c_final_calculations);

            // return($group_d_grouped_by_transaction_date);
            foreach($group_d_grouped_by_transaction_date as $group_d_one_transaction_date)
            {
                $food_categories_value = 0 ;
                $beverage_categories_value = 0 ;
                $broken_categories_value = 0 ;
                $shisha_categories_value = 0 ;
                $other_categories_value = 0 ;
                $market_categories_value = 0 ;
                $activities_categories_value = 0 ;
                $security_categories_value = 0 ;
                $laundry_categories_value = 0 ;
                $hairdresser_categories_value = 0 ;
                $animals_categories_value = 0 ;
                $transaction_total_before_tax = 0 ;
                $service_15_tax_amount = 0 ;
                $service_25_tax_amount = 0 ;
                $transaction_inline_discount_amount = 0 ;
                $transaction_discount_amount = 0 ;
                $transaction_final_total = 0 ;
                $general_hospitality_transaction_final_total = 0 ;
                $hospitality_transaction_final_total = 0 ;
                $hotel_hospitality_transaction_final_total = 0 ;
                $banquet_hospitality_transaction_final_total = 0 ;
                $general_hospitality_cash_payment = 0 ;
                $general_hospitality_card_payment = 0 ;
                $general_hospitality_other_payment = 0 ;
                $general_hospitality = 0 ;
                $hospitality_cash_payment = 0 ;
                $hospitality_card_payment = 0 ;
                $hospitality_other_payment = 0 ;
                $hospitality = 0 ;
                $hotel_hospitality_cash_payment = 0 ;
                $hotel_hospitality_card_payment = 0 ;
                $hotel_hospitality_other_payment = 0 ;
                $hotel_hospitality = 0 ;
                $banquet_hospitality_cash_payment = 0 ;
                $banquet_hospitality_card_payment = 0 ;
                $banquet_hospitality_other_payment = 0 ;
                $banquet_hospitality = 0 ;
                
                // return($group_d_one_transaction_date);
                foreach($group_d_one_transaction_date as $d)
                {
                    $transaction_total_before_tax += $d->transaction_total_before_tax;
                    if($d->transaction_tax_id = $service_15_tax_id)
                        $service_15_tax_amount += $d->transaction_tax_amount ;
                    elseif($d->transaction_tax_id = $service_25_tax_id)
                        $service_25_tax_amount += $d->transaction_tax_amount ;
                    $transaction_discount_amount += $d->transaction_discount_amount ;
                    $transaction_final_total += $d->transaction_final_total ;

                    foreach($d->sell_lines as $d->sell_line)
                    {

                        $product_category_id = $d->sell_line->product_category_id ;
                        $product_sub_category_id = $d->sell_line->product_sub_category_id ;
                        if( (in_array($product_sub_category_id, explode(',', $beverage_categories_id))) || (in_array($product_category_id, explode(',', $beverage_categories_id))) )
                        {
                            $beverage_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $food_categories_id))) || (in_array($product_category_id, explode(',', $food_categories_id))) )
                        {
                            $food_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $broken_categories_id))) || (in_array($product_category_id, explode(',', $broken_categories_id))) )
                        {
                            $broken_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $shisha_categories_id))) || (in_array($product_category_id, explode(',', $shisha_categories_id))) )
                        {
                            $shisha_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $other_categories_id))) || (in_array($product_category_id, explode(',', $other_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $food_categories_id))) || (!in_array($product_category_id, explode(',', $food_categories_id)))
                             || (!in_array($product_sub_category_id, explode(',', $beverage_categories_id))) || (!in_array($product_category_id, explode(',', $beverage_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $broken_categories_id))) || (!in_array($product_category_id, explode(',', $broken_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $shisha_categories_id))) || (!in_array($product_category_id, explode(',', $shisha_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $market_categories_id))) || (!in_array($product_category_id, explode(',', $market_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $activities_categories_id))) || (!in_array($product_category_id, explode(',', $activities_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $security_categories_id))) || (!in_array($product_category_id, explode(',', $security_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $laundry_categories_id))) || (!in_array($product_category_id, explode(',', $laundry_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $hairdresser_categories_id))) || (!in_array($product_category_id, explode(',', $hairdresser_categories_id))) 
                             || (!in_array($product_sub_category_id, explode(',', $animals_categories_id))) || (!in_array($product_category_id, explode(',', $animals_categories_id))) 
                             )
                        {
                            $other_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $market_categories_id))) || (in_array($product_category_id, explode(',', $market_categories_id))) )
                        {
                            $market_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $activities_categories_id))) || (in_array($product_category_id, explode(',', $activities_categories_id))) )
                        {
                            $activities_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $security_categories_id))) || (in_array($product_category_id, explode(',', $security_categories_id))) )
                        {
                            $security_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $laundry_categories_id))) || (in_array($product_category_id, explode(',', $laundry_categories_id))) )
                        {
                            $laundry_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $hairdresser_categories_id))) || (in_array($product_category_id, explode(',', $hairdresser_categories_id))) )
                        {
                            $hairdresser_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                        }
                        elseif( (in_array($product_sub_category_id, explode(',', $animals_categories_id))) || (in_array($product_category_id, explode(',', $animals_categories_id))) )
                        {
                            $animals_categories_value += ( $d->sell_line->sell_line_unit_price_before_discount - $d->sell_line->sell_line_discount_amount ) * ($d->sell_line->sell_line_sold_qty)  ;
                        }
                        if($d->sell_line->sell_line_tax_id = $service_15_tax_id)
                            $service_15_tax_amount += $d->sell_line->sell_line_item_tax * $d->sell_line->sell_line_sold_qty ;
                        if($d->sell_line->sell_line_tax_id = $service_25_tax_id)
                            $service_25_tax_amount += $d->sell_line->sell_line_item_tax * $d->sell_line->sell_line_sold_qty ;
                        $transaction_inline_discount_amount += $d->sell_line->sell_line_discount_amount * $d->sell_line->sell_line_sold_qty ;
                        $sell_line_unit_price_before_discount += $d->sell_line->sell_line_unit_price_before_discount * $d->sell_line->sell_line_sold_qty ;
                    }
                    
                    if($d->transaction_customer_group_id == $general_hospitality_customer_group_id )
                        {
                            // return('1');
                            $general_hospitality_transaction_final_total += $d->transaction_final_total ;
                            foreach($d->payment_lines as $d->payment_line)
                            {
                                if($d->payment_line->method == "cash")
                                {
                                    $general_hospitality_cash_payment += $d->payment_line->amount ;
                                }
                                elseif($d->payment_line->method == "card")
                                {
                                    $general_hospitality_card_payment += $d->payment_line->amount ;
                                }
                                else
                                {
                                    $general_hospitality_other_payment += $d->payment_line->amount ;
                                }
                            }
                            $general_hospitality = $general_hospitality_transaction_final_total - ($general_hospitality_cash_payment + $general_hospitality_card_payment + $general_hospitality_other_payment);
                            // $general_hospitality += $general_hospitality_transaction_final_total - ($general_hospitality_cash_payment + $general_hospitality_card_payment + $general_hospitality_other_payment);
                        }
                    elseif($d->transaction_customer_group_id == $hospitality_customer_group_id )
                        {
                            // return('11');
                            $hospitality_transaction_final_total += $d->transaction_final_total ;
                            foreach($d->payment_lines as $d->payment_line)
                            {
                                if($d->payment_line->method == "cash")
                                {
                                    $hospitality_cash_payment += $d->payment_line->amount ;
                                }
                                elseif($d->payment_line->method == "card")
                                {
                                    $hospitality_card_payment += $d->payment_line->amount ;
                                }
                                else
                                {
                                    $hospitality_other_payment += $d->payment_line->amount ;
                                }
                            }
                            $hospitality = $hospitality_transaction_final_total - ($hospitality_cash_payment + $hospitality_card_payment + $hospitality_other_payment);
                            // $hospitality += $hospitality_transaction_final_total - ($hospitality_cash_payment + $hospitality_card_payment + $hospitality_other_payment);
                        }
                    elseif($d->transaction_customer_group_id == $hotel_hospitality_customer_group_id )
                        {
                            // return($hotel_hospitality_transaction_final_total);
                            $hotel_hospitality_transaction_final_total += $d->transaction_final_total ;
                            foreach($d->payment_lines as $d->payment_line)
                            {
                                if($d->payment_line->method == "cash")
                                {
                                    $hotel_hospitality_cash_payment += $d->payment_line->amount ;
                                }
                                elseif($d->payment_line->method == "card")
                                {
                                    $hotel_hospitality_card_payment += $d->payment_line->amount ;
                                }
                                else
                                {
                                    $hotel_hospitality_other_payment += $d->payment_line->amount ;
                                }
                            }
                            $hotel_hospitality = $hotel_hospitality_transaction_final_total - ($hotel_hospitality_cash_payment + $hotel_hospitality_card_payment + $hotel_hospitality_other_payment);
                            // $hotel_hospitality += $hotel_hospitality_transaction_final_total - ($hotel_hospitality_cash_payment + $hotel_hospitality_card_payment + $hotel_hospitality_other_payment);
                        }
                    elseif($d->transaction_customer_group_id == $banquet_hospitality_customer_group_id )
                        {
                            // return('1111');
                            $banquet_hospitality_transaction_final_total += $d->transaction_final_total ;
                            foreach($d->payment_lines as $d->payment_line)
                            {
                                if($d->payment_line->method == "cash")
                                {
                                    $banquet_hospitality_cash_payment += $d->payment_line->amount ;
                                }
                                elseif($d->payment_line->method == "card")
                                {
                                    $banquet_hospitality_card_payment += $d->payment_line->amount ;
                                }
                                else
                                {
                                    $banquet_hospitality_other_payment += $d->payment_line->amount ;
                                }
                            }
                            $banquet_hospitality = $banquet_hospitality_transaction_final_total - ($banquet_hospitality_cash_payment + $banquet_hospitality_card_payment + $banquet_hospitality_other_payment);
                            // $banquet_hospitality += $banquet_hospitality_transaction_final_total - ($banquet_hospitality_cash_payment + $banquet_hospitality_card_payment + $banquet_hospitality_other_payment);
                        }
                    
                    
                }

                array_push($group_d_final_calculations, (object)[
                    'transaction_date' => $group_d_one_transaction_date[0]->transaction_date,
                    'food_categories_value' => (string)$food_categories_value,
                    'beverage_categories_value' => (string)$beverage_categories_value,
                    'broken_categories_value' => (string)$broken_categories_value,
                    'shisha_categories_value' => (string)$shisha_categories_value,
                    'other_categories_value' => (string)$other_categories_value,
                    'market_categories_value' => (string)$market_categories_value,
                    'activities_categories_value' => (string)$activities_categories_value,
                    'security_categories_value' => (string)$security_categories_value,
                    'laundry_categories_value' => (string)$laundry_categories_value,
                    'hairdresser_categories_value' => (string)$hairdresser_categories_value,
                    'animals_categories_value' => (string)$animals_categories_value,
                    'transaction_total_before_tax' => (string)$transaction_total_before_tax,
                    'service_15_tax_amount' => (string)$service_15_tax_amount,
                    'service_25_tax_amount' => (string)$service_25_tax_amount,
                    'transaction_inline_discount_amount' => (string)$transaction_inline_discount_amount,
                    'transaction_discount_amount' => (string)$transaction_discount_amount,
                    'transaction_final_total' => (string)$transaction_final_total,
                    'other_payments' => [
                        'general_hospitality' => number_format($general_hospitality , 2),
                        'hospitality' => (string)$hospitality,
                        'hotel_hospitality' => (string)$hotel_hospitality,
                        'banquet_hospitality' => (string)$banquet_hospitality,
                        ],
                ]);
            }
            // return($group_d_final_calculations);
            
            array_push($final_finance_calculations, (object)[
            'group_a' => $group_a_final_calculations,
            'group_b' => $group_b_final_calculations,
            'group_c' => $group_c_final_calculations,
            'group_d' => $group_d_final_calculations,
            // 'group_e' => $group_e_grouped_by_transaction_date,
            // 'group_f' => $group_f_grouped_by_transaction_date,
            // 'group_g' => $group_g_grouped_by_transaction_date,
            // 'group_h' => $group_h_grouped_by_transaction_date,
            // 'group_i' => $group_i_grouped_by_transaction_date,
        ]);
            return($final_finance_calculations);

        // foreach($group_a as $a)
        // {
        //     // return($a->sell_lines->sell_line_discount_amount);
        //     $transaction_total_before_tax += $a->transaction_total_before_tax;
        //     if($a->transaction_tax_id = $service_15_tax_id)
        //         $service_15_tax_amount += $a->transaction_tax_amount ;
        //     if($a->transaction_tax_id = $service_25_tax_id)
        //         $service_25_tax_amount += $a->transaction_tax_amount ;
        //     $transaction_discount_amount += $a->transaction_discount_amount ;
        //     $transaction_final_total += $a->transaction_final_total ;
            
        //     foreach($a->sell_lines as $a->sell_line)
        //     {
        //         if($a->sell_line->sell_line_tax_id = $service_15_tax_id)
        //             $service_15_tax_amount += $a->sell_line->sell_line_item_tax * $a->sell_line->sell_line_sold_qty ;
        //         if($a->sell_line->sell_line_tax_id = $service_25_tax_id)
        //             $service_25_tax_amount += $a->sell_line->sell_line_item_tax * $a->sell_line->sell_line_sold_qty ;
        //         $transaction_discount_amount += $a->sell_line->sell_line_discount_amount * $a->sell_line->sell_line_sold_qty ;
        //         $sell_line_unit_price_before_discount += $a->sell_line->sell_line_unit_price_before_discount ;
        //     }
            
        //     foreach($a->payment_lines as $a->payment_line)
        //     {
        //         if($a->payment_line->method == "cash")
        //             $cash_payment += $a->payment_line->amount ;
        //         if($a->payment_line->method == "card")
        //             $card_payment += $a->payment_line->amount ;
                
        //     }
            
        // }
        // return($transaction_total_before_tax);
        $perPage = 10;
        $skip = 0;
        if(!empty($filters['per_page']))
        {
            if (($filters['per_page']) != -1)
            {
                $perPage = $filters['per_page'];
            }
            else
            {
                 $perPage = count($transactions_data);
            }
        }


        $sells = $this->paginate($transactions_data, $perPage);
        $sells->appends(Arr::except($filters, ['page']));

        $response = ((new PaginatedResourceResponse(CollectionResource::make($sells)))->toResponse(request()));
        $data = $response->getData();
        
      
        
        
        $response->setData($data);
        return $response;


    }


    /**
     * Create a new command instance.
     *
     * @return string
     */
    public function queryToSql($query)
    {
        return vsprintf(str_replace(array('?'), array('\'%s\''), $query->toSql()), $query->getBindings());
    }

    /**
     * The attributes that are mass assignable.
     *
     *
     * @param $items
     * @param int $perPage
     * @param null $page
     * @param array $options
     * @return LengthAwarePaginator
     */
    public function paginate($items, $perPage = 5, $page = null, $options = [])
    {
        $page = $page ?: (Paginator::resolveCurrentPage() ?: 1);
        $items = $items instanceof Collection ? $items : Collection::make($items);
        return new LengthAwarePaginator($items->forPage($page, $perPage), $items->count(), $perPage, $page, $options);
    }
}
