<?php
namespace Modules\ReportsModule\Http\Controllers;

use stdClass;
use App\User;
use App\Category;
use App\Product;
use Exception;
use Illuminate\Database\Query\JoinClause;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Resources\Json\PaginatedResourceResponse;
use Illuminate\Pagination\LengthAwarePaginator;
use Illuminate\Pagination\Paginator;
use Illuminate\Support\Arr;
use Illuminate\Support\Collection;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Modules\Connector\Http\Controllers\Api\ApiController;
use Modules\ReportsModule\Transformers\CollectionResource;
use Illuminate\Support\Str;


class Kitchen2RolesApiController extends ApiController
{
    /**
     * Display a listing of the resource.
     * @return JsonResponse
     * @throws Exception
     */

    public function index()
    {
        /** @var User $user */
        $user = Auth::user();
        $business_id = $user->business_id;
        
        $user_permission_roles_explode = explode('|', $user->custom_field_3); 
        $user_permission_roles = $user_permission_roles_explode[0];
        $user_permission_force_notification = $user_permission_roles_explode[1];

        if($user_permission_roles == ""){
            $user_permission_roles = "General";
        }

        
        
        $permitted_locations = $user->permitted_locations($business_id);
        $filters = request()->only([
            'user_id','role_access'
        ]);
        // Defines
        $kitchen_2_roles = 0;
        $kitchen_2_roles_categories = [];
        $kitchen_2_roles_sub_categories = [];
        $response = [];
        // End Defines
        
        $reports_module_setting = DB::table('reports_module')
        ->where('item', 'kitchen_2_roles')
        ->get();

        foreach ($reports_module_setting as $report_module_setting)
        {
            if($report_module_setting->item == "kitchen_2_roles")
                $kitchen_2_roles = json_decode($report_module_setting->value);
        }
 
        foreach($kitchen_2_roles as $kitchen_2_role)
        {
            if($kitchen_2_role->role  == $user_permission_roles)
            {
                array_push($kitchen_2_roles_categories , $kitchen_2_role->categories_id);
                array_push($kitchen_2_roles_sub_categories , $kitchen_2_role->sub_categories_id);
            }
        }
            // array_push($response->categories, $kitchen_2_roles_categories);
        // return($response);
        $response[categories] = $kitchen_2_roles_categories;
        $response[sub_categories] = $kitchen_2_roles_sub_categories;
        $response[force_notification] = $user_permission_force_notification;
        $response[department] = $user_permission_roles;
        
        return($response);


    }

}
