<?php
namespace Modules\ReportsModule\Http\Controllers;

use stdClass;
use App\User;
use App\Category;
use App\Product;
use Exception;
use Illuminate\Database\Query\JoinClause;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Resources\Json\PaginatedResourceResponse;
use Illuminate\Pagination\LengthAwarePaginator;
use Illuminate\Pagination\Paginator;
use Illuminate\Support\Arr;
use Illuminate\Support\Collection;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Modules\Connector\Http\Controllers\Api\ApiController;
use Modules\ReportsModule\Transformers\CollectionResource;
use Illuminate\Support\Str;


class PosContactsApiController extends ApiController
{
    /**
     * Display a listing of the resource.
     * @return JsonResponse
     * @throws Exception
     */

    public function index()
    {

        /** @var User $user */
        $user = Auth::user();
        $user_id = $user->id;
        $business_id = $user->business_id;
        
        $filters = request()->only([
            'location_type'
        ]);
        
        
        if (!empty($filters['location_type']) && $filters['location_type'] == 'G')
        {

            // $contacts = DB::table('user_contact_access as uca')
            // ->select(
            //             DB::raw('uca.contact_id AS contact_id'),
            //             DB::raw('c.name AS contact_name')
            //         )
            // ->leftjoin('contacts as c','c.id', '=', 'uca.contact_id')
            // ->where('c.custom_field1', '=' , 'G')
            // ->where('uca.user_id', $user_id)
            // ->get();
            $contacts = DB::table('contacts as c')
            ->select(
                        DB::raw('c.id AS contact_id'),
                        DB::raw('c.name AS contact_name')
                    )
            ->where('c.custom_field1', '=' , 'G')
            ->where('c.business_id', $business_id)
            ->get();
                
        }
        elseif (!empty($filters['location_type']) && $filters['location_type'] == 'M')
        {
            $contacts = DB::table('contacts as c')
            ->select(
                        DB::raw('c.id AS contact_id'),
                        DB::raw('c.name AS contact_name')
                    )
            ->where('c.custom_field1', '=' , 'M')
            ->where('c.business_id', $business_id)
            ->get();
        }
        else {
            
            $contacts = DB::table('contacts as c')
            ->select(
                        DB::raw('c.id AS contact_id'),
                        DB::raw('c.name AS contact_name')
                    )
            ->where('c.business_id', $business_id)
            ->get();
            
        }
                 
        
        
        return($contacts);
   
    }

}
